-- C:\RESEARCH\LIN_CONTROLLER
-- VHDL Test Bench created by
-- HDL Bencher 5.1i
-- Mon Jul 21 16:22:34 2003
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.all;
USE IEEE.STD_LOGIC_ARITH.all;
USE IEEE.STD_LOGIC_UNSIGNED.all;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT checksum_generator
		PORT (
			clk : in  STD_LOGIC;
			clr : in  STD_LOGIC;
			rst : in  STD_LOGIC;
			data : in  STD_LOGIC_VECTOR (7 DOWNTO 0);
			strb : in  STD_LOGIC;
			cksum : out  STD_LOGIC_VECTOR (7 DOWNTO 0)
		);
	END COMPONENT;

	SIGNAL clk : STD_LOGIC;
	SIGNAL clr : STD_LOGIC;
	SIGNAL rst : STD_LOGIC;
	SIGNAL data : STD_LOGIC_VECTOR (7 DOWNTO 0);
	SIGNAL strb : STD_LOGIC;
	SIGNAL cksum : STD_LOGIC_VECTOR (7 DOWNTO 0);

BEGIN
	UUT : checksum_generator
	PORT MAP (
		clk => clk,
		clr => clr,
		rst => rst,
		data => data,
		strb => strb,
		cksum => cksum
	);

	PROCESS -- clock process for clk,
	BEGIN
		CLOCK_LOOP : LOOP
		clk <= transport '0';
		WAIT FOR 10 ns;
		clk <= transport '1';
		WAIT FOR 10 ns;
		WAIT FOR 40 ns;
		clk <= transport '0';
		WAIT FOR 40 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

	PROCESS   -- Process for clk
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_cksum(
			next_cksum : STD_LOGIC_VECTOR (7 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (cksum /= next_cksum) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns cksum="));
				write(TX_LOC, cksum);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_cksum);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		clr <= transport '0';
		rst <= transport '1';
		data <= transport STD_LOGIC_VECTOR'("00000000"); --0
		strb <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=100 ns
		rst <= transport '0';
		data <= transport STD_LOGIC_VECTOR'("01001010"); --4A
		-- --------------------
		WAIT FOR 100 ns; -- Time=200 ns
		data <= transport STD_LOGIC_VECTOR'("01010101"); --55
		-- --------------------
		WAIT FOR 100 ns; -- Time=300 ns
		data <= transport STD_LOGIC_VECTOR'("10010011"); --93
		-- --------------------
		WAIT FOR 100 ns; -- Time=400 ns
		data <= transport STD_LOGIC_VECTOR'("11100101"); --E5
		-- --------------------
		WAIT FOR 100 ns; -- Time=500 ns
		data <= transport STD_LOGIC_VECTOR'("00000000"); --0
		-- --------------------
		WAIT FOR 100 ns; -- Time=600 ns
		strb <= transport '0';
		-- --------------------
		WAIT FOR 500 ns; -- Time=1100 ns
		strb <= transport '0';
		-- --------------------
		WAIT FOR 110 ns; -- Time=1210 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION checksum_generator_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END checksum_generator_cfg;
