library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

-- Uncomment the following lines to use the declarations that are
-- provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity divider is
  port
    (
      clk, rst   : in  std_logic;
      bitclk     : out std_logic;
      bitclk_x16 : out std_logic;
      clkdiv1    : in  std_logic_vector (3 downto 0);
      clkdiv2    : in  std_logic_vector (7 downto 0)
    );
end divider;

architecture Behavioral of divider is
  signal clkcounter     : std_logic_vector (11 downto 0);
  signal counter        : std_logic_vector (3 downto 0);
  signal bitclk_x16_tmp : std_logic;
begin
  divide: process (rst, clk)
  begin
    if (rst = '1') then
      clkcounter <= "000000000001";
      bitclk_x16_tmp <= '0';
    elsif (rising_edge(clk)) then
      clkcounter <= clkcounter + 1;
      if (clkcounter = clkdiv1 & clkdiv2) then
        clkcounter <= "000000000001";
        bitclk_x16_tmp <= '1';
      else
        bitclk_x16_tmp <= '0';
      end if;
    end if;
  end process divide;

  bitclk_x16 <= bitclk_x16_tmp;

  divide_by_16 : process (rst, bitclk_x16_tmp)
  begin
    if (rst = '1') then
      counter <= "0000";
    elsif (rising_edge(bitclk_x16_tmp)) then
      counter <= counter + 1;
    end if;
  end process divide_by_16;

  bitclk <= counter(3);

end Behavioral;
