-- Vhdl model created from schematic lin_controller.sch - Tue Jun 17 19:27:38 2003

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
-- synopsys translate_off
LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;
-- synopsys translate_on

ENTITY lin_controller IS
   PORT ( RxD	:	IN	STD_LOGIC; 
          Transmit	:	IN	STD_LOGIC_VECTOR (7 DOWNTO 0); 
          clk	:	IN	STD_LOGIC; 
          receive_mask	:	IN	STD_LOGIC_VECTOR (5 DOWNTO 0); 
          reset	:	IN	STD_LOGIC; 
          response_mask	:	IN	STD_LOGIC_VECTOR (5 DOWNTO 0); 
          Receive	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
          Statuses	:	OUT	STD_LOGIC_VECTOR (2 DOWNTO 0); 
          TxD	:	OUT	STD_LOGIC; 
          slave_state	:	OUT	STD_LOGIC_VECTOR (3 DOWNTO 0));

end lin_controller;

ARCHITECTURE SCHEMATIC OF lin_controller IS
   SIGNAL Receive_DUMMY	:	STD_LOGIC_VECTOR (7 DOWNTO 0);
   SIGNAL XLXN_13	:	STD_LOGIC;
   SIGNAL XLXN_21	:	STD_LOGIC;
   SIGNAL XLXN_22	:	STD_LOGIC;
   SIGNAL XLXN_23	:	STD_LOGIC_VECTOR (7 DOWNTO 0);
   SIGNAL XLXN_26	:	STD_LOGIC;
   SIGNAL XLXN_27	:	STD_LOGIC;
   SIGNAL XLXN_28	:	STD_LOGIC;
   SIGNAL XLXN_29	:	STD_LOGIC_VECTOR (5 DOWNTO 0);
   SIGNAL XLXN_30	:	STD_LOGIC_VECTOR (7 DOWNTO 0);
   SIGNAL XLXN_32	:	STD_LOGIC;
   SIGNAL XLXN_33	:	STD_LOGIC;
   SIGNAL XLXN_36	:	STD_LOGIC;
   SIGNAL XLXN_37	:	STD_LOGIC;
   SIGNAL XLXN_38	:	STD_LOGIC_VECTOR (7 DOWNTO 0);
   SIGNAL XLXN_43	:	STD_LOGIC;
   SIGNAL XLXN_44	:	STD_LOGIC;

   ATTRIBUTE BOX_TYPE : STRING;

   COMPONENT checksum_generator
      PORT ( clk	:	IN	STD_LOGIC; 
             clr	:	IN	STD_LOGIC; 
             rst	:	IN	STD_LOGIC; 
             en	:	IN	STD_LOGIC; 
             done	:	IN	STD_LOGIC; 
             cksum	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
             data	:	IN	STD_LOGIC_VECTOR (7 DOWNTO 0));
   END COMPONENT;

   COMPONENT CLK_DIV2
      PORT ( CLKIN	:	IN	STD_LOGIC; 
             CLKDV	:	OUT	STD_LOGIC);
   END COMPONENT;

   ATTRIBUTE BOX_TYPE OF CLK_DIV2 : COMPONENT IS "BLACK_BOX";
   COMPONENT core_state_machine
      PORT ( clk	:	IN	STD_LOGIC; 
             bitclk	:	IN	STD_LOGIC; 
             rst	:	IN	STD_LOGIC; 
             ser_in	:	IN	STD_LOGIC; 
             receiver_done	:	IN	STD_LOGIC; 
             transmitter_done	:	IN	STD_LOGIC; 
             pr1	:	IN	STD_LOGIC; 
             pr0	:	IN	STD_LOGIC; 
             transmit	:	IN	STD_LOGIC_VECTOR (7 DOWNTO 0); 
             receiver_sr	:	IN	STD_LOGIC_VECTOR (7 DOWNTO 0); 
             checksum	:	IN	STD_LOGIC_VECTOR (7 DOWNTO 0); 
             cfg_receive_mask	:	IN	STD_LOGIC_VECTOR (5 DOWNTO 0); 
             cfg_response_mask	:	IN	STD_LOGIC_VECTOR (5 DOWNTO 0); 
             ser_out	:	OUT	STD_LOGIC; 
             receiver_rst	:	OUT	STD_LOGIC; 
             transmitter_rst	:	OUT	STD_LOGIC; 
             transmitter_bypass	:	OUT	STD_LOGIC; 
             checksum_en	:	OUT	STD_LOGIC; 
             checksum_done	:	OUT	STD_LOGIC; 
             statuses	:	OUT	STD_LOGIC_VECTOR (2 DOWNTO 0); 
             receive	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
             transmitter_sr	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
             parity_check	:	OUT	STD_LOGIC_VECTOR (5 DOWNTO 0); 
             snoop_cur_state	:	OUT	STD_LOGIC_VECTOR (3 DOWNTO 0); 
             checksum_clr	:	OUT	STD_LOGIC);
   END COMPONENT;

   COMPONENT parity_generator
      PORT ( pr1	:	OUT	STD_LOGIC; 
             pr0	:	OUT	STD_LOGIC; 
             data	:	IN	STD_LOGIC_VECTOR (5 DOWNTO 0));
   END COMPONENT;

   COMPONENT receiver
      PORT ( clk	:	IN	STD_LOGIC; 
             rst	:	IN	STD_LOGIC; 
             ser_in	:	IN	STD_LOGIC; 
             done	:	OUT	STD_LOGIC; 
             par_out	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0));
   END COMPONENT;

   COMPONENT transmitter
      PORT ( clk	:	IN	STD_LOGIC; 
             rst	:	IN	STD_LOGIC; 
             ser_in	:	IN	STD_LOGIC; 
             bypass	:	IN	STD_LOGIC; 
             par_in	:	IN	STD_LOGIC_VECTOR (7 DOWNTO 0); 
             ser_out	:	OUT	STD_LOGIC; 
             done	:	OUT	STD_LOGIC);
   END COMPONENT;

BEGIN
   Receive <= Receive_DUMMY;

   XLXI_9 : checksum_generator
      PORT MAP (clk=>clk, clr=>XLXN_43, rst=>reset, en=>XLXN_32, done=>XLXN_33,
      cksum(7)=>XLXN_30(7), cksum(6)=>XLXN_30(6), cksum(5)=>XLXN_30(5),
      cksum(4)=>XLXN_30(4), cksum(3)=>XLXN_30(3), cksum(2)=>XLXN_30(2),
      cksum(1)=>XLXN_30(1), cksum(0)=>XLXN_30(0), data(7)=>Receive_DUMMY(7),
      data(6)=>Receive_DUMMY(6), data(5)=>Receive_DUMMY(5),
      data(4)=>Receive_DUMMY(4), data(3)=>Receive_DUMMY(3),
      data(2)=>Receive_DUMMY(2), data(1)=>Receive_DUMMY(1),
      data(0)=>Receive_DUMMY(0));

   XLXI_7 : CLK_DIV2
      PORT MAP (CLKIN=>clk, CLKDV=>XLXN_13);

   XLXI_5 : core_state_machine
      PORT MAP (clk=>clk, bitclk=>XLXN_13, rst=>reset, ser_in=>RxD,
      receiver_done=>XLXN_37, transmitter_done=>XLXN_26, pr1=>XLXN_27,
      pr0=>XLXN_28, transmit(7)=>Transmit(7), transmit(6)=>Transmit(6),
      transmit(5)=>Transmit(5), transmit(4)=>Transmit(4),
      transmit(3)=>Transmit(3), transmit(2)=>Transmit(2),
      transmit(1)=>Transmit(1), transmit(0)=>Transmit(0),
      receiver_sr(7)=>XLXN_38(7), receiver_sr(6)=>XLXN_38(6),
      receiver_sr(5)=>XLXN_38(5), receiver_sr(4)=>XLXN_38(4),
      receiver_sr(3)=>XLXN_38(3), receiver_sr(2)=>XLXN_38(2),
      receiver_sr(1)=>XLXN_38(1), receiver_sr(0)=>XLXN_38(0),
      checksum(7)=>XLXN_30(7), checksum(6)=>XLXN_30(6),
      checksum(5)=>XLXN_30(5), checksum(4)=>XLXN_30(4),
      checksum(3)=>XLXN_30(3), checksum(2)=>XLXN_30(2),
      checksum(1)=>XLXN_30(1), checksum(0)=>XLXN_30(0),
      cfg_receive_mask(5)=>receive_mask(5),
      cfg_receive_mask(4)=>receive_mask(4),
      cfg_receive_mask(3)=>receive_mask(3),
      cfg_receive_mask(2)=>receive_mask(2),
      cfg_receive_mask(1)=>receive_mask(1),
      cfg_receive_mask(0)=>receive_mask(0),
      cfg_response_mask(5)=>response_mask(5),
      cfg_response_mask(4)=>response_mask(4),
      cfg_response_mask(3)=>response_mask(3),
      cfg_response_mask(2)=>response_mask(2),
      cfg_response_mask(1)=>response_mask(1),
      cfg_response_mask(0)=>response_mask(0), ser_out=>XLXN_21,
      receiver_rst=>XLXN_36, transmitter_rst=>XLXN_22,
      transmitter_bypass=>XLXN_44, checksum_en=>XLXN_32,
      checksum_done=>XLXN_33, statuses(2)=>Statuses(2),
      statuses(1)=>Statuses(1), statuses(0)=>Statuses(0),
      receive(7)=>Receive_DUMMY(7), receive(6)=>Receive_DUMMY(6),
      receive(5)=>Receive_DUMMY(5), receive(4)=>Receive_DUMMY(4),
      receive(3)=>Receive_DUMMY(3), receive(2)=>Receive_DUMMY(2),
      receive(1)=>Receive_DUMMY(1), receive(0)=>Receive_DUMMY(0),
      transmitter_sr(7)=>XLXN_23(7), transmitter_sr(6)=>XLXN_23(6),
      transmitter_sr(5)=>XLXN_23(5), transmitter_sr(4)=>XLXN_23(4),
      transmitter_sr(3)=>XLXN_23(3), transmitter_sr(2)=>XLXN_23(2),
      transmitter_sr(1)=>XLXN_23(1), transmitter_sr(0)=>XLXN_23(0),
      parity_check(5)=>XLXN_29(5), parity_check(4)=>XLXN_29(4),
      parity_check(3)=>XLXN_29(3), parity_check(2)=>XLXN_29(2),
      parity_check(1)=>XLXN_29(1), parity_check(0)=>XLXN_29(0),
      snoop_cur_state(3)=>slave_state(3), snoop_cur_state(2)=>slave_state(2),
      snoop_cur_state(1)=>slave_state(1), snoop_cur_state(0)=>slave_state(0),
      checksum_clr=>XLXN_43);

   XLXI_8 : parity_generator
      PORT MAP (pr1=>XLXN_27, pr0=>XLXN_28, data(5)=>XLXN_29(5),
      data(4)=>XLXN_29(4), data(3)=>XLXN_29(3), data(2)=>XLXN_29(2),
      data(1)=>XLXN_29(1), data(0)=>XLXN_29(0));

   XLXI_10 : receiver
      PORT MAP (clk=>clk, rst=>XLXN_36, ser_in=>RxD, done=>XLXN_37,
      par_out(7)=>XLXN_38(7), par_out(6)=>XLXN_38(6), par_out(5)=>XLXN_38(5),
      par_out(4)=>XLXN_38(4), par_out(3)=>XLXN_38(3), par_out(2)=>XLXN_38(2),
      par_out(1)=>XLXN_38(1), par_out(0)=>XLXN_38(0));

   XLXI_6 : transmitter
      PORT MAP (clk=>clk, rst=>XLXN_22, ser_in=>XLXN_21, bypass=>XLXN_44,
      par_in(7)=>XLXN_23(7), par_in(6)=>XLXN_23(6), par_in(5)=>XLXN_23(5),
      par_in(4)=>XLXN_23(4), par_in(3)=>XLXN_23(3), par_in(2)=>XLXN_23(2),
      par_in(1)=>XLXN_23(1), par_in(0)=>XLXN_23(0), ser_out=>TxD,
      done=>XLXN_26);

END SCHEMATIC;



