-- C:\WORK_XILINX\LIN_CONTROLLER
-- VHDL Test Bench created by
-- HDL Bencher 5.1i
-- Thu Jun 19 01:26:00 2003
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
  -- time for one full clock cycle
  constant CLK_TIME : Time := 100 ns;
  -- Time for one full bit
  constant BIT_TIME : Time := 32*CLK_TIME;

FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT lin_controller
		PORT (
			clk : in  std_logic;
			rst : in  std_logic;
      sel_n   : in    std_logic;
      r_n   : in std_logic;
      w_n   : in    std_logic;
			addr : in  std_logic_vector (3 DOWNTO 0);
			data : inout  std_logic_vector (7 DOWNTO 0);
			RxD : in  std_logic;
			TxD : out  std_logic
		);
	END COMPONENT;

	SIGNAL clk : std_logic;
	SIGNAL rst : std_logic;
	SIGNAL sel_n : std_logic;
	SIGNAL w_n : std_logic;
	SIGNAL r_n : std_logic;
	SIGNAL addr : std_logic_vector (3 DOWNTO 0);
	SIGNAL data : std_logic_vector (7 DOWNTO 0);
	SIGNAL RxD : std_logic;
	SIGNAL TxD : std_logic;


BEGIN


UUT : lin_controller
	PORT MAP (
		clk => clk,
		rst => rst,
		sel_n => sel_n,
		r_n => r_n,
		w_n => w_n,
		addr => addr,
		data => data,
		RxD => RxD,
		TxD => TxD
	);

	PROCESS -- clock process for clk,
	BEGIN
		CLOCK_LOOP : LOOP
		clk <= transport '0';
		WAIT FOR 10 ns;
		clk <= transport '1';
		WAIT FOR 10 ns;
		WAIT FOR 40 ns;
		clk <= transport '0';
		WAIT FOR 40 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

--  process interrupt_handler (
--    irq : in std_logic,
--    iack : out std_logic)
--  begin
--    -- interrupt handler - receive interrupts and act on them.
--    if (rising_edge(irq)) then
--      WAIT FOR 1000 ns;
--      -- Address for read register
--      addr <= transport std_logic_vector'("0100"); --4
--      -- --------------------
--      WAIT FOR 200 ns; -- Time=37500 ns
--      w_n <= transport '0';
--      data <= transport std_logic_vector'("00000100"); --4
--      -- --------------------
--      WAIT FOR 100 ns; -- Time=37600 ns
--      sel_n <= transport '0';
--      -- --------------------
--      WAIT FOR 100 ns; -- Time=37700 ns
--      sel_n <= transport '1';
--      -- --------------------
--      WAIT FOR 100 ns; -- Time=37800 ns
--      w_n <= transport '1';
--      data <= transport std_logic_vector'("ZZZZZZZZ"); --Z
--      -- --------------------
--      WAIT FOR 15410 ns; -- Time=53210 ns
--      -- --------------------
--    end if;
--
--  end interrupt_handler;
--

	PROCESS   -- Process for clk
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

--		PROCEDURE CHECK_TxD(
--			next_TxD : std_logic;
--			TX_TIME : INTEGER
--		) IS
--			VARIABLE TX_STR : String(1 to 4096);
--			VARIABLE TX_LOC : LINE;
--		BEGIN
--			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
--			-- change compiler settings to use explicit declarations only
--			IF (TxD /= next_TxD) THEN 
--				write(TX_LOC,string'("Error at time="));
--				write(TX_LOC, TX_TIME);
--				write(TX_LOC,string'("ns TxD="));
--				write(TX_LOC, TxD);
--				write(TX_LOC, string'(", Expected = "));
--				write(TX_LOC, next_TxD);
--				write(TX_LOC, string'(" "));
--				TX_STR(TX_LOC.all'range) := TX_LOC.all;
--				writeline(results, TX_LOC);
--				Deallocate(TX_LOC);
--				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
--				TX_ERROR := TX_ERROR + 1;
--			END IF;
--		END;
--
--		PROCEDURE CHECK_data(
--			next_data : std_logic_vector (7 DOWNTO 0);
--			TX_TIME : INTEGER
--		) IS
--			VARIABLE TX_STR : String(1 to 4096);
--			VARIABLE TX_LOC : LINE;
--		BEGIN
--			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
--			-- change compiler settings to use explicit declarations only
--			IF (data /= next_data) THEN 
--				write(TX_LOC,string'("Error at time="));
--				write(TX_LOC, TX_TIME);
--				write(TX_LOC,string'("ns data="));
--				write(TX_LOC, data);
--				write(TX_LOC, string'(", Expected = "));
--				write(TX_LOC, next_data);
--				write(TX_LOC, string'(" "));
--				TX_STR(TX_LOC.all'range) := TX_LOC.all;
--				writeline(results, TX_LOC);
--				Deallocate(TX_LOC);
--				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
--				TX_ERROR := TX_ERROR + 1;
--			END IF;
--		END;

    procedure send_brk (signal RxD: out std_logic) is
    begin
    -- Break, low phase
      RxD <= transport '0';
      WAIT FOR 16*BIT_TIME;
      -- Break, high phase
      RxD <= transport '1';
      WAIT FOR 2*BIT_TIME;
    end send_brk;

    procedure send_byte (byte : in std_logic_vector(7 downto 0)) is
      variable i : integer;
    begin
      -- Start bit
      RxD <= transport '0';
      WAIT FOR BIT_TIME;

      -- Send out byte, LSB first
      for i in 0 to 7 loop
        RxD <= transport (byte(i));
        WAIT FOR BIT_TIME;
      end loop;  -- i

      -- Stop bit
      RxD <= transport '1';
      WAIT FOR BIT_TIME;
    end send_byte;

    procedure write_register (
      reg: in std_logic_vector (3 downto 0);
      byte: in std_logic_vector (7 downto 0)
    ) is
    begin
      WAIT FOR 2*BIT_TIME;
      -- Address for transmit register
      addr <= transport (reg); --4
      WAIT FOR 10*CLK_TIME; 
      sel_n <= transport '0';
      WAIT FOR 10*CLK_TIME; 
      w_n <= transport '0';
      WAIT FOR 4*CLK_TIME;
      -- assert the data
      data <= transport (byte); --4
      WAIT FOR 4*CLK_TIME; 
      w_n <= transport '1';
      WAIT FOR 4*CLK_TIME;
      sel_n <= transport '1';
      WAIT FOR 4*CLK_TIME;
      data <= transport ("ZZZZZZZZ"); --Z
      WAIT FOR 2*CLK_TIME;

    end write_register;
      

		BEGIN
    -- Initial setup of all signals
		-- --------------------
		rst <= transport '1';
		addr <= transport std_logic_vector'("0000"); --0
		RxD <= transport '1';
		sel_n <= transport '1';
		r_n <= transport '1';
		w_n <= transport '1';
		data <= transport std_logic_vector'("ZZZZZZZZ"); --Z
		-- --------------------
		WAIT FOR 100 ns; -- Time=100 ns
		rst <= transport '0';
		-- --------------------
		WAIT FOR 900 ns; -- Time=1000 ns


    ---------------------------------------------------------------------------
    -- Slave reception checks                
    ---------------------------------------------------------------------------
    -- Send the sync break
    send_brk(RxD);
    wait for BIT_TIME;

    -- Send the sync field
    send_byte("01010101");
    wait for 4*BIT_TIME;

    -- Identifier
    send_byte(x"A3");
    wait for 4*BIT_TIME;

    -- Send data fields
    send_byte(x"4A");
    wait for 4*BIT_TIME;
    send_byte(x"55");
    wait for 4*BIT_TIME;
    send_byte(x"93");
    wait for 4*BIT_TIME;
    send_byte(x"E5");
    wait for 4*BIT_TIME;
    -- checkbyte
    send_byte(x"E6");
    wait for 4*BIT_TIME;

    ---------------------------------------------------------------------------
    -- Slave transmission checks                
    ---------------------------------------------------------------------------
    -- Send the sync break
    send_brk(RxD);
    wait for BIT_TIME;

    -- Send the sync field
    send_byte("01010101");
    wait for 4*BIT_TIME;

    -- Identifier
    send_byte(x"A3");
    wait for 4*BIT_TIME;

    write_register("0100", x"4A");
    wait for 15*BIT_TIME;
    write_register("0100", x"55");
    wait for 15*BIT_TIME;
    write_register("0100", x"93");
    wait for 15*BIT_TIME;
    write_register("0100", x"E5");
    wait for 15*BIT_TIME;
    
    -- --------------------
    WAIT FOR 100 ns; -- Time=37600 ns
    -- --------------------
    WAIT FOR 100 ns; -- Time=37700 ns
    sel_n <= transport '1';
    -- --------------------
    WAIT FOR 100 ns; -- Time=37800 ns
    w_n <= transport '1';
    data <= transport std_logic_vector'("ZZZZZZZZ"); --Z
    wait for 10*BIT_TIME;


    ---------------------------------------------------------------------------
    -- Slave transmission checks                
    ---------------------------------------------------------------------------
    -- Send the sync break
    send_brk(RxD);
    wait for 10*BIT_TIME;
    -- Send another break
    send_brk(RxD);
    wait for BIT_TIME;
    WAIT FOR 15410 ns; -- Time=53210 ns



--		IF (TX_ERROR = 0) THEN 
--			write(TX_OUT,string'("No errors or warnings"));
--			writeline(results, TX_OUT);
--			ASSERT (FALSE) REPORT
--				"Simulation successful (not a failure).  No problems detected. "
--				SEVERITY FAILURE;
--		ELSE
--			write(TX_OUT, TX_ERROR);
--			write(TX_OUT, string'(
--				" errors found in simulation"));
--			writeline(results, TX_OUT);
--			ASSERT (FALSE) REPORT
--				"Errors found during simulation"
--				SEVERITY FAILURE;
--		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION lin_controller_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END lin_controller_cfg;
