-- C:\WORK_XILINX\LIN_CONTROLLER
-- VHDL Test Bench created by
-- HDL Bencher 5.1i
-- Fri Jun 27 16:47:27 2003
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY  ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

LIBRARY  UNISIM;
USE UNISIM.Vcomponents.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
  constant CLK_TIME : Time := 100 ns;
  -- Time for one full bit
  constant BIT_TIME : Time := 32*CLK_TIME;

  type test_t is (
    None, Test_1, Test_2, Test_3, Test_4, Test_5, Test_6, Test_7, Test_8,
    Test_9, Test_10, Test_11
  );

FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT lin_network
		PORT (
      addr1   : in    std_logic_vector (3 downto 0);
      addr2   : in    std_logic_vector (3 downto 0);
      clk     : in    std_logic;
      r_n1    : in    std_logic;
      r_n2    : in    std_logic;
      rst     : in    std_logic;
      sel_n1  : in    std_logic;
      sel_n2  : in    std_logic;
      w_n1    : in    std_logic;
      w_n2    : in    std_logic;
      data1   : inout std_logic_vector (7 downto 0);
      data2   : inout std_logic_vector (7 downto 0);
      lin_bus : INOUT STD_LOGIC;
      int1    : out   std_logic;
      int2    : out   std_logic
		);
	END COMPONENT;

  signal addr1   : std_logic_vector (3 downto 0);
  signal addr2   : std_logic_vector (3 downto 0);
  signal clk     : std_logic;
  signal r_n1    : std_logic;
  signal r_n2    : std_logic;
  signal rst     : std_logic;
  signal sel_n1  : std_logic;
  signal sel_n2  : std_logic;
  signal w_n1    : std_logic;
  signal w_n2    : std_logic;
  signal data1   : std_logic_vector (7 downto 0);
  signal data2   : std_logic_vector (7 downto 0);
  signal lin_bus : std_logic;
  signal int1    : STD_LOGIC;
  SIGNAL int2    : STD_LOGIC;

  constant REG_CONTROL         : std_logic_vector ( 3 downto 0) := "0000";
  constant REG_STATUS1         : std_logic_vector ( 3 downto 0) := "0010";
  constant REG_STATUS2         : std_logic_vector ( 3 downto 0) := "0011";
  constant REG_TRANSMIT        : std_logic_vector ( 3 downto 0) := "0100";
  constant REG_RECEIVE         : std_logic_vector ( 3 downto 0) := "0101";
  constant REG_SLAVE_ID_MASK   : std_logic_vector ( 3 downto 0) := "0110";
  constant REG_SLAVE_ID_FILTER : std_logic_vector ( 3 downto 0) := "0111";
  constant REG_CLKDIV1         : std_logic_vector ( 3 downto 0) := "1000";
  constant REG_CLKDIV2         : std_logic_vector ( 3 downto 0) := "1001";

  signal data_read : std_logic_vector (7 downto 0);
  -- Used so the current test # can be displayed in the waveform viewer.
  signal current_test : test_t;
BEGIN
	UUT : lin_network
	PORT MAP (
    addr1   => addr1,
    addr2   => addr2,
    clk     => clk,
    r_n1    => r_n1,
    r_n2    => r_n2,
    rst     => rst,
    sel_n1  => sel_n1,
    sel_n2  => sel_n2,
    w_n1    => w_n1,
    w_n2    => w_n2,
    data1   => data1,
    data2   => data2,
    lin_bus => lin_bus,
    int1    => int1,
    int2    => int2
	);

	PROCESS -- clock process for clk,
	BEGIN
		CLOCK_LOOP : LOOP
		clk <= transport '0';
		WAIT FOR 10 ns;
		clk <= transport '1';
		WAIT FOR 10 ns;
		WAIT FOR 40 ns;
		clk <= transport '0';
		WAIT FOR 40 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

  
	PROCESS   -- Process for clk
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

  -- Credits: John Janusson (jjanusson@nospami-o.com)
  function slv2hex (
    hex_in : std_logic_vector)
    return string is
    variable textline : line;
    variable tmp_string : string(1 to hex_in'length / 4);
  begin  -- function slv2hex
    hwrite(textline,hex_in);
    read(textline,tmp_string);
    return(tmp_string);
  end function slv2hex;

    procedure read_register1 (
      reg: in std_logic_vector (3 downto 0);
      signal byte: out std_logic_vector (7 downto 0)
    ) is
    begin
      WAIT FOR 2*CLK_TIME;
      addr1 <= transport (reg); --4
      WAIT FOR 2*CLK_TIME; 
      sel_n1 <= transport '0';
      r_n1 <= transport '0';
      WAIT FOR 2*CLK_TIME;
      -- read the data
      byte <= transport (data1);
      WAIT FOR 2*CLK_TIME; 
      r_n1 <= transport '1';
      sel_n1 <= transport '1';
      WAIT FOR 2*CLK_TIME;
    end read_register1;

    procedure read_register2 (
      reg: in std_logic_vector (3 downto 0);
      signal byte: out std_logic_vector (7 downto 0)
    ) is
    begin
      WAIT FOR 2*CLK_TIME;
      addr2 <= transport (reg); --4
      WAIT FOR 2*CLK_TIME; 
      sel_n2 <= transport '0';
      r_n2 <= transport '0';
      WAIT FOR 2*CLK_TIME;
      -- read the data
      byte <= transport (data2);
      WAIT FOR 2*CLK_TIME; 
      r_n2 <= transport '1';
      sel_n2 <= transport '1';
      WAIT FOR 2*CLK_TIME;
    end read_register2;

    procedure write_register1 (
      reg: in std_logic_vector (3 downto 0);
      byte: in std_logic_vector (7 downto 0)
    ) is
    begin
      WAIT FOR 2*CLK_TIME;
      addr1 <= transport (reg); --4
      WAIT FOR 2*CLK_TIME; 
      sel_n1 <= transport '0';
      w_n1 <= transport '0';
      WAIT FOR 2*CLK_TIME;
      -- assert the data
      data1 <= transport (byte); --4
      WAIT FOR 2*CLK_TIME; 
      w_n1 <= transport '1';
      sel_n1 <= transport '1';
      WAIT FOR 2*CLK_TIME;
      data1 <= transport ("ZZZZZZZZ"); --Z
      WAIT FOR 2*CLK_TIME;
    end write_register1;

    procedure write_register2 (
      reg: in std_logic_vector (3 downto 0);
      byte: in std_logic_vector (7 downto 0)
    ) is
    begin
      WAIT FOR 2*CLK_TIME;
      addr2 <= transport (reg); --4
      WAIT FOR 2*CLK_TIME; 
      sel_n2 <= transport '0';
      w_n2 <= transport '0';
      WAIT FOR 2*CLK_TIME;
      -- assert the data
      data2 <= transport (byte); --4
      WAIT FOR 2*CLK_TIME; 
      w_n2 <= transport '1';
      sel_n2 <= transport '1';
      WAIT FOR 2*CLK_TIME;
      data2 <= transport ("ZZZZZZZZ"); --Z
      WAIT FOR 2*CLK_TIME;
    end write_register2;

    procedure send_brk (signal lin_bus: out std_logic) is
    begin
    -- Break, low phase
      lin_bus <= transport '0';
      WAIT FOR 16*BIT_TIME;
      -- Break, high phase
      lin_bus <= transport 'H';
      WAIT FOR 2*BIT_TIME;
    end send_brk;

    procedure send_byte (LOCAL_BIT_TIME : in time;
                         byte : in std_logic_vector(7 downto 0)) is
      variable i : integer;
    begin
      -- Start bit
      lin_bus <= transport '0';
      WAIT FOR LOCAL_BIT_TIME;

      -- Send out byte, LSB first
      for i in 0 to 7 loop
        if (byte(i) = '1') then
          lin_bus <= transport 'H';
        else
          lin_bus <= transport '0';
        end if;
        WAIT FOR LOCAL_BIT_TIME;
      end loop;  -- i

      -- Stop bit
      lin_bus <= transport 'H';
      WAIT FOR LOCAL_BIT_TIME;
    end send_byte;

		PROCEDURE report_register(
      reg: in std_logic_vector (3 downto 0);
      byte: in std_logic_vector (7 downto 0)
    ) is
    begin
      if (reg = REG_CONTROL) then
        write (TX_OUT, string'("Control Register:    "));
        write (TX_OUT, byte);
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 7: i_receive:       "));
        write (TX_OUT, byte(7));
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 6: i_transmit:      "));
        write (TX_OUT, byte(6));
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 5: i_error:         "));
        write (TX_OUT, byte(5));
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 1: cfg_autobaud:    "));
        write (TX_OUT, byte(1));
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 0: cfg_masterslave: "));
        write (TX_OUT, byte(0));
        writeline (results, TX_OUT);
      elsif (reg = REG_STATUS1) then
        write (TX_OUT, string'("Status Register1: "));
        write (TX_OUT, byte);
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 3: s_error:  "));
        write (TX_OUT, byte(3));
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 2: s_idle:   "));
        write (TX_OUT, byte(2));
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 1: s_tdre:   "));
        write (TX_OUT, byte(1));
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 0: s_rdre:   "));
        write (TX_OUT, byte(0));
        writeline (results, TX_OUT);
      elsif (reg = REG_STATUS2) then
        write (TX_OUT, string'("Status Register2: "));
        write (TX_OUT, byte);
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 6: e_shortframe:   "));
        write (TX_OUT, byte(6));
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 5: e_noslaveresp:  "));
        write (TX_OUT, byte(5));
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 4: e_xmit:         "));
        write (TX_OUT, byte(4));
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 3: e_framing:      "));
        write (TX_OUT, byte(3));
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 2: e_parity:       "));
        write (TX_OUT, byte(2));
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 1: e_cksum:        "));
        write (TX_OUT, byte(1));
        writeline (results, TX_OUT);
        write (TX_OUT, string'(" 0: e_overrun:      "));
        write (TX_OUT, byte(0));
        writeline (results, TX_OUT);
      elsif (reg = REG_TRANSMIT) then
        write (TX_OUT, string'("Transmit Register: "));
        write (TX_OUT, byte);
        writeline (results, TX_OUT);
      elsif (reg = REG_RECEIVE) then
        write (TX_OUT, string'("Receive Register: "));
        write (TX_OUT, byte);
        writeline (results, TX_OUT);
      elsif (reg = REG_SLAVE_ID_MASK) then
        write (TX_OUT, string'("Slave ID Mask: "));
        write (TX_OUT, byte);
        writeline (results, TX_OUT);
      elsif (reg = REG_SLAVE_ID_FILTER) then
        write (TX_OUT, string'("Slave ID Filter: "));
        write (TX_OUT, byte);
        writeline (results, TX_OUT);
      elsif (reg = REG_CLKDIV1) then
        write (TX_OUT, string'("Clock divisor1 (upper byte): "));
        write (TX_OUT, byte);
        writeline (results, TX_OUT);
      elsif (reg = REG_CLKDIV2) then
        write (TX_OUT, string'("Clock divisor2 (lower byte): "));
        write (TX_OUT, byte);
        writeline (results, TX_OUT);
      end if;
    end report_register;
      
		PROCEDURE report_all_registers is
    begin
      write (TX_OUT, string'("*****************************"));
      writeline (results, TX_OUT);
      write (TX_OUT, string'("*** Lin controller 1      ***"));
      writeline (results, TX_OUT);
      write (TX_OUT, string'("*****************************"));
      writeline (results, TX_OUT);
      read_register1(REG_CONTROL, data_read);
      report_register(REG_CONTROL, data_read);
      read_register1(REG_STATUS1, data_read);
      report_register(REG_STATUS1, data_read);
      read_register1(REG_STATUS2, data_read);
      report_register(REG_STATUS2, data_read);
      read_register1(REG_TRANSMIT, data_read);
      report_register(REG_TRANSMIT, data_read);
      read_register1(REG_RECEIVE, data_read);
      report_register(REG_RECEIVE, data_read);
      read_register1(REG_SLAVE_ID_MASK, data_read);
      report_register(REG_SLAVE_ID_MASK, data_read);
      read_register1(REG_SLAVE_ID_FILTER, data_read);
      report_register(REG_SLAVE_ID_FILTER, data_read);
      read_register1(REG_SLAVE_ID_MASK, data_read);
      report_register(REG_SLAVE_ID_MASK, data_read);
      read_register1(REG_CLKDIV1, data_read);
      report_register(REG_CLKDIV1, data_read);
      read_register1(REG_CLKDIV2, data_read);
      report_register(REG_CLKDIV2, data_read);
      
      write (TX_OUT, string'(""));
      writeline (results, TX_OUT);
      write (TX_OUT, string'("*****************************"));
      writeline (results, TX_OUT);
      write (TX_OUT, string'("*** Lin controller 2      ***"));
      writeline (results, TX_OUT);
      write (TX_OUT, string'("*****************************"));
      writeline (results, TX_OUT);
      read_register2(REG_CONTROL, data_read);
      report_register(REG_CONTROL, data_read);
      read_register2(REG_STATUS1, data_read);
      report_register(REG_STATUS1, data_read);
      read_register2(REG_STATUS2, data_read);
      report_register(REG_STATUS2, data_read);
      read_register2(REG_TRANSMIT, data_read);
      report_register(REG_TRANSMIT, data_read);
      read_register2(REG_RECEIVE, data_read);
      report_register(REG_RECEIVE, data_read);
      read_register2(REG_SLAVE_ID_MASK, data_read);
      report_register(REG_SLAVE_ID_MASK, data_read);
      read_register2(REG_SLAVE_ID_FILTER, data_read);
      report_register(REG_SLAVE_ID_FILTER, data_read);
      read_register2(REG_SLAVE_ID_MASK, data_read);
      report_register(REG_SLAVE_ID_MASK, data_read);
      read_register2(REG_CLKDIV1, data_read);
      report_register(REG_CLKDIV1, data_read);
      read_register2(REG_CLKDIV2, data_read);
      report_register(REG_CLKDIV2, data_read);

    end report_all_registers;

		BEGIN
		-- --------------------
    data_read <= transport STD_LOGIC_VECTOR'("00000000");
 		addr1 <= transport STD_LOGIC_VECTOR'("0000"); --0
		addr2 <= transport STD_LOGIC_VECTOR'("0000"); --0
		r_n1 <= transport '1';
		r_n2 <= transport '1';
		rst <= transport '1';
		sel_n1 <= transport '1';
		sel_n2 <= transport '1';
		w_n1 <= transport '1';
		w_n2 <= transport '1';
		data1 <= transport STD_LOGIC_VECTOR'("ZZZZZZZZ");
		data2 <= transport STD_LOGIC_VECTOR'("ZZZZZZZZ");
    lin_bus <= transport 'H';
		-- --------------------
		WAIT FOR 100 ns; -- Time=100 ns
		rst <= transport '0';
		-- --------------------
		WAIT FOR 110 ns; -- Time=210 ns
		-- --------------------

    wait for 4*BIT_TIME;
    report_all_registers;

    -- Configure controller 2 as a slave.
    write_register2(REG_STATUS1, "10100001");
    
    wait for 4*BIT_TIME;

    ---------------------------------------------------------------------------
    -- Basic transmission test, from controller 1 to 2.  2 Bytes.
    ---------------------------------------------------------------------------
    current_test <= Test_1;
    write_register1(REG_STATUS1, "10100000");
    write_register2(REG_STATUS1, "10100001");

    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("*** Test 1: Basic Transmission Test: 2 bytes"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Sending ID 15, data 10 FF"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Received (controller 1, controller 2): "));
    -- Send from unit 1
    write_register1(REG_TRANSMIT, x"15");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    
    write_register1(REG_TRANSMIT, x"10");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    write_register1(REG_TRANSMIT, x"FF");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    -- Receive the checksum (final byte)
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'("."));

    writeline (results, TX_OUT);
    -- Dump all of the registers at the end of the test
    report_all_registers;
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);

    ---------------------------------------------------------------------------
    -- Basic transmission test, from controller 1 to 2.  4 Bytes.
    ---------------------------------------------------------------------------
    current_test <= Test_2;
    write_register1(REG_STATUS1, "10100000");
    write_register2(REG_STATUS1, "10100001");
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("*** Test 2: Basic Transmission Test: 4 bytes"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Sending ID 23, data 4A 55 93 E5"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Received (controller 1, controller 2): "));
    -- Send from unit 1
    write_register1(REG_TRANSMIT, x"23");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    write_register1(REG_TRANSMIT, x"4A");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    write_register1(REG_TRANSMIT, x"55");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    write_register1(REG_TRANSMIT, x"93");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    write_register1(REG_TRANSMIT, x"E5");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    -- Receive the checksum (final byte)
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'("."));

    writeline (results, TX_OUT);
    -- Dump all of the registers at the end of the test
    report_all_registers;
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);


    ---------------------------------------------------------------------------
    -- Basic transmission test, from controller 1 to 2.  8 Bytes.
    ---------------------------------------------------------------------------
    current_test <= Test_3;
    write_register1(REG_STATUS1, "10100000");
    write_register2(REG_STATUS1, "10100001");
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("*** Test 3: Basic Transmission Test: 8 bytes"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Sending ID 32, data AB CD 00 00 00 FF 55 11"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Received (controller 1, controller 2): "));
    -- Send from unit 1
    write_register1(REG_TRANSMIT, x"32");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    write_register1(REG_TRANSMIT, x"AB");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    write_register1(REG_TRANSMIT, x"CD");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    write_register1(REG_TRANSMIT, x"00");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    write_register1(REG_TRANSMIT, x"00");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    write_register1(REG_TRANSMIT, x"00");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    write_register1(REG_TRANSMIT, x"FF");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    write_register1(REG_TRANSMIT, x"55");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    write_register1(REG_TRANSMIT, x"11");
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    -- Receive the checksum (final byte)
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'("."));

    writeline (results, TX_OUT);
    -- Dump all of the registers at the end of the test
    report_all_registers;
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);

    ---------------------------------------------------------------------------
    -- Basic transmission test, Node 1 sends ID, node 2 responds.
    ---------------------------------------------------------------------------
    current_test <= Test_4;
    write_register1(REG_STATUS1, "10100000");
    write_register2(REG_STATUS1, "10100001");
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("*** Test 4: Node 1 sends ID, Node 2 responds"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Sending ID 15, data 10 FF"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Received (controller 1, controller 2): "));
    -- Send ID from Node 1
    write_register1(REG_TRANSMIT, x"15");
    -- The master echos back any ID it sends out.  Read it.
    wait until (int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    -- When Node 2 is ready, then read the ID.
    if (int2 = '0') then wait until (int2 = '1');  end if;
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    -- Write the first byte from node 2
    write_register2(REG_TRANSMIT, x"10");
    -- Read the byte from Node 1.
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    -- Write the second byte from node 2
    write_register2(REG_TRANSMIT, x"FF");
    -- Read the byte from Node 1.
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    -- Receive the checksum (final byte)
    wait until (int2 = '1' and int1 = '1');
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'("."));

    writeline (results, TX_OUT);
    -- Dump all of the registers at the end of the test
    report_all_registers;
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);

    ---------------------------------------------------------------------------
    -- Short Frame test
    ---------------------------------------------------------------------------
    current_test <= Test_5;
    -- Enable only error interrupts on both 1 and 2
    write_register1(REG_CONTROL, "00100000");
    write_register2(REG_CONTROL, "00100001");
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("*** Test 5: Short Frame: 2 bytes"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Sending ID 32, data D0"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Received (controller 1, controller 2): "));
    -- Send from unit 1
    write_register1(REG_TRANSMIT, x"32");
    wait for 40*BIT_TIME;
    -- Read from both nodes
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));

    write_register2(REG_TRANSMIT, x"D0");
    wait for 20*BIT_TIME;
    -- Read from both nodes
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(","));
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'("."));
  
    writeline (results, TX_OUT);
    -- Wait until an error is flagged.  Both 1 and 2 should notice the
    -- short frame.
    if (int1 = '0') then wait until (int1 = '1');  end if;
    if (int2 = '0') then wait until (int2 = '1');  end if;
    -- Dump all of the registers at the end of the test
    report_all_registers;
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);

    ---------------------------------------------------------------------------
    -- Noslaveresp test
    ---------------------------------------------------------------------------
    current_test <= Test_6;
    -- Enable only error interrupts on both 1 and 2
    write_register1(REG_CONTROL, "00100000");
    write_register2(REG_CONTROL, "00100001");
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("*** Test 6: No slave response"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Sending ID 05"));
    writeline (results, TX_OUT);
    -- Send from unit 1
    write_register1(REG_TRANSMIT, x"05");
    -- Wait until an error is flagged.  Both 1 and 2 should notice the
    -- lack of a response.
    if (int1 = '0') then wait until (int1 = '1');  end if;
    if (int2 = '0') then wait until (int2 = '1');  end if;
    -- Dump all of the registers at the end of the test
    report_all_registers;
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);

    ---------------------------------------------------------------------------
    -- Testing transmit and checksum errors.
    ---------------------------------------------------------------------------
    current_test <= Test_7;
    -- Reenable receive interrupt on only node 2.  Keep error interrupts
    -- disabled.
    write_register1(REG_CONTROL, "00000000");
    write_register2(REG_CONTROL, "10000001");
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("*** Test 7: Testing e_xmit and e_cksum"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Sending ID 0A, data FF 50"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Received (controller 2): "));
    -- Send from unit 1
    write_register1(REG_TRANSMIT, x"0A");
    wait until (int2 = '1');
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    write_register1(REG_TRANSMIT, x"FF");
    wait for 4*BIT_TIME;
    -- Simulate a short bus error
    lin_bus <= transport '0';
    wait for 1*BIT_TIME;
    lin_bus <= transport 'H';
    wait until (int2 = '1');
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    write_register1(REG_TRANSMIT, x"50");
    wait until (int2 = '1');
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    -- Receive the checksum (final byte)
    wait until (int2 = '1');
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'("."));
    writeline (results, TX_OUT);
    -- Dump all of the registers at the end of the test
    report_all_registers;
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);

    ---------------------------------------------------------------------------
    -- Test a framing error.
    ---------------------------------------------------------------------------
    current_test <= Test_8;
    -- Disable error interrupts.
    write_register1(REG_CONTROL, "10000000");
    write_register2(REG_CONTROL, "10000001");
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("*** Test 8: Framing error"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Sending ID 0A, data FF 00"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Received (controller 1): "));
    -- Send ID from unit 1
    write_register1(REG_TRANSMIT, x"0A");
    if (int1 = '0') then wait until (int1 = '1');  end if;
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    -- Serial write direct to the bus, so we can test a framing error.  Send
    -- an "FF" with no high stop bit.
    lin_bus <= transport '0';
    wait for 1*BIT_TIME;
    lin_bus <= transport 'H';
    wait for 8*BIT_TIME;
    -- Incorrect stop bit.
    lin_bus <= transport '0';
    wait for 1*BIT_TIME;
    -- Back to 'H'.
    lin_bus <= transport 'H';
    if (int1 = '0') then wait until (int1 = '1');  end if;
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    -- Padding
    wait for 1*BIT_TIME;
    -- Serial write direct to the bus, this time just "55" for a second
    -- byte and an incorrect checksum.
    lin_bus <= transport '0';
    wait for 1*BIT_TIME;
    lin_bus <= transport 'H';
    wait for 1*BIT_TIME;
    lin_bus <= transport '0';
    wait for 1*BIT_TIME;
    lin_bus <= transport 'H';
    wait for 1*BIT_TIME;
    lin_bus <= transport '0';
    wait for 1*BIT_TIME;
    lin_bus <= transport 'H';
    wait for 1*BIT_TIME;
    lin_bus <= transport '0';
    wait for 1*BIT_TIME;
    lin_bus <= transport 'H';
    wait for 1*BIT_TIME;
    lin_bus <= transport '0';
    wait for 1*BIT_TIME;

    lin_bus <= transport 'H';
    wait for 1*BIT_TIME;
    if (int1 = '0') then wait until (int1 = '1');  end if;
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    -- Checksum "00" (incorrect checksum).
    lin_bus <= transport '0';
    wait for 9*BIT_TIME;
    lin_bus <= transport 'H';
    wait for 1*BIT_TIME;
    if (int1 = '0') then wait until (int1 = '1');  end if;
    read_register1(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'("."));
    writeline (results, TX_OUT);
    -- Dump all of the registers at the end of the test
    report_all_registers;
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);

    ---------------------------------------------------------------------------
    -- Testing parity error.
    ---------------------------------------------------------------------------
    current_test <= Test_9;
    -- Enable error interrupt on both nodes.
    write_register1(REG_CONTROL, "00100000");
    write_register2(REG_CONTROL, "00100001");
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("*** Test 9: e_parity"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Sending ID 0A, data FF 50"));
    writeline (results, TX_OUT);

    -- Bypass node 1 and send a break and ID directly (technically
    -- illegal to have two masters, but it simplifies this test).
    send_brk (lin_bus);
    send_byte (BIT_TIME, x"55");
    send_byte (BIT_TIME, x"0A");
    -- Wait until both nodes acknowledge the incorrect parity.
    if (int1 = '0') then wait until (int1 = '1');  end if;
    if (int2 = '0') then wait until (int2 = '1');  end if;
    -- Dump all of the registers at the end of the test
    report_all_registers;
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);

    ---------------------------------------------------------------------------
    -- Slewed clock slave reception (slave reeceives a response from
    -- another slave with a clock that is fast by 4%).
    ---------------------------------------------------------------------------
    current_test <= Test_10;
    write_register1(REG_CONTROL, "00100000");
    write_register2(REG_CONTROL, "10000001");
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("*** Test 10: Slewed clock slave reception"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Sending ID 15, data 10 FF"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Received (controller 2): "));
    -- Send ID from unit 1, test reception from unit 2
    write_register1(REG_TRANSMIT, x"15");
    wait until (int2 = '1');
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    wait for 2*BIT_TIME;
    -- Write directly to the bus serially, using a BIT_TIME that's off by
    -- 4%.
    send_byte (0.96*BIT_TIME, x"10");
    wait until (int2 = '1');
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    send_byte (0.96*BIT_TIME, x"FF");
    wait until (int2 = '1');
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    -- Checksum
    send_byte (0.96*BIT_TIME, x"EF");
    wait until (int2 = '1');
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    writeline (results, TX_OUT);
    -- Dump all of the registers at the end of the test
    report_all_registers;
    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);

    ---------------------------------------------------------------------------
    -- Testing slave mask.
    ---------------------------------------------------------------------------
    current_test <= Test_11;
    write_register1(REG_STATUS1, "10100000");
    write_register2(REG_STATUS1, "10100001");
    -- Set up node 2 to only pay attention to address 0x10 through 0x13
    write_register2(REG_SLAVE_ID_MASK, "11111100");
    write_register2(REG_SLAVE_ID_FILTER, x"10");

    write (TX_OUT, string'(""));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("*** Test 11: Parity mask/filter"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("***********************************************"));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Sending ID 11 - Node 1 sends data CC CC.  Node 2 should not ignore this frame."));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Received (controller 2): "));
    -- Send from unit 1
    write_register1(REG_TRANSMIT, x"11");
    wait for 40*BIT_TIME;
    read_register1(REG_RECEIVE, data_read);
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    write_register1(REG_TRANSMIT, x"CC");
    wait for 12*BIT_TIME;
    read_register1(REG_RECEIVE, data_read);
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    write_register1(REG_TRANSMIT, x"CC");
    wait for 12*BIT_TIME;
    read_register1(REG_RECEIVE, data_read);
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    -- Receive the checksum (final byte)
    wait for 12*BIT_TIME;
    read_register1(REG_RECEIVE, data_read);
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'("."));
    writeline (results, TX_OUT);

    -- Now send bytes on ID 0x15 (out of range of the filter)
    write (TX_OUT, string'("Sending ID 15 - Node 1 sends data CC CC.  Node 2 should ignore this frame."));
    writeline (results, TX_OUT);
    write (TX_OUT, string'("Received (controller 2): "));
    -- Send from unit 1
    write_register1(REG_TRANSMIT, x"15");
    wait for 40*BIT_TIME;
    read_register1(REG_RECEIVE, data_read);
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    write_register1(REG_TRANSMIT, x"CC");
    wait for 12*BIT_TIME;
    read_register1(REG_RECEIVE, data_read);
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    write_register1(REG_TRANSMIT, x"CC");
    wait for 12*BIT_TIME;
    read_register1(REG_RECEIVE, data_read);
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'(" "));
    -- Receive the checksum (final byte)
    wait for 12*BIT_TIME;
    read_register1(REG_RECEIVE, data_read);
    read_register2(REG_RECEIVE, data_read);
    write (TX_OUT, slv2hex(data_read));
    write (TX_OUT, string'("."));
    writeline (results, TX_OUT);
    -- Dump all of the registers at the end of the test
    report_all_registers;
    write (TX_OUT, string'(""));
   writeline (results, TX_OUT);
    -- Set the mask and filter back to default
    write_register2(REG_SLAVE_ID_MASK, x"00");
    write_register2(REG_SLAVE_ID_FILTER, x"00");


		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION lin_network_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END lin_network_cfg;
