library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

-- Uncomment the following lines to use the declarations that are
-- provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity lin_transceiver is
  port (
    TxD     : in    std_logic;
    RxD     : out   std_logic;
    lin_bus : inout std_logic
  );
end lin_transceiver;

architecture Dataflow of lin_transceiver is
begin
  -- Lin bus is modeled with a weak high, pulled low.
  lin_bus <= 'H' when TxD = '1' else
             '0' when TxD = '0';
  RxD <= '1' when (lin_bus = 'H' or lin_bus = '1') else
         '0' when (lin_bus = 'L' or lin_bus = '0') else
         '1';
end Dataflow;                        
