-- C:\RESEARCH\LIN_CONTROLLER
-- VHDL Test Bench created by
-- HDL Bencher 5.1i
-- Mon Jul 21 16:36:28 2003
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.all;
USE IEEE.STD_LOGIC_ARITH.all;
USE IEEE.STD_LOGIC_UNSIGNED.all;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT majority_sampler
		PORT (
			clk : in  STD_LOGIC;
			rst : in  STD_LOGIC;
			data : in  STD_LOGIC;
			dout : out  STD_LOGIC
		);
	END COMPONENT;

	SIGNAL clk : STD_LOGIC;
	SIGNAL rst : STD_LOGIC;
	SIGNAL data : STD_LOGIC;
	SIGNAL dout : STD_LOGIC;

BEGIN
	UUT : majority_sampler
	PORT MAP (
		clk => clk,
		rst => rst,
		data => data,
		dout => dout
	);

	PROCESS -- clock process for clk,
	BEGIN
		CLOCK_LOOP : LOOP
		clk <= transport '0';
		WAIT FOR 10 ns;
		clk <= transport '1';
		WAIT FOR 10 ns;
		WAIT FOR 40 ns;
		clk <= transport '0';
		WAIT FOR 40 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

	PROCESS   -- Process for clk
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_dout(
			next_dout : STD_LOGIC;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (dout /= next_dout) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns dout="));
				write(TX_LOC, dout);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_dout);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		rst <= transport '1';
		data <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=100 ns
		rst <= transport '0';
		-- --------------------
		WAIT FOR 200 ns; -- Time=300 ns
		data <= transport '1';
		-- --------------------
		WAIT FOR 500 ns; -- Time=800 ns
		data <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=900 ns
		data <= transport '1';
		-- --------------------
		WAIT FOR 600 ns; -- Time=1500 ns
		data <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=1600 ns
		data <= transport '1';
		-- --------------------
		WAIT FOR 1200 ns; -- Time=2800 ns
		data <= transport '0';
		-- --------------------
		WAIT FOR 3300 ns; -- Time=6100 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION majority_sampler_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END majority_sampler_cfg;
