-- Xilinx Vhdl produced by program ngd2vhdl F.28
-- Command: -rpw 100 -ar Structure -xon true -w -log __projnav/ngd2vhdl.log majority_sampler.nga majority_sampler_timesim.vhd 
-- Input file: majority_sampler.nga
-- Output file: majority_sampler_timesim.vhd
-- Design name: majority_sampler
-- Xilinx: C:/Xilinx
-- # of Entities: 1
-- Device: XC2C256-7-TQ144

-- The output of ngd2vhdl is a simulation model. This file cannot be synthesized,
-- or used in any other manner other than simulation. This netlist uses simulation
-- primitives which may not represent the true implementation of the device, however
-- the netlist is functionally correct. Do not modify this file.

-- Model for  ROC (Reset-On-Configuration) Cell
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.VITAL_Timing.all;
entity ROC is
  generic (InstancePath: STRING := "*";
           WIDTH : Time := 100 ns);
  port(O : out std_ulogic := '1') ;
  attribute VITAL_LEVEL0 of ROC : entity is TRUE;
end ROC;

architecture ROC_V of ROC is
attribute VITAL_LEVEL0 of ROC_V : architecture is TRUE;
begin
  ONE_SHOT : process
  begin
    if (WIDTH <= 0 ns) then
       assert FALSE report
       "*** Error: a positive value of WIDTH must be specified ***"
       severity failure;
    else
       wait for WIDTH;
       O <= '0';
    end if;
    wait;
  end process ONE_SHOT;
end ROC_V;

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library SIMPRIM;
use SIMPRIM.VCOMPONENTS.ALL;
use SIMPRIM.VPACKAGE.ALL;
entity majority_sampler is
  port (
    clk : in STD_LOGIC := 'X'; 
    clr : in STD_LOGIC := 'X'; 
    input : in STD_LOGIC := 'X'; 
    rst : in STD_LOGIC := 'X'; 
    output : out STD_LOGIC 
  );
end majority_sampler;

architecture Structure of majority_sampler is
  component ROC
    generic (InstancePath: STRING := "*";
             WIDTH : Time := 100 ns);
    port (O : out STD_ULOGIC := '1');
  end component;
  signal output_MC_Q : STD_LOGIC; 
  signal output_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal rst_II_FSR : STD_LOGIC; 
  signal output_MC_R_OR_PRLD : STD_LOGIC; 
  signal output_MC_D : STD_LOGIC; 
  signal clk_II_FCLK : STD_LOGIC; 
  signal output_MC_D1 : STD_LOGIC; 
  signal clr_II_UIM : STD_LOGIC; 
  signal output_MC_UIM : STD_LOGIC; 
  signal output_MC_D2_PT_0 : STD_LOGIC; 
  signal input_II_UIM : STD_LOGIC; 
  signal output_MC_D2_PT_1 : STD_LOGIC; 
  signal output_MC_D2_PT_2 : STD_LOGIC; 
  signal output_MC_D2 : STD_LOGIC; 
  signal output_MC_D_TFF : STD_LOGIC; 
  signal num_0_MC_Q : STD_LOGIC; 
  signal num_0_MC_R_OR_PRLD : STD_LOGIC; 
  signal num_0_MC_D : STD_LOGIC; 
  signal num_0_MC_D1 : STD_LOGIC; 
  signal num_0_MC_D2_PT_0 : STD_LOGIC; 
  signal num_0_MC_D2_PT_1 : STD_LOGIC; 
  signal num_0_MC_D2_PT_2 : STD_LOGIC; 
  signal num_0_MC_D2 : STD_LOGIC; 
  signal num_0_MC_D_TFF : STD_LOGIC; 
  signal num_1_MC_Q : STD_LOGIC; 
  signal num_1_MC_R_OR_PRLD : STD_LOGIC; 
  signal num_1_MC_D : STD_LOGIC; 
  signal num_1_MC_D1_PT_0 : STD_LOGIC; 
  signal num_1_MC_D1 : STD_LOGIC; 
  signal num_1_MC_D2_PT_0 : STD_LOGIC; 
  signal num_1_MC_D2_PT_1 : STD_LOGIC; 
  signal num_1_MC_D2_PT_2 : STD_LOGIC; 
  signal num_1_MC_D2_PT_3 : STD_LOGIC; 
  signal num_1_MC_D2 : STD_LOGIC; 
  signal num_2_MC_Q : STD_LOGIC; 
  signal num_2_MC_R_OR_PRLD : STD_LOGIC; 
  signal num_2_MC_D : STD_LOGIC; 
  signal num_2_MC_D1 : STD_LOGIC; 
  signal num_2_MC_D2_PT_0 : STD_LOGIC; 
  signal num_2_MC_D2_PT_1 : STD_LOGIC; 
  signal num_2_MC_D2_PT_2 : STD_LOGIC; 
  signal num_2_MC_D2_PT_3 : STD_LOGIC; 
  signal num_2_MC_D2_PT_4 : STD_LOGIC; 
  signal num_2_MC_D2 : STD_LOGIC; 
  signal num_2_MC_D_TFF : STD_LOGIC; 
  signal VCC : STD_LOGIC; 
  signal GND : STD_LOGIC; 
  signal PRLD : STD_LOGIC; 
  signal NlwInverterSignal_output_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_output_MC_D2_PT_1_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_output_MC_D2_PT_1_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_output_MC_D2_PT_1_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_output_MC_D2_PT_2_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_output_MC_D2_PT_2_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_num_0_MC_D2_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_num_0_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_num_0_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_num_0_MC_D2_PT_1_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_num_0_MC_D2_PT_1_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_num_0_MC_D2_PT_1_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_num_0_MC_D2_PT_2_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_num_0_MC_XOR_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_num_1_MC_D1_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_num_1_MC_D1_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_num_1_MC_D2_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_num_1_MC_D2_PT_0_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_num_1_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_num_1_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_num_1_MC_D2_PT_2_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_num_1_MC_D2_PT_3_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_num_1_MC_D2_PT_3_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_num_1_MC_D2_PT_3_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_num_1_MC_D2_PT_3_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_num_1_MC_D2_PT_3_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_num_2_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_num_2_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_num_2_MC_D2_PT_1_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_num_2_MC_D2_PT_2_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_num_2_MC_D2_PT_2_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_num_2_MC_D2_PT_3_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_num_2_MC_D2_PT_3_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_num_2_MC_D2_PT_3_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_num_2_MC_D2_PT_3_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_num_2_MC_D2_PT_4_IN1 : STD_LOGIC; 
  signal num : STD_LOGIC_VECTOR ( 2 downto 0 ); 
begin
  output_0 : X_BUF
    port map (
      I => output_MC_Q,
      O => output
    );
  output_MC_Q_1 : X_BUF
    port map (
      I => output_MC_Q_tsim_ireg_Q,
      O => output_MC_Q
    );
  output_MC_R_OR_PRLD_2 : X_OR2
    port map (
      I0 => rst_II_FSR,
      I1 => PRLD,
      O => output_MC_R_OR_PRLD
    );
  output_MC_REG : X_FF
    port map (
      I => output_MC_D,
      CE => VCC,
      CLK => clk_II_FCLK,
      SET => GND,
      RST => output_MC_R_OR_PRLD,
      O => output_MC_Q_tsim_ireg_Q
    );
  VCC_ONE : X_ONE
    port map (
      O => VCC
    );
  GND_ZERO : X_ZERO
    port map (
      O => GND
    );
  output_MC_D1_3 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => output_MC_D1
    );
  output_MC_D2_PT_0_4 : X_AND2
    port map (
      I0 => clr_II_UIM,
      I1 => output_MC_UIM,
      O => output_MC_D2_PT_0
    );
  output_MC_D2_PT_1_5 : X_AND5
    port map (
      I0 => NlwInverterSignal_output_MC_D2_PT_1_IN0,
      I1 => output_MC_UIM,
      I2 => NlwInverterSignal_output_MC_D2_PT_1_IN2,
      I3 => NlwInverterSignal_output_MC_D2_PT_1_IN3,
      I4 => NlwInverterSignal_output_MC_D2_PT_1_IN4,
      O => output_MC_D2_PT_1
    );
  output_MC_D2_PT_2_6 : X_AND6
    port map (
      I0 => NlwInverterSignal_output_MC_D2_PT_2_IN0,
      I1 => input_II_UIM,
      I2 => NlwInverterSignal_output_MC_D2_PT_2_IN2,
      I3 => num(0),
      I4 => num(1),
      I5 => num(2),
      O => output_MC_D2_PT_2
    );
  output_MC_D2_7 : X_OR3
    port map (
      I0 => output_MC_D2_PT_0,
      I1 => output_MC_D2_PT_1,
      I2 => output_MC_D2_PT_2,
      O => output_MC_D2
    );
  output_MC_D_8 : X_XOR2
    port map (
      I0 => output_MC_D_TFF,
      I1 => output_MC_Q,
      O => output_MC_D
    );
  output_MC_XOR : X_XOR2
    port map (
      I0 => output_MC_D1,
      I1 => output_MC_D2,
      O => output_MC_D_TFF
    );
  output_MC_UIM_9 : X_BUF
    port map (
      I => output_MC_Q_tsim_ireg_Q,
      O => output_MC_UIM
    );
  clr_II_UIM_10 : X_BUF
    port map (
      I => clr,
      O => clr_II_UIM
    );
  input_II_UIM_11 : X_BUF
    port map (
      I => input,
      O => input_II_UIM
    );
  num_0_Q : X_BUF
    port map (
      I => num_0_MC_Q,
      O => num(0)
    );
  num_0_MC_R_OR_PRLD_12 : X_OR2
    port map (
      I0 => rst_II_FSR,
      I1 => PRLD,
      O => num_0_MC_R_OR_PRLD
    );
  num_0_MC_REG : X_FF
    port map (
      I => num_0_MC_D,
      CE => VCC,
      CLK => clk_II_FCLK,
      SET => GND,
      RST => num_0_MC_R_OR_PRLD,
      O => num_0_MC_Q
    );
  num_0_MC_D1_13 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => num_0_MC_D1
    );
  num_0_MC_D2_PT_0_14 : X_AND2
    port map (
      I0 => clr_II_UIM,
      I1 => NlwInverterSignal_num_0_MC_D2_PT_0_IN1,
      O => num_0_MC_D2_PT_0
    );
  num_0_MC_D2_PT_1_15 : X_AND5
    port map (
      I0 => NlwInverterSignal_num_0_MC_D2_PT_1_IN0,
      I1 => NlwInverterSignal_num_0_MC_D2_PT_1_IN1,
      I2 => NlwInverterSignal_num_0_MC_D2_PT_1_IN2,
      I3 => NlwInverterSignal_num_0_MC_D2_PT_1_IN3,
      I4 => NlwInverterSignal_num_0_MC_D2_PT_1_IN4,
      O => num_0_MC_D2_PT_1
    );
  num_0_MC_D2_PT_2_16 : X_AND6
    port map (
      I0 => NlwInverterSignal_num_0_MC_D2_PT_2_IN0,
      I1 => input_II_UIM,
      I2 => output_MC_UIM,
      I3 => num(0),
      I4 => num(1),
      I5 => num(2),
      O => num_0_MC_D2_PT_2
    );
  num_0_MC_D2_17 : X_OR3
    port map (
      I0 => num_0_MC_D2_PT_0,
      I1 => num_0_MC_D2_PT_1,
      I2 => num_0_MC_D2_PT_2,
      O => num_0_MC_D2
    );
  num_0_MC_D_18 : X_XOR2
    port map (
      I0 => num_0_MC_D_TFF,
      I1 => num_0_MC_Q,
      O => num_0_MC_D
    );
  num_0_MC_XOR : X_XOR2
    port map (
      I0 => NlwInverterSignal_num_0_MC_XOR_IN0,
      I1 => num_0_MC_D2,
      O => num_0_MC_D_TFF
    );
  num_1_Q : X_BUF
    port map (
      I => num_1_MC_Q,
      O => num(1)
    );
  num_1_MC_R_OR_PRLD_19 : X_OR2
    port map (
      I0 => rst_II_FSR,
      I1 => PRLD,
      O => num_1_MC_R_OR_PRLD
    );
  num_1_MC_REG : X_FF
    port map (
      I => num_1_MC_D,
      CE => VCC,
      CLK => clk_II_FCLK,
      SET => GND,
      RST => num_1_MC_R_OR_PRLD,
      O => num_1_MC_Q
    );
  num_1_MC_D1_PT_0_20 : X_AND2
    port map (
      I0 => NlwInverterSignal_num_1_MC_D1_PT_0_IN0,
      I1 => NlwInverterSignal_num_1_MC_D1_PT_0_IN1,
      O => num_1_MC_D1_PT_0
    );
  num_1_MC_D1_21 : X_OR2
    port map (
      I0 => num_1_MC_D1_PT_0,
      I1 => num_1_MC_D1_PT_0,
      O => num_1_MC_D1
    );
  num_1_MC_D2_PT_0_22 : X_AND3
    port map (
      I0 => NlwInverterSignal_num_1_MC_D2_PT_0_IN0,
      I1 => num(0),
      I2 => NlwInverterSignal_num_1_MC_D2_PT_0_IN2,
      O => num_1_MC_D2_PT_0
    );
  num_1_MC_D2_PT_1_23 : X_AND3
    port map (
      I0 => NlwInverterSignal_num_1_MC_D2_PT_1_IN0,
      I1 => NlwInverterSignal_num_1_MC_D2_PT_1_IN1,
      I2 => num(1),
      O => num_1_MC_D2_PT_1
    );
  num_1_MC_D2_PT_2_24 : X_AND5
    port map (
      I0 => NlwInverterSignal_num_1_MC_D2_PT_2_IN0,
      I1 => input_II_UIM,
      I2 => output_MC_UIM,
      I3 => num(1),
      I4 => num(2),
      O => num_1_MC_D2_PT_2
    );
  num_1_MC_D2_PT_3_25 : X_AND5
    port map (
      I0 => NlwInverterSignal_num_1_MC_D2_PT_3_IN0,
      I1 => NlwInverterSignal_num_1_MC_D2_PT_3_IN1,
      I2 => NlwInverterSignal_num_1_MC_D2_PT_3_IN2,
      I3 => NlwInverterSignal_num_1_MC_D2_PT_3_IN3,
      I4 => NlwInverterSignal_num_1_MC_D2_PT_3_IN4,
      O => num_1_MC_D2_PT_3
    );
  num_1_MC_D2_26 : X_OR4
    port map (
      I0 => num_1_MC_D2_PT_0,
      I1 => num_1_MC_D2_PT_1,
      I2 => num_1_MC_D2_PT_2,
      I3 => num_1_MC_D2_PT_3,
      O => num_1_MC_D2
    );
  num_1_MC_XOR : X_XOR2
    port map (
      I0 => num_1_MC_D1,
      I1 => num_1_MC_D2,
      O => num_1_MC_D
    );
  num_2_Q : X_BUF
    port map (
      I => num_2_MC_Q,
      O => num(2)
    );
  num_2_MC_R_OR_PRLD_27 : X_OR2
    port map (
      I0 => rst_II_FSR,
      I1 => PRLD,
      O => num_2_MC_R_OR_PRLD
    );
  num_2_MC_REG : X_FF
    port map (
      I => num_2_MC_D,
      CE => VCC,
      CLK => clk_II_FCLK,
      SET => GND,
      RST => num_2_MC_R_OR_PRLD,
      O => num_2_MC_Q
    );
  num_2_MC_D1_28 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => num_2_MC_D1
    );
  num_2_MC_D2_PT_0_29 : X_AND2
    port map (
      I0 => clr_II_UIM,
      I1 => num(2),
      O => num_2_MC_D2_PT_0
    );
  num_2_MC_D2_PT_1_30 : X_AND4
    port map (
      I0 => NlwInverterSignal_num_2_MC_D2_PT_1_IN0,
      I1 => NlwInverterSignal_num_2_MC_D2_PT_1_IN1,
      I2 => NlwInverterSignal_num_2_MC_D2_PT_1_IN2,
      I3 => num(2),
      O => num_2_MC_D2_PT_1
    );
  num_2_MC_D2_PT_2_31 : X_AND5
    port map (
      I0 => NlwInverterSignal_num_2_MC_D2_PT_2_IN0,
      I1 => input_II_UIM,
      I2 => num(0),
      I3 => num(1),
      I4 => NlwInverterSignal_num_2_MC_D2_PT_2_IN4,
      O => num_2_MC_D2_PT_2
    );
  num_2_MC_D2_PT_3_32 : X_AND5
    port map (
      I0 => NlwInverterSignal_num_2_MC_D2_PT_3_IN0,
      I1 => NlwInverterSignal_num_2_MC_D2_PT_3_IN1,
      I2 => output_MC_UIM,
      I3 => NlwInverterSignal_num_2_MC_D2_PT_3_IN3,
      I4 => NlwInverterSignal_num_2_MC_D2_PT_3_IN4,
      O => num_2_MC_D2_PT_3
    );
  num_2_MC_D2_PT_4_33 : X_AND5
    port map (
      I0 => input_II_UIM,
      I1 => NlwInverterSignal_num_2_MC_D2_PT_4_IN1,
      I2 => num(0),
      I3 => num(1),
      I4 => num(2),
      O => num_2_MC_D2_PT_4
    );
  num_2_MC_D2_34 : X_OR5
    port map (
      I0 => num_2_MC_D2_PT_0,
      I1 => num_2_MC_D2_PT_1,
      I2 => num_2_MC_D2_PT_2,
      I3 => num_2_MC_D2_PT_3,
      I4 => num_2_MC_D2_PT_4,
      O => num_2_MC_D2
    );
  num_2_MC_D_35 : X_XOR2
    port map (
      I0 => num_2_MC_D_TFF,
      I1 => num_2_MC_Q,
      O => num_2_MC_D
    );
  num_2_MC_XOR : X_XOR2
    port map (
      I0 => num_2_MC_D1,
      I1 => num_2_MC_D2,
      O => num_2_MC_D_TFF
    );
  clk_II_FCLK_36 : X_BUF
    port map (
      I => clk,
      O => clk_II_FCLK
    );
  rst_II_FSR_37 : X_BUF
    port map (
      I => rst,
      O => rst_II_FSR
    );
  NlwInverterBlock_output_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => input_II_UIM,
      O => NlwInverterSignal_output_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_output_MC_D2_PT_1_IN2 : X_INV
    port map (
      I => num(0),
      O => NlwInverterSignal_output_MC_D2_PT_1_IN2
    );
  NlwInverterBlock_output_MC_D2_PT_1_IN3 : X_INV
    port map (
      I => num(1),
      O => NlwInverterSignal_output_MC_D2_PT_1_IN3
    );
  NlwInverterBlock_output_MC_D2_PT_1_IN4 : X_INV
    port map (
      I => num(2),
      O => NlwInverterSignal_output_MC_D2_PT_1_IN4
    );
  NlwInverterBlock_output_MC_D2_PT_2_IN0 : X_INV
    port map (
      I => clr_II_UIM,
      O => NlwInverterSignal_output_MC_D2_PT_2_IN0
    );
  NlwInverterBlock_output_MC_D2_PT_2_IN2 : X_INV
    port map (
      I => output_MC_UIM,
      O => NlwInverterSignal_output_MC_D2_PT_2_IN2
    );
  NlwInverterBlock_num_0_MC_D2_PT_0_IN1 : X_INV
    port map (
      I => num(0),
      O => NlwInverterSignal_num_0_MC_D2_PT_0_IN1
    );
  NlwInverterBlock_num_0_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => input_II_UIM,
      O => NlwInverterSignal_num_0_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_num_0_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => output_MC_UIM,
      O => NlwInverterSignal_num_0_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_num_0_MC_D2_PT_1_IN2 : X_INV
    port map (
      I => num(0),
      O => NlwInverterSignal_num_0_MC_D2_PT_1_IN2
    );
  NlwInverterBlock_num_0_MC_D2_PT_1_IN3 : X_INV
    port map (
      I => num(1),
      O => NlwInverterSignal_num_0_MC_D2_PT_1_IN3
    );
  NlwInverterBlock_num_0_MC_D2_PT_1_IN4 : X_INV
    port map (
      I => num(2),
      O => NlwInverterSignal_num_0_MC_D2_PT_1_IN4
    );
  NlwInverterBlock_num_0_MC_D2_PT_2_IN0 : X_INV
    port map (
      I => clr_II_UIM,
      O => NlwInverterSignal_num_0_MC_D2_PT_2_IN0
    );
  NlwInverterBlock_num_0_MC_XOR_IN0 : X_INV
    port map (
      I => num_0_MC_D1,
      O => NlwInverterSignal_num_0_MC_XOR_IN0
    );
  NlwInverterBlock_num_1_MC_D1_PT_0_IN0 : X_INV
    port map (
      I => clr_II_UIM,
      O => NlwInverterSignal_num_1_MC_D1_PT_0_IN0
    );
  NlwInverterBlock_num_1_MC_D1_PT_0_IN1 : X_INV
    port map (
      I => input_II_UIM,
      O => NlwInverterSignal_num_1_MC_D1_PT_0_IN1
    );
  NlwInverterBlock_num_1_MC_D2_PT_0_IN0 : X_INV
    port map (
      I => clr_II_UIM,
      O => NlwInverterSignal_num_1_MC_D2_PT_0_IN0
    );
  NlwInverterBlock_num_1_MC_D2_PT_0_IN2 : X_INV
    port map (
      I => num(1),
      O => NlwInverterSignal_num_1_MC_D2_PT_0_IN2
    );
  NlwInverterBlock_num_1_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => clr_II_UIM,
      O => NlwInverterSignal_num_1_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_num_1_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => num(0),
      O => NlwInverterSignal_num_1_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_num_1_MC_D2_PT_2_IN0 : X_INV
    port map (
      I => clr_II_UIM,
      O => NlwInverterSignal_num_1_MC_D2_PT_2_IN0
    );
  NlwInverterBlock_num_1_MC_D2_PT_3_IN0 : X_INV
    port map (
      I => clr_II_UIM,
      O => NlwInverterSignal_num_1_MC_D2_PT_3_IN0
    );
  NlwInverterBlock_num_1_MC_D2_PT_3_IN1 : X_INV
    port map (
      I => input_II_UIM,
      O => NlwInverterSignal_num_1_MC_D2_PT_3_IN1
    );
  NlwInverterBlock_num_1_MC_D2_PT_3_IN2 : X_INV
    port map (
      I => output_MC_UIM,
      O => NlwInverterSignal_num_1_MC_D2_PT_3_IN2
    );
  NlwInverterBlock_num_1_MC_D2_PT_3_IN3 : X_INV
    port map (
      I => num(0),
      O => NlwInverterSignal_num_1_MC_D2_PT_3_IN3
    );
  NlwInverterBlock_num_1_MC_D2_PT_3_IN4 : X_INV
    port map (
      I => num(2),
      O => NlwInverterSignal_num_1_MC_D2_PT_3_IN4
    );
  NlwInverterBlock_num_2_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => input_II_UIM,
      O => NlwInverterSignal_num_2_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_num_2_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => num(0),
      O => NlwInverterSignal_num_2_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_num_2_MC_D2_PT_1_IN2 : X_INV
    port map (
      I => num(1),
      O => NlwInverterSignal_num_2_MC_D2_PT_1_IN2
    );
  NlwInverterBlock_num_2_MC_D2_PT_2_IN0 : X_INV
    port map (
      I => clr_II_UIM,
      O => NlwInverterSignal_num_2_MC_D2_PT_2_IN0
    );
  NlwInverterBlock_num_2_MC_D2_PT_2_IN4 : X_INV
    port map (
      I => num(2),
      O => NlwInverterSignal_num_2_MC_D2_PT_2_IN4
    );
  NlwInverterBlock_num_2_MC_D2_PT_3_IN0 : X_INV
    port map (
      I => clr_II_UIM,
      O => NlwInverterSignal_num_2_MC_D2_PT_3_IN0
    );
  NlwInverterBlock_num_2_MC_D2_PT_3_IN1 : X_INV
    port map (
      I => input_II_UIM,
      O => NlwInverterSignal_num_2_MC_D2_PT_3_IN1
    );
  NlwInverterBlock_num_2_MC_D2_PT_3_IN3 : X_INV
    port map (
      I => num(0),
      O => NlwInverterSignal_num_2_MC_D2_PT_3_IN3
    );
  NlwInverterBlock_num_2_MC_D2_PT_3_IN4 : X_INV
    port map (
      I => num(1),
      O => NlwInverterSignal_num_2_MC_D2_PT_3_IN4
    );
  NlwInverterBlock_num_2_MC_D2_PT_4_IN1 : X_INV
    port map (
      I => output_MC_UIM,
      O => NlwInverterSignal_num_2_MC_D2_PT_4_IN1
    );
  NlwBlockROC : ROC generic map ( WIDTH => 100 ns)
     port map (O => PRLD);
end Structure;

