-- C:\RESEARCH\LIN_CONTROLLER
-- VHDL Test Bench created by
-- HDL Bencher 5.1i
-- Mon Jul 21 16:37:46 2003
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.all;
USE IEEE.STD_LOGIC_ARITH.all;
USE IEEE.STD_LOGIC_UNSIGNED.all;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT parity_generator
		PORT (
			data : in  STD_LOGIC_VECTOR (5 DOWNTO 0);
			PR1 : out  STD_LOGIC;
			PR0 : out  STD_LOGIC
		);
	END COMPONENT;

	SIGNAL data : STD_LOGIC_VECTOR (5 DOWNTO 0);
	SIGNAL PR1 : STD_LOGIC;
	SIGNAL PR0 : STD_LOGIC;

BEGIN
	UUT : parity_generator
	PORT MAP (
		data => data,
		PR1 => PR1,
		PR0 => PR0
	);

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_PR1(
			next_PR1 : STD_LOGIC;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (PR1 /= next_PR1) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns PR1="));
				write(TX_LOC, PR1);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_PR1);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_PR0(
			next_PR0 : STD_LOGIC;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (PR0 /= next_PR0) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns PR0="));
				write(TX_LOC, PR0);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_PR0);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		data <= transport STD_LOGIC_VECTOR'("000001"); --1
		-- --------------------
		WAIT FOR 100 ns; -- Time=100 ns
		data <= transport STD_LOGIC_VECTOR'("000010"); --2
		-- --------------------
		WAIT FOR 100 ns; -- Time=200 ns
		data <= transport STD_LOGIC_VECTOR'("000100"); --4
		-- --------------------
		WAIT FOR 100 ns; -- Time=300 ns
		data <= transport STD_LOGIC_VECTOR'("000110"); --6
		-- --------------------
		WAIT FOR 100 ns; -- Time=400 ns
		data <= transport STD_LOGIC_VECTOR'("001010"); --A
		-- --------------------
		WAIT FOR 100 ns; -- Time=500 ns
		data <= transport STD_LOGIC_VECTOR'("010000"); --10
		-- --------------------
		WAIT FOR 100 ns; -- Time=600 ns
		data <= transport STD_LOGIC_VECTOR'("101010"); --2A
		-- --------------------
		WAIT FOR 100 ns; -- Time=700 ns
		data <= transport STD_LOGIC_VECTOR'("110111"); --37
		-- --------------------
		WAIT FOR 100 ns; -- Time=800 ns
		data <= transport STD_LOGIC_VECTOR'("100000"); --20
		-- --------------------
		WAIT FOR 100 ns; -- Time=900 ns
		data <= transport STD_LOGIC_VECTOR'("111111"); --3F
		-- --------------------
		WAIT FOR 150 ns; -- Time=1050 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION parity_generator_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END parity_generator_cfg;
