-- Xilinx Vhdl produced by program ngd2vhdl F.28
-- Command: -rpw 100 -ar Structure -xon true -w -log __projnav/ngd2vhdl.log core_state_machine.nga core_state_machine_timesim.vhd 
-- Input file: core_state_machine.nga
-- Output file: core_state_machine_timesim.vhd
-- Design name: core_state_machine
-- Xilinx: C:/Xilinx
-- # of Entities: 1
-- Device: XC2C256-7-TQ144

-- The output of ngd2vhdl is a simulation model. This file cannot be synthesized,
-- or used in any other manner other than simulation. This netlist uses simulation
-- primitives which may not represent the true implementation of the device, however
-- the netlist is functionally correct. Do not modify this file.

-- Model for  ROC (Reset-On-Configuration) Cell
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.VITAL_Timing.all;
entity ROC is
  generic (InstancePath: STRING := "*";
           WIDTH : Time := 100 ns);
  port(O : out std_ulogic := '1') ;
  attribute VITAL_LEVEL0 of ROC : entity is TRUE;
end ROC;

architecture ROC_V of ROC is
attribute VITAL_LEVEL0 of ROC_V : architecture is TRUE;
begin
  ONE_SHOT : process
  begin
    if (WIDTH <= 0 ns) then
       assert FALSE report
       "*** Error: a positive value of WIDTH must be specified ***"
       severity failure;
    else
       wait for WIDTH;
       O <= '0';
    end if;
    wait;
  end process ONE_SHOT;
end ROC_V;

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library SIMPRIM;
use SIMPRIM.VCOMPONENTS.ALL;
use SIMPRIM.VPACKAGE.ALL;
entity core_state_machine is
  port (
    bitclk : in STD_LOGIC := 'X'; 
    receiver_done : in STD_LOGIC := 'X'; 
    ser_in : in STD_LOGIC := 'X'; 
    transmitter_done : in STD_LOGIC := 'X'; 
    pr0 : in STD_LOGIC := 'X'; 
    pr1 : in STD_LOGIC := 'X'; 
    clk : in STD_LOGIC := 'X'; 
    rst : in STD_LOGIC := 'X'; 
    checksum_done : out STD_LOGIC; 
    checksum_en : out STD_LOGIC; 
    receiver_rst : out STD_LOGIC; 
    transmitter_rst : out STD_LOGIC; 
    cfg_receive_mask : in STD_LOGIC_VECTOR ( 5 downto 0 ); 
    cfg_response_mask : in STD_LOGIC_VECTOR ( 5 downto 0 ); 
    checksum : in STD_LOGIC_VECTOR ( 7 downto 0 ); 
    receiver_sr : in STD_LOGIC_VECTOR ( 7 downto 0 ); 
    parity_check : out STD_LOGIC_VECTOR ( 5 downto 0 ); 
    receive : out STD_LOGIC_VECTOR ( 7 downto 0 ); 
    snoop_cur_state : out STD_LOGIC_VECTOR ( 3 downto 0 ); 
    statuses : out STD_LOGIC_VECTOR ( 2 downto 0 ); 
    transmit : in STD_LOGIC_VECTOR ( 7 downto 0 ); 
    transmitter_sr : out STD_LOGIC_VECTOR ( 7 downto 0 ) 
  );
end core_state_machine;

architecture Structure of core_state_machine is
  component ROC
    generic (InstancePath: STRING := "*";
             WIDTH : Time := 100 ns);
    port (O : out STD_ULOGIC := '1');
  end component;
  signal checksum_done_MC_Q : STD_LOGIC; 
  signal checksum_done_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal checksum_done_MC_D : STD_LOGIC; 
  signal checksum_done_MC_D1 : STD_LOGIC; 
  signal receiver_done_II_UIM : STD_LOGIC; 
  signal slave_cur_state_ffd2 : STD_LOGIC; 
  signal slave_cur_state_ffd4 : STD_LOGIC; 
  signal slave_cur_state_ffd3 : STD_LOGIC; 
  signal slave_cur_state_ffd1 : STD_LOGIC; 
  signal Q_n0060 : STD_LOGIC; 
  signal checksum_done_MC_D2_PT_0 : STD_LOGIC; 
  signal transmitter_done_II_UIM : STD_LOGIC; 
  signal checksum_done_MC_D2_PT_1 : STD_LOGIC; 
  signal checksum_done_MC_D2 : STD_LOGIC; 
  signal byte_counter_0_MC_Q : STD_LOGIC; 
  signal rst_II_FSR : STD_LOGIC; 
  signal byte_counter_0_MC_R_OR_PRLD : STD_LOGIC; 
  signal byte_counter_0_MC_D : STD_LOGIC; 
  signal clk_II_FCLK : STD_LOGIC; 
  signal byte_counter_0_MC_D1 : STD_LOGIC; 
  signal byte_counter_0_MC_D2_PT_0 : STD_LOGIC; 
  signal byte_counter_0_MC_D2_PT_1 : STD_LOGIC; 
  signal byte_counter_0_MC_D2 : STD_LOGIC; 
  signal byte_counter_0_MC_D_TFF : STD_LOGIC; 
  signal slave_cur_state_ffd2_MC_Q : STD_LOGIC; 
  signal slave_cur_state_ffd2_MC_R_OR_PRLD : STD_LOGIC; 
  signal slave_cur_state_ffd2_MC_D : STD_LOGIC; 
  signal slave_cur_state_ffd2_MC_D1 : STD_LOGIC; 
  signal N_PZ_231 : STD_LOGIC; 
  signal slave_cur_state_ffd2_MC_D2_PT_0 : STD_LOGIC; 
  signal slave_cur_state_xx_ffd228 : STD_LOGIC; 
  signal slave_cur_state_ffd2_MC_D2_PT_1 : STD_LOGIC; 
  signal slave_cur_state_ffd2_MC_D2_PT_2 : STD_LOGIC; 
  signal Q_n0098 : STD_LOGIC; 
  signal slave_cur_state_ffd2_MC_D2_PT_3 : STD_LOGIC; 
  signal transmitter_rst_MC_UIM : STD_LOGIC; 
  signal slave_cur_state_ffd2_MC_D2_PT_4 : STD_LOGIC; 
  signal ser_in_II_UIM : STD_LOGIC; 
  signal slave_cur_state_ffd2_MC_D2_PT_5 : STD_LOGIC; 
  signal slave_cur_state_ffd2_MC_D2_PT_6 : STD_LOGIC; 
  signal slave_cur_state_ffd2_MC_D2_PT_7 : STD_LOGIC; 
  signal slave_cur_state_ffd2_MC_D2_PT_8 : STD_LOGIC; 
  signal slave_cur_state_ffd2_MC_D2_PT_9 : STD_LOGIC; 
  signal slave_cur_state_ffd2_MC_D2 : STD_LOGIC; 
  signal N_PZ_231_MC_Q : STD_LOGIC; 
  signal N_PZ_231_MC_D : STD_LOGIC; 
  signal N_PZ_231_MC_D1 : STD_LOGIC; 
  signal cfg_receive_mask_0_II_UIM : STD_LOGIC; 
  signal receiver_sr_2_II_UIM : STD_LOGIC; 
  signal N_PZ_229 : STD_LOGIC; 
  signal N_PZ_231_MC_D2_PT_0 : STD_LOGIC; 
  signal cfg_receive_mask_1_II_UIM : STD_LOGIC; 
  signal receiver_sr_3_II_UIM : STD_LOGIC; 
  signal N_PZ_231_MC_D2_PT_1 : STD_LOGIC; 
  signal cfg_receive_mask_2_II_UIM : STD_LOGIC; 
  signal receiver_sr_4_II_UIM : STD_LOGIC; 
  signal N_PZ_231_MC_D2_PT_2 : STD_LOGIC; 
  signal cfg_receive_mask_3_II_UIM : STD_LOGIC; 
  signal receiver_sr_5_II_UIM : STD_LOGIC; 
  signal N_PZ_231_MC_D2_PT_3 : STD_LOGIC; 
  signal cfg_receive_mask_4_II_UIM : STD_LOGIC; 
  signal receiver_sr_6_II_UIM : STD_LOGIC; 
  signal N_PZ_231_MC_D2_PT_4 : STD_LOGIC; 
  signal cfg_receive_mask_5_II_UIM : STD_LOGIC; 
  signal receiver_sr_7_II_UIM : STD_LOGIC; 
  signal N_PZ_231_MC_D2_PT_5 : STD_LOGIC; 
  signal N_PZ_231_MC_D2 : STD_LOGIC; 
  signal N_PZ_229_MC_Q : STD_LOGIC; 
  signal N_PZ_229_MC_D : STD_LOGIC; 
  signal N_PZ_229_MC_D1 : STD_LOGIC; 
  signal receiver_sr_0_II_UIM : STD_LOGIC; 
  signal receiver_sr_1_II_UIM : STD_LOGIC; 
  signal pr0_II_UIM : STD_LOGIC; 
  signal pr1_II_UIM : STD_LOGIC; 
  signal N_PZ_229_MC_D2_PT_0 : STD_LOGIC; 
  signal N_PZ_229_MC_D2_PT_1 : STD_LOGIC; 
  signal N_PZ_229_MC_D2_PT_2 : STD_LOGIC; 
  signal N_PZ_229_MC_D2_PT_3 : STD_LOGIC; 
  signal N_PZ_229_MC_D2 : STD_LOGIC; 
  signal slave_cur_state_ffd4_MC_Q : STD_LOGIC; 
  signal slave_cur_state_ffd4_MC_R_OR_PRLD : STD_LOGIC; 
  signal slave_cur_state_ffd4_MC_D : STD_LOGIC; 
  signal slave_cur_state_ffd4_MC_D1 : STD_LOGIC; 
  signal N_PZ_235 : STD_LOGIC; 
  signal slave_cur_state_ffd4_MC_D2_PT_0 : STD_LOGIC; 
  signal slave_cur_state_ffd4_MC_D2_PT_1 : STD_LOGIC; 
  signal slave_cur_state_ffd4_MC_D2_PT_2 : STD_LOGIC; 
  signal slave_cur_state_ffd4_MC_D2_PT_3 : STD_LOGIC; 
  signal slave_cur_state_ffd4_MC_D2_PT_4 : STD_LOGIC; 
  signal slave_cur_state_ffd4_MC_D2_PT_5 : STD_LOGIC; 
  signal slave_cur_state_ffd4_MC_D2_PT_6 : STD_LOGIC; 
  signal slave_cur_state_ffd4_MC_D2_PT_7 : STD_LOGIC; 
  signal slave_cur_state_ffd4_MC_D2 : STD_LOGIC; 
  signal N_PZ_235_MC_Q : STD_LOGIC; 
  signal N_PZ_235_MC_D : STD_LOGIC; 
  signal N_PZ_235_MC_D1_PT_0 : STD_LOGIC; 
  signal N_PZ_235_MC_D1 : STD_LOGIC; 
  signal N_PZ_235_MC_D2_PT_0 : STD_LOGIC; 
  signal N_PZ_235_MC_D2_PT_1 : STD_LOGIC; 
  signal N_PZ_235_MC_D2_PT_2 : STD_LOGIC; 
  signal N_PZ_235_MC_D2 : STD_LOGIC; 
  signal slave_cur_state_ffd3_MC_Q : STD_LOGIC; 
  signal slave_cur_state_ffd3_MC_R_OR_PRLD : STD_LOGIC; 
  signal slave_cur_state_ffd3_MC_D : STD_LOGIC; 
  signal slave_cur_state_ffd3_MC_D1 : STD_LOGIC; 
  signal slave_cur_state_ffd3_MC_D2_PT_0 : STD_LOGIC; 
  signal slave_cur_state_ffd3_MC_D2_PT_1 : STD_LOGIC; 
  signal slave_cur_state_ffd3_MC_D2_PT_2 : STD_LOGIC; 
  signal slave_cur_state_ffd3_MC_D2_PT_3 : STD_LOGIC; 
  signal slave_cur_state_ffd3_MC_D2_PT_4 : STD_LOGIC; 
  signal slave_cur_state_ffd3_MC_D2_PT_5 : STD_LOGIC; 
  signal slave_cur_state_ffd3_MC_D2_PT_6 : STD_LOGIC; 
  signal slave_cur_state_ffd3_MC_D2_PT_7 : STD_LOGIC; 
  signal slave_cur_state_ffd3_MC_D2 : STD_LOGIC; 
  signal slave_cur_state_ffd1_MC_Q : STD_LOGIC; 
  signal slave_cur_state_ffd1_MC_R_OR_PRLD : STD_LOGIC; 
  signal slave_cur_state_ffd1_MC_D : STD_LOGIC; 
  signal slave_cur_state_ffd1_MC_D1 : STD_LOGIC; 
  signal slave_cur_state_ffd1_MC_D2_PT_0 : STD_LOGIC; 
  signal slave_cur_state_ffd1_MC_D2_PT_1 : STD_LOGIC; 
  signal N_PZ_198 : STD_LOGIC; 
  signal slave_cur_state_ffd1_MC_D2_PT_2 : STD_LOGIC; 
  signal slave_cur_state_ffd1_MC_D2_PT_3 : STD_LOGIC; 
  signal slave_cur_state_ffd1_MC_D2_PT_4 : STD_LOGIC; 
  signal slave_cur_state_ffd1_MC_D2_PT_5 : STD_LOGIC; 
  signal slave_cur_state_ffd1_MC_D2_PT_6 : STD_LOGIC; 
  signal slave_cur_state_ffd1_MC_D2_PT_7 : STD_LOGIC; 
  signal slave_cur_state_ffd1_MC_D2_PT_8 : STD_LOGIC; 
  signal slave_cur_state_ffd1_MC_D2 : STD_LOGIC; 
  signal Q_n0060_MC_Q : STD_LOGIC; 
  signal Q_n0060_MC_D : STD_LOGIC; 
  signal Q_n0060_MC_D1_PT_0 : STD_LOGIC; 
  signal Q_n0060_MC_D1 : STD_LOGIC; 
  signal Q_n0060_MC_D2 : STD_LOGIC; 
  signal bit_counter_0_MC_Q : STD_LOGIC; 
  signal FOOBAR2_ctinst_5 : STD_LOGIC; 
  signal bit_counter_0_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_0_MC_D : STD_LOGIC; 
  signal bitclk_II_FCLK : STD_LOGIC; 
  signal bit_counter_0_MC_D1 : STD_LOGIC; 
  signal bit_counter_0_MC_D2 : STD_LOGIC; 
  signal bit_counter_0_MC_D_TFF : STD_LOGIC; 
  signal bit_counter_1_MC_Q : STD_LOGIC; 
  signal bit_counter_1_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_1_MC_D : STD_LOGIC; 
  signal bit_counter_1_MC_D1_PT_0 : STD_LOGIC; 
  signal bit_counter_1_MC_D1 : STD_LOGIC; 
  signal bit_counter_1_MC_D2 : STD_LOGIC; 
  signal bit_counter_1_MC_D_TFF : STD_LOGIC; 
  signal bit_counter_2_MC_Q : STD_LOGIC; 
  signal bit_counter_2_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_2_MC_D : STD_LOGIC; 
  signal bit_counter_2_MC_D1_PT_0 : STD_LOGIC; 
  signal bit_counter_2_MC_D1 : STD_LOGIC; 
  signal bit_counter_2_MC_D2 : STD_LOGIC; 
  signal bit_counter_2_MC_D_TFF : STD_LOGIC; 
  signal bit_counter_3_MC_Q : STD_LOGIC; 
  signal bit_counter_3_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_3_MC_D : STD_LOGIC; 
  signal bit_counter_3_MC_D1_PT_0 : STD_LOGIC; 
  signal bit_counter_3_MC_D1 : STD_LOGIC; 
  signal bit_counter_3_MC_D2 : STD_LOGIC; 
  signal bit_counter_3_MC_D_TFF : STD_LOGIC; 
  signal bit_counter_4_MC_Q : STD_LOGIC; 
  signal bit_counter_4_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_4_MC_D : STD_LOGIC; 
  signal bit_counter_4_MC_D1_PT_0 : STD_LOGIC; 
  signal bit_counter_4_MC_D1 : STD_LOGIC; 
  signal bit_counter_4_MC_D2 : STD_LOGIC; 
  signal bit_counter_4_MC_D_TFF : STD_LOGIC; 
  signal bit_counter_5_MC_Q : STD_LOGIC; 
  signal bit_counter_5_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_5_MC_D : STD_LOGIC; 
  signal bit_counter_5_MC_D1_PT_0 : STD_LOGIC; 
  signal bit_counter_5_MC_D1 : STD_LOGIC; 
  signal bit_counter_5_MC_D2 : STD_LOGIC; 
  signal bit_counter_5_MC_D_TFF : STD_LOGIC; 
  signal bit_counter_6_MC_Q : STD_LOGIC; 
  signal bit_counter_6_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_6_MC_D : STD_LOGIC; 
  signal bit_counter_6_MC_D1_PT_0 : STD_LOGIC; 
  signal bit_counter_6_MC_D1 : STD_LOGIC; 
  signal bit_counter_6_MC_D2 : STD_LOGIC; 
  signal bit_counter_6_MC_D_TFF : STD_LOGIC; 
  signal bit_counter_7_MC_Q : STD_LOGIC; 
  signal bit_counter_7_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_7_MC_D : STD_LOGIC; 
  signal bit_counter_7_MC_D1_PT_0 : STD_LOGIC; 
  signal bit_counter_7_MC_D1 : STD_LOGIC; 
  signal bit_counter_7_MC_D2 : STD_LOGIC; 
  signal bit_counter_7_MC_D_TFF : STD_LOGIC; 
  signal bit_counter_8_MC_Q : STD_LOGIC; 
  signal FOOBAR1_ctinst_5 : STD_LOGIC; 
  signal bit_counter_8_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_8_MC_D : STD_LOGIC; 
  signal bit_counter_8_MC_D1_PT_0 : STD_LOGIC; 
  signal bit_counter_8_MC_D1 : STD_LOGIC; 
  signal bit_counter_8_MC_D2 : STD_LOGIC; 
  signal bit_counter_8_MC_D_TFF : STD_LOGIC; 
  signal bit_counter_9_MC_Q : STD_LOGIC; 
  signal bit_counter_9_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_9_MC_D : STD_LOGIC; 
  signal bit_counter_9_MC_D1_PT_0 : STD_LOGIC; 
  signal bit_counter_9_MC_D1 : STD_LOGIC; 
  signal bit_counter_9_MC_D2 : STD_LOGIC; 
  signal bit_counter_9_MC_D_TFF : STD_LOGIC; 
  signal bit_counter_10_MC_Q : STD_LOGIC; 
  signal bit_counter_10_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_10_MC_D : STD_LOGIC; 
  signal bit_counter_10_MC_D1_PT_0 : STD_LOGIC; 
  signal bit_counter_10_MC_D1 : STD_LOGIC; 
  signal bit_counter_10_MC_D2 : STD_LOGIC; 
  signal bit_counter_10_MC_D_TFF : STD_LOGIC; 
  signal bit_counter_11_MC_Q : STD_LOGIC; 
  signal bit_counter_11_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_11_MC_D : STD_LOGIC; 
  signal bit_counter_11_MC_D1_PT_0 : STD_LOGIC; 
  signal bit_counter_11_MC_D1 : STD_LOGIC; 
  signal bit_counter_11_MC_D2 : STD_LOGIC; 
  signal bit_counter_11_MC_D_TFF : STD_LOGIC; 
  signal bit_counter_12_MC_Q : STD_LOGIC; 
  signal bit_counter_12_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_12_MC_D : STD_LOGIC; 
  signal bit_counter_12_MC_D1_PT_0 : STD_LOGIC; 
  signal bit_counter_12_MC_D1 : STD_LOGIC; 
  signal bit_counter_12_MC_D2 : STD_LOGIC; 
  signal bit_counter_12_MC_D_TFF : STD_LOGIC; 
  signal bit_counter_13_MC_Q : STD_LOGIC; 
  signal bit_counter_13_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_13_MC_D : STD_LOGIC; 
  signal bit_counter_13_MC_D1_PT_0 : STD_LOGIC; 
  signal bit_counter_13_MC_D1 : STD_LOGIC; 
  signal bit_counter_13_MC_D2 : STD_LOGIC; 
  signal bit_counter_13_MC_D_TFF : STD_LOGIC; 
  signal bit_counter_14_MC_Q : STD_LOGIC; 
  signal bit_counter_14_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_14_MC_D : STD_LOGIC; 
  signal bit_counter_14_MC_D1_PT_0 : STD_LOGIC; 
  signal bit_counter_14_MC_D1 : STD_LOGIC; 
  signal bit_counter_14_MC_D2 : STD_LOGIC; 
  signal bit_counter_14_MC_D_TFF : STD_LOGIC; 
  signal bit_counter_15_MC_Q : STD_LOGIC; 
  signal bit_counter_15_MC_R_OR_PRLD : STD_LOGIC; 
  signal bit_counter_15_MC_D : STD_LOGIC; 
  signal bit_counter_15_MC_D1_PT_0 : STD_LOGIC; 
  signal bit_counter_15_MC_D1 : STD_LOGIC; 
  signal bit_counter_15_MC_D2 : STD_LOGIC; 
  signal bit_counter_15_MC_D_TFF : STD_LOGIC; 
  signal N_PZ_198_MC_Q : STD_LOGIC; 
  signal N_PZ_198_MC_D : STD_LOGIC; 
  signal N_PZ_198_MC_D1_PT_0 : STD_LOGIC; 
  signal N_PZ_198_MC_D1 : STD_LOGIC; 
  signal N_PZ_198_MC_D2 : STD_LOGIC; 
  signal Q_n0098_MC_Q : STD_LOGIC; 
  signal Q_n0098_MC_D : STD_LOGIC; 
  signal Q_n0098_MC_D1 : STD_LOGIC; 
  signal cfg_response_mask_0_II_UIM : STD_LOGIC; 
  signal Q_n0098_MC_D2_PT_0 : STD_LOGIC; 
  signal cfg_response_mask_1_II_UIM : STD_LOGIC; 
  signal Q_n0098_MC_D2_PT_1 : STD_LOGIC; 
  signal cfg_response_mask_2_II_UIM : STD_LOGIC; 
  signal Q_n0098_MC_D2_PT_2 : STD_LOGIC; 
  signal cfg_response_mask_3_II_UIM : STD_LOGIC; 
  signal Q_n0098_MC_D2_PT_3 : STD_LOGIC; 
  signal cfg_response_mask_4_II_UIM : STD_LOGIC; 
  signal Q_n0098_MC_D2_PT_4 : STD_LOGIC; 
  signal cfg_response_mask_5_II_UIM : STD_LOGIC; 
  signal Q_n0098_MC_D2_PT_5 : STD_LOGIC; 
  signal Q_n0098_MC_D2 : STD_LOGIC; 
  signal transmitter_rst_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal transmitter_rst_MC_Q : STD_LOGIC; 
  signal transmitter_rst_MC_D : STD_LOGIC; 
  signal transmitter_rst_MC_D1_PT_0 : STD_LOGIC; 
  signal transmitter_rst_MC_D1 : STD_LOGIC; 
  signal transmitter_rst_MC_D2 : STD_LOGIC; 
  signal byte_counter_1_MC_Q : STD_LOGIC; 
  signal byte_counter_1_MC_R_OR_PRLD : STD_LOGIC; 
  signal byte_counter_1_MC_D : STD_LOGIC; 
  signal byte_counter_1_MC_D1 : STD_LOGIC; 
  signal byte_counter_1_MC_D2_PT_0 : STD_LOGIC; 
  signal byte_counter_1_MC_D2_PT_1 : STD_LOGIC; 
  signal byte_counter_1_MC_D2 : STD_LOGIC; 
  signal byte_counter_1_MC_D_TFF : STD_LOGIC; 
  signal byte_counter_2_MC_Q : STD_LOGIC; 
  signal byte_counter_2_MC_R_OR_PRLD : STD_LOGIC; 
  signal byte_counter_2_MC_D : STD_LOGIC; 
  signal byte_counter_2_MC_D1 : STD_LOGIC; 
  signal byte_counter_2_MC_D2_PT_0 : STD_LOGIC; 
  signal byte_counter_2_MC_D2_PT_1 : STD_LOGIC; 
  signal byte_counter_2_MC_D2 : STD_LOGIC; 
  signal byte_counter_2_MC_D_TFF : STD_LOGIC; 
  signal byte_counter_3_MC_Q : STD_LOGIC; 
  signal byte_counter_3_MC_R_OR_PRLD : STD_LOGIC; 
  signal byte_counter_3_MC_D : STD_LOGIC; 
  signal byte_counter_3_MC_D1 : STD_LOGIC; 
  signal byte_counter_3_MC_D2_PT_0 : STD_LOGIC; 
  signal byte_counter_3_MC_D2_PT_1 : STD_LOGIC; 
  signal byte_counter_3_MC_D2 : STD_LOGIC; 
  signal byte_counter_3_MC_D_TFF : STD_LOGIC; 
  signal slave_cur_state_xx_ffd228_MC_Q : STD_LOGIC; 
  signal slave_cur_state_xx_ffd228_MC_D : STD_LOGIC; 
  signal slave_cur_state_xx_ffd228_MC_D1 : STD_LOGIC; 
  signal slave_cur_state_xx_ffd228_MC_D2_PT_0 : STD_LOGIC; 
  signal slave_cur_state_xx_ffd228_MC_D2_PT_1 : STD_LOGIC; 
  signal slave_cur_state_xx_ffd228_MC_D2_PT_2 : STD_LOGIC; 
  signal slave_cur_state_xx_ffd228_MC_D2_PT_3 : STD_LOGIC; 
  signal slave_cur_state_xx_ffd228_MC_D2_PT_4 : STD_LOGIC; 
  signal slave_cur_state_xx_ffd228_MC_D2_PT_5 : STD_LOGIC; 
  signal slave_cur_state_xx_ffd228_MC_D2 : STD_LOGIC; 
  signal checksum_en_MC_Q : STD_LOGIC; 
  signal checksum_en_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal checksum_en_MC_D : STD_LOGIC; 
  signal checksum_en_MC_D1 : STD_LOGIC; 
  signal checksum_en_MC_D2_PT_0 : STD_LOGIC; 
  signal checksum_en_MC_D2_PT_1 : STD_LOGIC; 
  signal checksum_en_MC_D2 : STD_LOGIC; 
  signal parity_check_0_MC_Q : STD_LOGIC; 
  signal parity_check_0_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal parity_check_0_MC_D : STD_LOGIC; 
  signal parity_check_0_MC_D1_PT_0 : STD_LOGIC; 
  signal parity_check_0_MC_D1 : STD_LOGIC; 
  signal parity_check_0_MC_D2 : STD_LOGIC; 
  signal parity_check_1_MC_Q : STD_LOGIC; 
  signal parity_check_1_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal parity_check_1_MC_D : STD_LOGIC; 
  signal parity_check_1_MC_D1_PT_0 : STD_LOGIC; 
  signal parity_check_1_MC_D1 : STD_LOGIC; 
  signal parity_check_1_MC_D2 : STD_LOGIC; 
  signal parity_check_2_MC_Q : STD_LOGIC; 
  signal parity_check_2_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal parity_check_2_MC_D : STD_LOGIC; 
  signal parity_check_2_MC_D1_PT_0 : STD_LOGIC; 
  signal parity_check_2_MC_D1 : STD_LOGIC; 
  signal parity_check_2_MC_D2 : STD_LOGIC; 
  signal parity_check_3_MC_Q : STD_LOGIC; 
  signal parity_check_3_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal parity_check_3_MC_D : STD_LOGIC; 
  signal parity_check_3_MC_D1_PT_0 : STD_LOGIC; 
  signal parity_check_3_MC_D1 : STD_LOGIC; 
  signal parity_check_3_MC_D2 : STD_LOGIC; 
  signal parity_check_4_MC_Q : STD_LOGIC; 
  signal parity_check_4_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal parity_check_4_MC_D : STD_LOGIC; 
  signal parity_check_4_MC_D1_PT_0 : STD_LOGIC; 
  signal parity_check_4_MC_D1 : STD_LOGIC; 
  signal parity_check_4_MC_D2 : STD_LOGIC; 
  signal parity_check_5_MC_Q : STD_LOGIC; 
  signal parity_check_5_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal parity_check_5_MC_D : STD_LOGIC; 
  signal parity_check_5_MC_D1_PT_0 : STD_LOGIC; 
  signal parity_check_5_MC_D1 : STD_LOGIC; 
  signal parity_check_5_MC_D2 : STD_LOGIC; 
  signal receive_0_MC_Q : STD_LOGIC; 
  signal receive_0_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal receive_0_MC_D : STD_LOGIC; 
  signal receive_0_MC_D1_PT_0 : STD_LOGIC; 
  signal receive_0_MC_D1 : STD_LOGIC; 
  signal receive_0_MC_D2 : STD_LOGIC; 
  signal receive_1_MC_Q : STD_LOGIC; 
  signal receive_1_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal receive_1_MC_D : STD_LOGIC; 
  signal receive_1_MC_D1_PT_0 : STD_LOGIC; 
  signal receive_1_MC_D1 : STD_LOGIC; 
  signal receive_1_MC_D2 : STD_LOGIC; 
  signal receive_2_MC_Q : STD_LOGIC; 
  signal receive_2_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal receive_2_MC_D : STD_LOGIC; 
  signal receive_2_MC_D1_PT_0 : STD_LOGIC; 
  signal receive_2_MC_D1 : STD_LOGIC; 
  signal receive_2_MC_D2 : STD_LOGIC; 
  signal receive_3_MC_Q : STD_LOGIC; 
  signal receive_3_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal receive_3_MC_D : STD_LOGIC; 
  signal receive_3_MC_D1_PT_0 : STD_LOGIC; 
  signal receive_3_MC_D1 : STD_LOGIC; 
  signal receive_3_MC_D2 : STD_LOGIC; 
  signal receive_4_MC_Q : STD_LOGIC; 
  signal receive_4_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal receive_4_MC_D : STD_LOGIC; 
  signal receive_4_MC_D1_PT_0 : STD_LOGIC; 
  signal receive_4_MC_D1 : STD_LOGIC; 
  signal receive_4_MC_D2 : STD_LOGIC; 
  signal receive_5_MC_Q : STD_LOGIC; 
  signal receive_5_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal receive_5_MC_D : STD_LOGIC; 
  signal receive_5_MC_D1_PT_0 : STD_LOGIC; 
  signal receive_5_MC_D1 : STD_LOGIC; 
  signal receive_5_MC_D2 : STD_LOGIC; 
  signal receive_6_MC_Q : STD_LOGIC; 
  signal receive_6_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal receive_6_MC_D : STD_LOGIC; 
  signal receive_6_MC_D1_PT_0 : STD_LOGIC; 
  signal receive_6_MC_D1 : STD_LOGIC; 
  signal receive_6_MC_D2 : STD_LOGIC; 
  signal receive_7_MC_Q : STD_LOGIC; 
  signal receive_7_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal receive_7_MC_D : STD_LOGIC; 
  signal receive_7_MC_D1_PT_0 : STD_LOGIC; 
  signal receive_7_MC_D1 : STD_LOGIC; 
  signal receive_7_MC_D2 : STD_LOGIC; 
  signal receiver_rst_MC_Q : STD_LOGIC; 
  signal receiver_rst_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal receiver_rst_MC_D : STD_LOGIC; 
  signal receiver_rst_MC_D1 : STD_LOGIC; 
  signal receiver_rst_MC_D2_PT_0 : STD_LOGIC; 
  signal receiver_rst_MC_D2_PT_1 : STD_LOGIC; 
  signal receiver_rst_MC_D2 : STD_LOGIC; 
  signal snoop_cur_state_0_MC_Q : STD_LOGIC; 
  signal snoop_cur_state_0_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal snoop_cur_state_0_MC_D : STD_LOGIC; 
  signal snoop_cur_state_0_MC_D1 : STD_LOGIC; 
  signal snoop_cur_state_0_MC_D2_PT_0 : STD_LOGIC; 
  signal snoop_cur_state_0_MC_D2_PT_1 : STD_LOGIC; 
  signal snoop_cur_state_0_MC_D2_PT_2 : STD_LOGIC; 
  signal snoop_cur_state_0_MC_D2 : STD_LOGIC; 
  signal snoop_cur_state_1_MC_Q : STD_LOGIC; 
  signal snoop_cur_state_1_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal snoop_cur_state_1_MC_D : STD_LOGIC; 
  signal snoop_cur_state_1_MC_D1_PT_0 : STD_LOGIC; 
  signal snoop_cur_state_1_MC_D1 : STD_LOGIC; 
  signal snoop_cur_state_1_MC_D2_PT_0 : STD_LOGIC; 
  signal snoop_cur_state_1_MC_D2_PT_1 : STD_LOGIC; 
  signal snoop_cur_state_1_MC_D2 : STD_LOGIC; 
  signal snoop_cur_state_2_MC_Q : STD_LOGIC; 
  signal snoop_cur_state_2_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal snoop_cur_state_2_MC_D : STD_LOGIC; 
  signal snoop_cur_state_2_MC_D1 : STD_LOGIC; 
  signal snoop_cur_state_2_MC_D2_PT_0 : STD_LOGIC; 
  signal snoop_cur_state_2_MC_D2_PT_1 : STD_LOGIC; 
  signal snoop_cur_state_2_MC_D2_PT_2 : STD_LOGIC; 
  signal snoop_cur_state_2_MC_D2_PT_3 : STD_LOGIC; 
  signal snoop_cur_state_2_MC_D2 : STD_LOGIC; 
  signal snoop_cur_state_3_MC_Q : STD_LOGIC; 
  signal snoop_cur_state_3_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal snoop_cur_state_3_MC_D : STD_LOGIC; 
  signal snoop_cur_state_3_MC_D1 : STD_LOGIC; 
  signal snoop_cur_state_3_MC_D2_PT_0 : STD_LOGIC; 
  signal snoop_cur_state_3_MC_D2_PT_1 : STD_LOGIC; 
  signal snoop_cur_state_3_MC_D2_PT_2 : STD_LOGIC; 
  signal snoop_cur_state_3_MC_D2 : STD_LOGIC; 
  signal statuses_0_MC_Q : STD_LOGIC; 
  signal statuses_0_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal statuses_0_MC_D : STD_LOGIC; 
  signal statuses_0_MC_D1 : STD_LOGIC; 
  signal statuses_0_MC_D2_PT_0 : STD_LOGIC; 
  signal statuses_0_MC_D2_PT_1 : STD_LOGIC; 
  signal statuses_0_MC_D2_PT_2 : STD_LOGIC; 
  signal statuses_0_MC_D2_PT_3 : STD_LOGIC; 
  signal statuses_0_MC_D2_PT_4 : STD_LOGIC; 
  signal statuses_0_MC_D2_PT_5 : STD_LOGIC; 
  signal statuses_0_MC_D2 : STD_LOGIC; 
  signal statuses_1_MC_Q : STD_LOGIC; 
  signal statuses_1_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal statuses_1_MC_D : STD_LOGIC; 
  signal statuses_1_MC_D1_PT_0 : STD_LOGIC; 
  signal statuses_1_MC_D1 : STD_LOGIC; 
  signal statuses_1_MC_D2 : STD_LOGIC; 
  signal statuses_2_MC_Q : STD_LOGIC; 
  signal statuses_2_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal statuses_2_MC_D : STD_LOGIC; 
  signal statuses_2_MC_D1_PT_0 : STD_LOGIC; 
  signal statuses_2_MC_D1 : STD_LOGIC; 
  signal statuses_2_MC_D2 : STD_LOGIC; 
  signal transmitter_sr_0_MC_Q : STD_LOGIC; 
  signal transmitter_sr_0_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal transmitter_sr_0_MC_D : STD_LOGIC; 
  signal transmitter_sr_0_MC_D1 : STD_LOGIC; 
  signal checksum_0_II_UIM : STD_LOGIC; 
  signal transmitter_sr_0_MC_D2_PT_0 : STD_LOGIC; 
  signal transmit_0_II_UIM : STD_LOGIC; 
  signal transmitter_sr_0_MC_D2_PT_1 : STD_LOGIC; 
  signal transmitter_sr_0_MC_D2 : STD_LOGIC; 
  signal transmitter_sr_1_MC_Q : STD_LOGIC; 
  signal transmitter_sr_1_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal transmitter_sr_1_MC_D : STD_LOGIC; 
  signal transmitter_sr_1_MC_D1 : STD_LOGIC; 
  signal checksum_1_II_UIM : STD_LOGIC; 
  signal transmitter_sr_1_MC_D2_PT_0 : STD_LOGIC; 
  signal transmit_1_II_UIM : STD_LOGIC; 
  signal transmitter_sr_1_MC_D2_PT_1 : STD_LOGIC; 
  signal transmitter_sr_1_MC_D2 : STD_LOGIC; 
  signal transmitter_sr_2_MC_Q : STD_LOGIC; 
  signal transmitter_sr_2_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal transmitter_sr_2_MC_D : STD_LOGIC; 
  signal transmitter_sr_2_MC_D1 : STD_LOGIC; 
  signal checksum_2_II_UIM : STD_LOGIC; 
  signal transmitter_sr_2_MC_D2_PT_0 : STD_LOGIC; 
  signal transmit_2_II_UIM : STD_LOGIC; 
  signal transmitter_sr_2_MC_D2_PT_1 : STD_LOGIC; 
  signal transmitter_sr_2_MC_D2 : STD_LOGIC; 
  signal transmitter_sr_3_MC_Q : STD_LOGIC; 
  signal transmitter_sr_3_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal transmitter_sr_3_MC_D : STD_LOGIC; 
  signal transmitter_sr_3_MC_D1 : STD_LOGIC; 
  signal checksum_3_II_UIM : STD_LOGIC; 
  signal transmitter_sr_3_MC_D2_PT_0 : STD_LOGIC; 
  signal transmit_3_II_UIM : STD_LOGIC; 
  signal transmitter_sr_3_MC_D2_PT_1 : STD_LOGIC; 
  signal transmitter_sr_3_MC_D2 : STD_LOGIC; 
  signal transmitter_sr_4_MC_Q : STD_LOGIC; 
  signal transmitter_sr_4_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal transmitter_sr_4_MC_D : STD_LOGIC; 
  signal transmitter_sr_4_MC_D1 : STD_LOGIC; 
  signal checksum_4_II_UIM : STD_LOGIC; 
  signal transmitter_sr_4_MC_D2_PT_0 : STD_LOGIC; 
  signal transmit_4_II_UIM : STD_LOGIC; 
  signal transmitter_sr_4_MC_D2_PT_1 : STD_LOGIC; 
  signal transmitter_sr_4_MC_D2 : STD_LOGIC; 
  signal transmitter_sr_5_MC_Q : STD_LOGIC; 
  signal transmitter_sr_5_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal transmitter_sr_5_MC_D : STD_LOGIC; 
  signal transmitter_sr_5_MC_D1 : STD_LOGIC; 
  signal checksum_5_II_UIM : STD_LOGIC; 
  signal transmitter_sr_5_MC_D2_PT_0 : STD_LOGIC; 
  signal transmit_5_II_UIM : STD_LOGIC; 
  signal transmitter_sr_5_MC_D2_PT_1 : STD_LOGIC; 
  signal transmitter_sr_5_MC_D2 : STD_LOGIC; 
  signal transmitter_sr_6_MC_Q : STD_LOGIC; 
  signal transmitter_sr_6_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal transmitter_sr_6_MC_D : STD_LOGIC; 
  signal transmitter_sr_6_MC_D1 : STD_LOGIC; 
  signal checksum_6_II_UIM : STD_LOGIC; 
  signal transmitter_sr_6_MC_D2_PT_0 : STD_LOGIC; 
  signal transmit_6_II_UIM : STD_LOGIC; 
  signal transmitter_sr_6_MC_D2_PT_1 : STD_LOGIC; 
  signal transmitter_sr_6_MC_D2 : STD_LOGIC; 
  signal transmitter_sr_7_MC_Q : STD_LOGIC; 
  signal transmitter_sr_7_MC_Q_tsim_ireg_Q : STD_LOGIC; 
  signal transmitter_sr_7_MC_D : STD_LOGIC; 
  signal transmitter_sr_7_MC_D1 : STD_LOGIC; 
  signal checksum_7_II_UIM : STD_LOGIC; 
  signal transmitter_sr_7_MC_D2_PT_0 : STD_LOGIC; 
  signal transmit_7_II_UIM : STD_LOGIC; 
  signal transmitter_sr_7_MC_D2_PT_1 : STD_LOGIC; 
  signal transmitter_sr_7_MC_D2 : STD_LOGIC; 
  signal GND : STD_LOGIC; 
  signal VCC : STD_LOGIC; 
  signal PRLD : STD_LOGIC; 
  signal NlwInverterSignal_checksum_done_MC_D2_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_done_MC_D2_PT_0_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_done_MC_D2_PT_0_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_done_MC_D2_PT_0_IN6 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_done_MC_D2_PT_0_IN7 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_done_MC_D2_PT_0_IN8 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_done_MC_D2_PT_0_IN9 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_done_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_done_MC_D2_PT_1_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_done_MC_D2_PT_1_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_done_MC_D2_PT_1_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_done_MC_D2_PT_1_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_done_MC_D2_PT_1_IN6 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_done_MC_D2_PT_1_IN7 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_done_MC_D2_PT_1_IN8 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_0_MC_D2_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_0_MC_D2_PT_0_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_0_MC_D2_PT_0_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_0_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_0_MC_D2_PT_1_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_0_MC_D2_PT_1_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_0_MC_D2_PT_1_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_2_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_2_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_2_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_2_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_3_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_4_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_4_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_4_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_4_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_5_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_5_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_5_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_5_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_5_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_6_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_6_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_6_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_7_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_7_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_7_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_8_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_8_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_8_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN6 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN7 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN8 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_229_MC_D2_PT_0_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_229_MC_D2_PT_1_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_229_MC_D2_PT_1_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_229_MC_D2_PT_1_IN7 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_229_MC_D2_PT_2_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_229_MC_D2_PT_2_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_229_MC_D2_PT_2_IN6 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_229_MC_D2_PT_3_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_229_MC_D2_PT_3_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_229_MC_D2_PT_3_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_229_MC_D2_PT_3_IN6 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_229_MC_D2_PT_3_IN7 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_1_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_1_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_1_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_2_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_3_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_3_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_3_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_4_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_4_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_4_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_5_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_5_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_5_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_6_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_6_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_6_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN6 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN10 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN11 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_235_MC_D1_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_235_MC_D2_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_235_MC_D2_PT_0_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_235_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_235_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_235_MC_D2_PT_2_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_2_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_2_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_2_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_2_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_3_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_3_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_3_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_4_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_4_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_4_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_4_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_5_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_5_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_5_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_5_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN6 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN7 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN8 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN8 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN9 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN10 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN11 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN12 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN13 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN14 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN15 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN16 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN17 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN18 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN19 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_2_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_2_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_3_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_3_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_4_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_4_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_4_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_5_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_5_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_5_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_5_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_6_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_6_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_6_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_6_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_7_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_7_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_7_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_7_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN9 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN10 : STD_LOGIC; 
  signal NlwInverterSignal_n0060_MC_D1_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_n0060_MC_D1_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_n0060_MC_D1_PT_0_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_n0060_MC_D1_PT_0_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_n0060_MC_D1_PT_0_IN6 : STD_LOGIC; 
  signal NlwInverterSignal_n0060_MC_D1_PT_0_IN9 : STD_LOGIC; 
  signal NlwInverterSignal_n0060_MC_D1_PT_0_IN10 : STD_LOGIC; 
  signal NlwInverterSignal_n0060_MC_D1_PT_0_IN11 : STD_LOGIC; 
  signal NlwInverterSignal_n0060_MC_D1_PT_0_IN12 : STD_LOGIC; 
  signal NlwInverterSignal_n0060_MC_D1_PT_0_IN15 : STD_LOGIC; 
  signal NlwInverterSignal_FOOBAR2_ctinst_5_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_FOOBAR2_ctinst_5_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_FOOBAR2_ctinst_5_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_FOOBAR2_ctinst_5_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_FOOBAR2_ctinst_5_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_bit_counter_0_MC_XOR_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_FOOBAR1_ctinst_5_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_FOOBAR1_ctinst_5_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_FOOBAR1_ctinst_5_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_FOOBAR1_ctinst_5_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_FOOBAR1_ctinst_5_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_198_MC_D1_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_N_PZ_198_MC_D1_PT_0_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_rst_MC_D1_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_rst_MC_D1_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_rst_MC_D1_PT_0_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_rst_MC_D1_PT_0_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_1_MC_D2_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_1_MC_D2_PT_0_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_1_MC_D2_PT_0_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_1_MC_D2_PT_0_IN6 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_1_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_1_MC_D2_PT_1_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_1_MC_D2_PT_1_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_1_MC_D2_PT_1_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_1_MC_D2_PT_1_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_2_MC_D2_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_2_MC_D2_PT_0_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_2_MC_D2_PT_0_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_2_MC_D2_PT_0_IN6 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_2_MC_D2_PT_0_IN7 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN6 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN6 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN7 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN8 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN6 : STD_LOGIC; 
  signal NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN7 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN6 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN7 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN8 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN9 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN10 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN11 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN12 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN13 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN14 : STD_LOGIC; 
  signal NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN15 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_en_MC_D2_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_en_MC_D2_PT_0_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_en_MC_D2_PT_0_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_en_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_en_MC_D2_PT_1_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_en_MC_D2_PT_1_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_checksum_en_MC_D2_PT_1_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_receiver_rst_MC_D2_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_receiver_rst_MC_D2_PT_0_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_receiver_rst_MC_D2_PT_0_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN5 : STD_LOGIC; 
  signal NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN6 : STD_LOGIC; 
  signal NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN7 : STD_LOGIC; 
  signal NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN11 : STD_LOGIC; 
  signal NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN12 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_0_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_0_MC_D2_PT_2_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_0_MC_D2_PT_2_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_1_MC_D1_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_1_MC_D1_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_1_MC_D2_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_1_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_1_MC_XOR_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_1_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_2_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_2_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_3_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_3_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_2_MC_XOR_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_3_MC_D2_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_3_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_3_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_3_MC_D2_PT_1_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_3_MC_D2_PT_2_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_snoop_cur_state_3_MC_XOR_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_statuses_1_MC_D1_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_statuses_1_MC_D1_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_statuses_1_MC_D1_PT_0_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_statuses_1_MC_D1_PT_0_IN4 : STD_LOGIC; 
  signal NlwInverterSignal_statuses_2_MC_D1_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_statuses_2_MC_D1_PT_0_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_statuses_2_MC_D1_PT_0_IN2 : STD_LOGIC; 
  signal NlwInverterSignal_statuses_2_MC_D1_PT_0_IN3 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_0_MC_D2_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_0_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_0_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_0_MC_XOR_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_1_MC_D2_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_1_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_1_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_1_MC_XOR_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_2_MC_D2_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_2_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_2_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_2_MC_XOR_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_3_MC_D2_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_3_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_3_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_3_MC_XOR_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_4_MC_D2_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_4_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_4_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_4_MC_XOR_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_5_MC_D2_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_5_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_5_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_5_MC_XOR_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_6_MC_D2_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_6_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_6_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_6_MC_XOR_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_7_MC_D2_PT_0_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_7_MC_D2_PT_1_IN0 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_7_MC_D2_PT_1_IN1 : STD_LOGIC; 
  signal NlwInverterSignal_transmitter_sr_7_MC_XOR_IN0 : STD_LOGIC; 
  signal byte_counter : STD_LOGIC_VECTOR ( 3 downto 0 ); 
  signal bit_counter : STD_LOGIC_VECTOR ( 15 downto 0 ); 
begin
  checksum_done_0 : X_BUF
    port map (
      I => checksum_done_MC_Q,
      O => checksum_done
    );
  checksum_done_MC_Q_1 : X_BUF
    port map (
      I => checksum_done_MC_Q_tsim_ireg_Q,
      O => checksum_done_MC_Q
    );
  checksum_done_MC_REG : X_BUF
    port map (
      I => checksum_done_MC_D,
      O => checksum_done_MC_Q_tsim_ireg_Q
    );
  GND_ZERO : X_ZERO
    port map (
      O => GND
    );
  checksum_done_MC_D1_2 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => checksum_done_MC_D1
    );
  checksum_done_MC_D2_PT_0_3 : X_AND16
    port map (
      I0 => receiver_done_II_UIM,
      I1 => NlwInverterSignal_checksum_done_MC_D2_PT_0_IN1,
      I2 => NlwInverterSignal_checksum_done_MC_D2_PT_0_IN2,
      I3 => slave_cur_state_ffd4,
      I4 => slave_cur_state_ffd3,
      I5 => NlwInverterSignal_checksum_done_MC_D2_PT_0_IN5,
      I6 => NlwInverterSignal_checksum_done_MC_D2_PT_0_IN6,
      I7 => NlwInverterSignal_checksum_done_MC_D2_PT_0_IN7,
      I8 => NlwInverterSignal_checksum_done_MC_D2_PT_0_IN8,
      I9 => NlwInverterSignal_checksum_done_MC_D2_PT_0_IN9,
      I10 => VCC,
      I11 => VCC,
      I12 => VCC,
      I13 => VCC,
      I14 => VCC,
      I15 => VCC,
      O => checksum_done_MC_D2_PT_0
    );
  VCC_ONE : X_ONE
    port map (
      O => VCC
    );
  checksum_done_MC_D2_PT_1_4 : X_AND16
    port map (
      I0 => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN0,
      I1 => slave_cur_state_ffd2,
      I2 => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN2,
      I3 => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN3,
      I4 => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN4,
      I5 => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN5,
      I6 => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN6,
      I7 => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN7,
      I8 => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN8,
      I9 => transmitter_done_II_UIM,
      I10 => VCC,
      I11 => VCC,
      I12 => VCC,
      I13 => VCC,
      I14 => VCC,
      I15 => VCC,
      O => checksum_done_MC_D2_PT_1
    );
  checksum_done_MC_D2_5 : X_OR2
    port map (
      I0 => checksum_done_MC_D2_PT_0,
      I1 => checksum_done_MC_D2_PT_1,
      O => checksum_done_MC_D2
    );
  checksum_done_MC_XOR : X_XOR2
    port map (
      I0 => checksum_done_MC_D1,
      I1 => checksum_done_MC_D2,
      O => checksum_done_MC_D
    );
  receiver_done_II_UIM_6 : X_BUF
    port map (
      I => receiver_done,
      O => receiver_done_II_UIM
    );
  byte_counter_0_Q : X_BUF
    port map (
      I => byte_counter_0_MC_Q,
      O => byte_counter(0)
    );
  byte_counter_0_MC_R_OR_PRLD_7 : X_OR2
    port map (
      I0 => rst_II_FSR,
      I1 => PRLD,
      O => byte_counter_0_MC_R_OR_PRLD
    );
  byte_counter_0_MC_REG : X_FF
    port map (
      I => byte_counter_0_MC_D,
      CE => VCC,
      CLK => clk_II_FCLK,
      SET => GND,
      RST => byte_counter_0_MC_R_OR_PRLD,
      O => byte_counter_0_MC_Q
    );
  byte_counter_0_MC_D1_8 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => byte_counter_0_MC_D1
    );
  byte_counter_0_MC_D2_PT_0_9 : X_AND6
    port map (
      I0 => receiver_done_II_UIM,
      I1 => NlwInverterSignal_byte_counter_0_MC_D2_PT_0_IN1,
      I2 => slave_cur_state_ffd4,
      I3 => slave_cur_state_ffd3,
      I4 => NlwInverterSignal_byte_counter_0_MC_D2_PT_0_IN4,
      I5 => NlwInverterSignal_byte_counter_0_MC_D2_PT_0_IN5,
      O => byte_counter_0_MC_D2_PT_0
    );
  byte_counter_0_MC_D2_PT_1_10 : X_AND6
    port map (
      I0 => slave_cur_state_ffd2,
      I1 => NlwInverterSignal_byte_counter_0_MC_D2_PT_1_IN1,
      I2 => NlwInverterSignal_byte_counter_0_MC_D2_PT_1_IN2,
      I3 => NlwInverterSignal_byte_counter_0_MC_D2_PT_1_IN3,
      I4 => NlwInverterSignal_byte_counter_0_MC_D2_PT_1_IN4,
      I5 => transmitter_done_II_UIM,
      O => byte_counter_0_MC_D2_PT_1
    );
  byte_counter_0_MC_D2_11 : X_OR2
    port map (
      I0 => byte_counter_0_MC_D2_PT_0,
      I1 => byte_counter_0_MC_D2_PT_1,
      O => byte_counter_0_MC_D2
    );
  byte_counter_0_MC_D_12 : X_XOR2
    port map (
      I0 => byte_counter_0_MC_D_TFF,
      I1 => byte_counter_0_MC_Q,
      O => byte_counter_0_MC_D
    );
  byte_counter_0_MC_XOR : X_XOR2
    port map (
      I0 => byte_counter_0_MC_D1,
      I1 => byte_counter_0_MC_D2,
      O => byte_counter_0_MC_D_TFF
    );
  slave_cur_state_ffd2_13 : X_BUF
    port map (
      I => slave_cur_state_ffd2_MC_Q,
      O => slave_cur_state_ffd2
    );
  slave_cur_state_ffd2_MC_R_OR_PRLD_14 : X_OR2
    port map (
      I0 => rst_II_FSR,
      I1 => PRLD,
      O => slave_cur_state_ffd2_MC_R_OR_PRLD
    );
  slave_cur_state_ffd2_MC_REG : X_FF
    port map (
      I => slave_cur_state_ffd2_MC_D,
      CE => VCC,
      CLK => clk_II_FCLK,
      SET => GND,
      RST => slave_cur_state_ffd2_MC_R_OR_PRLD,
      O => slave_cur_state_ffd2_MC_Q
    );
  slave_cur_state_ffd2_MC_D1_15 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => slave_cur_state_ffd2_MC_D1
    );
  slave_cur_state_ffd2_MC_D2_PT_0_16 : X_AND2
    port map (
      I0 => N_PZ_231,
      I1 => N_PZ_231,
      O => slave_cur_state_ffd2_MC_D2_PT_0
    );
  slave_cur_state_ffd2_MC_D2_PT_1_17 : X_AND2
    port map (
      I0 => slave_cur_state_ffd3,
      I1 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_1_IN1,
      O => slave_cur_state_ffd2_MC_D2_PT_1
    );
  slave_cur_state_ffd2_MC_D2_PT_2_18 : X_AND5
    port map (
      I0 => slave_cur_state_ffd2,
      I1 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_2_IN1,
      I2 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_2_IN2,
      I3 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_2_IN3,
      I4 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_2_IN4,
      O => slave_cur_state_ffd2_MC_D2_PT_2
    );
  slave_cur_state_ffd2_MC_D2_PT_3_19 : X_AND5
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_3_IN0,
      I1 => slave_cur_state_ffd4,
      I2 => slave_cur_state_ffd3,
      I3 => slave_cur_state_ffd1,
      I4 => Q_n0098,
      O => slave_cur_state_ffd2_MC_D2_PT_3
    );
  slave_cur_state_ffd2_MC_D2_PT_4_20 : X_AND5
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_4_IN0,
      I1 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_4_IN1,
      I2 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_4_IN2,
      I3 => slave_cur_state_ffd1,
      I4 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_4_IN4,
      O => slave_cur_state_ffd2_MC_D2_PT_4
    );
  slave_cur_state_ffd2_MC_D2_PT_5_21 : X_AND5
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_5_IN0,
      I1 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_5_IN1,
      I2 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_5_IN2,
      I3 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_5_IN3,
      I4 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_5_IN4,
      O => slave_cur_state_ffd2_MC_D2_PT_5
    );
  slave_cur_state_ffd2_MC_D2_PT_6_22 : X_AND6
    port map (
      I0 => receiver_done_II_UIM,
      I1 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_6_IN1,
      I2 => slave_cur_state_ffd4,
      I3 => slave_cur_state_ffd3,
      I4 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_6_IN4,
      I5 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_6_IN5,
      O => slave_cur_state_ffd2_MC_D2_PT_6
    );
  slave_cur_state_ffd2_MC_D2_PT_7_23 : X_AND6
    port map (
      I0 => receiver_done_II_UIM,
      I1 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_7_IN1,
      I2 => slave_cur_state_ffd4,
      I3 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_7_IN3,
      I4 => slave_cur_state_ffd1,
      I5 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_7_IN5,
      O => slave_cur_state_ffd2_MC_D2_PT_7
    );
  slave_cur_state_ffd2_MC_D2_PT_8_24 : X_AND6
    port map (
      I0 => slave_cur_state_ffd2,
      I1 => slave_cur_state_ffd4,
      I2 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_8_IN2,
      I3 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_8_IN3,
      I4 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_8_IN4,
      I5 => ser_in_II_UIM,
      O => slave_cur_state_ffd2_MC_D2_PT_8
    );
  slave_cur_state_ffd2_MC_D2_PT_9_25 : X_AND16
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN0,
      I1 => slave_cur_state_ffd2,
      I2 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN2,
      I3 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN3,
      I4 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN4,
      I5 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN5,
      I6 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN6,
      I7 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN7,
      I8 => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN8,
      I9 => VCC,
      I10 => VCC,
      I11 => VCC,
      I12 => VCC,
      I13 => VCC,
      I14 => VCC,
      I15 => VCC,
      O => slave_cur_state_ffd2_MC_D2_PT_9
    );
  slave_cur_state_ffd2_MC_D2_26 : X_OR16
    port map (
      I0 => slave_cur_state_ffd2_MC_D2_PT_0,
      I1 => slave_cur_state_ffd2_MC_D2_PT_1,
      I2 => slave_cur_state_ffd2_MC_D2_PT_2,
      I3 => slave_cur_state_ffd2_MC_D2_PT_3,
      I4 => slave_cur_state_ffd2_MC_D2_PT_4,
      I5 => slave_cur_state_ffd2_MC_D2_PT_5,
      I6 => slave_cur_state_ffd2_MC_D2_PT_6,
      I7 => slave_cur_state_ffd2_MC_D2_PT_7,
      I8 => slave_cur_state_ffd2_MC_D2_PT_8,
      I9 => slave_cur_state_ffd2_MC_D2_PT_9,
      I10 => GND,
      I11 => GND,
      I12 => GND,
      I13 => GND,
      I14 => GND,
      I15 => GND,
      O => slave_cur_state_ffd2_MC_D2
    );
  slave_cur_state_ffd2_MC_XOR : X_XOR2
    port map (
      I0 => slave_cur_state_ffd2_MC_D1,
      I1 => slave_cur_state_ffd2_MC_D2,
      O => slave_cur_state_ffd2_MC_D
    );
  N_PZ_231_27 : X_BUF
    port map (
      I => N_PZ_231_MC_Q,
      O => N_PZ_231
    );
  N_PZ_231_MC_REG : X_BUF
    port map (
      I => N_PZ_231_MC_D,
      O => N_PZ_231_MC_Q
    );
  N_PZ_231_MC_D1_28 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => N_PZ_231_MC_D1
    );
  N_PZ_231_MC_D2_PT_0_29 : X_AND3
    port map (
      I0 => cfg_receive_mask_0_II_UIM,
      I1 => receiver_sr_2_II_UIM,
      I2 => N_PZ_229,
      O => N_PZ_231_MC_D2_PT_0
    );
  N_PZ_231_MC_D2_PT_1_30 : X_AND3
    port map (
      I0 => cfg_receive_mask_1_II_UIM,
      I1 => receiver_sr_3_II_UIM,
      I2 => N_PZ_229,
      O => N_PZ_231_MC_D2_PT_1
    );
  N_PZ_231_MC_D2_PT_2_31 : X_AND3
    port map (
      I0 => cfg_receive_mask_2_II_UIM,
      I1 => receiver_sr_4_II_UIM,
      I2 => N_PZ_229,
      O => N_PZ_231_MC_D2_PT_2
    );
  N_PZ_231_MC_D2_PT_3_32 : X_AND3
    port map (
      I0 => cfg_receive_mask_3_II_UIM,
      I1 => receiver_sr_5_II_UIM,
      I2 => N_PZ_229,
      O => N_PZ_231_MC_D2_PT_3
    );
  N_PZ_231_MC_D2_PT_4_33 : X_AND3
    port map (
      I0 => cfg_receive_mask_4_II_UIM,
      I1 => receiver_sr_6_II_UIM,
      I2 => N_PZ_229,
      O => N_PZ_231_MC_D2_PT_4
    );
  N_PZ_231_MC_D2_PT_5_34 : X_AND3
    port map (
      I0 => cfg_receive_mask_5_II_UIM,
      I1 => receiver_sr_7_II_UIM,
      I2 => N_PZ_229,
      O => N_PZ_231_MC_D2_PT_5
    );
  N_PZ_231_MC_D2_35 : X_OR6
    port map (
      I0 => N_PZ_231_MC_D2_PT_0,
      I1 => N_PZ_231_MC_D2_PT_1,
      I2 => N_PZ_231_MC_D2_PT_2,
      I3 => N_PZ_231_MC_D2_PT_3,
      I4 => N_PZ_231_MC_D2_PT_4,
      I5 => N_PZ_231_MC_D2_PT_5,
      O => N_PZ_231_MC_D2
    );
  N_PZ_231_MC_XOR : X_XOR2
    port map (
      I0 => N_PZ_231_MC_D1,
      I1 => N_PZ_231_MC_D2,
      O => N_PZ_231_MC_D
    );
  cfg_receive_mask_0_II_UIM_36 : X_BUF
    port map (
      I => cfg_receive_mask(0),
      O => cfg_receive_mask_0_II_UIM
    );
  receiver_sr_2_II_UIM_37 : X_BUF
    port map (
      I => receiver_sr(2),
      O => receiver_sr_2_II_UIM
    );
  N_PZ_229_38 : X_BUF
    port map (
      I => N_PZ_229_MC_Q,
      O => N_PZ_229
    );
  N_PZ_229_MC_REG : X_BUF
    port map (
      I => N_PZ_229_MC_D,
      O => N_PZ_229_MC_Q
    );
  N_PZ_229_MC_D1_39 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => N_PZ_229_MC_D1
    );
  N_PZ_229_MC_D2_PT_0_40 : X_AND8
    port map (
      I0 => slave_cur_state_ffd2,
      I1 => slave_cur_state_ffd4,
      I2 => NlwInverterSignal_N_PZ_229_MC_D2_PT_0_IN2,
      I3 => slave_cur_state_ffd1,
      I4 => receiver_sr_0_II_UIM,
      I5 => receiver_sr_1_II_UIM,
      I6 => pr0_II_UIM,
      I7 => pr1_II_UIM,
      O => N_PZ_229_MC_D2_PT_0
    );
  N_PZ_229_MC_D2_PT_1_41 : X_AND8
    port map (
      I0 => slave_cur_state_ffd2,
      I1 => slave_cur_state_ffd4,
      I2 => NlwInverterSignal_N_PZ_229_MC_D2_PT_1_IN2,
      I3 => slave_cur_state_ffd1,
      I4 => receiver_sr_0_II_UIM,
      I5 => NlwInverterSignal_N_PZ_229_MC_D2_PT_1_IN5,
      I6 => pr0_II_UIM,
      I7 => NlwInverterSignal_N_PZ_229_MC_D2_PT_1_IN7,
      O => N_PZ_229_MC_D2_PT_1
    );
  N_PZ_229_MC_D2_PT_2_42 : X_AND8
    port map (
      I0 => slave_cur_state_ffd2,
      I1 => slave_cur_state_ffd4,
      I2 => NlwInverterSignal_N_PZ_229_MC_D2_PT_2_IN2,
      I3 => slave_cur_state_ffd1,
      I4 => NlwInverterSignal_N_PZ_229_MC_D2_PT_2_IN4,
      I5 => receiver_sr_1_II_UIM,
      I6 => NlwInverterSignal_N_PZ_229_MC_D2_PT_2_IN6,
      I7 => pr1_II_UIM,
      O => N_PZ_229_MC_D2_PT_2
    );
  N_PZ_229_MC_D2_PT_3_43 : X_AND8
    port map (
      I0 => slave_cur_state_ffd2,
      I1 => slave_cur_state_ffd4,
      I2 => NlwInverterSignal_N_PZ_229_MC_D2_PT_3_IN2,
      I3 => slave_cur_state_ffd1,
      I4 => NlwInverterSignal_N_PZ_229_MC_D2_PT_3_IN4,
      I5 => NlwInverterSignal_N_PZ_229_MC_D2_PT_3_IN5,
      I6 => NlwInverterSignal_N_PZ_229_MC_D2_PT_3_IN6,
      I7 => NlwInverterSignal_N_PZ_229_MC_D2_PT_3_IN7,
      O => N_PZ_229_MC_D2_PT_3
    );
  N_PZ_229_MC_D2_44 : X_OR4
    port map (
      I0 => N_PZ_229_MC_D2_PT_0,
      I1 => N_PZ_229_MC_D2_PT_1,
      I2 => N_PZ_229_MC_D2_PT_2,
      I3 => N_PZ_229_MC_D2_PT_3,
      O => N_PZ_229_MC_D2
    );
  N_PZ_229_MC_XOR : X_XOR2
    port map (
      I0 => N_PZ_229_MC_D1,
      I1 => N_PZ_229_MC_D2,
      O => N_PZ_229_MC_D
    );
  slave_cur_state_ffd4_45 : X_BUF
    port map (
      I => slave_cur_state_ffd4_MC_Q,
      O => slave_cur_state_ffd4
    );
  slave_cur_state_ffd4_MC_R_OR_PRLD_46 : X_OR2
    port map (
      I0 => rst_II_FSR,
      I1 => PRLD,
      O => slave_cur_state_ffd4_MC_R_OR_PRLD
    );
  slave_cur_state_ffd4_MC_REG : X_FF
    port map (
      I => slave_cur_state_ffd4_MC_D,
      CE => VCC,
      CLK => clk_II_FCLK,
      SET => GND,
      RST => slave_cur_state_ffd4_MC_R_OR_PRLD,
      O => slave_cur_state_ffd4_MC_Q
    );
  slave_cur_state_ffd4_MC_D1_47 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => slave_cur_state_ffd4_MC_D1
    );
  slave_cur_state_ffd4_MC_D2_PT_0_48 : X_AND2
    port map (
      I0 => slave_cur_state_ffd2,
      I1 => N_PZ_235,
      O => slave_cur_state_ffd4_MC_D2_PT_0
    );
  slave_cur_state_ffd4_MC_D2_PT_1_49 : X_AND5
    port map (
      I0 => slave_cur_state_ffd2,
      I1 => slave_cur_state_ffd4,
      I2 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_1_IN2,
      I3 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_1_IN3,
      I4 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_1_IN4,
      O => slave_cur_state_ffd4_MC_D2_PT_1
    );
  slave_cur_state_ffd4_MC_D2_PT_2_50 : X_AND5
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_2_IN0,
      I1 => slave_cur_state_ffd4,
      I2 => slave_cur_state_ffd3,
      I3 => slave_cur_state_ffd1,
      I4 => Q_n0098,
      O => slave_cur_state_ffd4_MC_D2_PT_2
    );
  slave_cur_state_ffd4_MC_D2_PT_3_51 : X_AND5
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_3_IN0,
      I1 => slave_cur_state_ffd4,
      I2 => slave_cur_state_ffd3,
      I3 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_3_IN3,
      I4 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_3_IN4,
      O => slave_cur_state_ffd4_MC_D2_PT_3
    );
  slave_cur_state_ffd4_MC_D2_PT_4_52 : X_AND5
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_4_IN0,
      I1 => slave_cur_state_ffd4,
      I2 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_4_IN2,
      I3 => slave_cur_state_ffd1,
      I4 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_4_IN4,
      O => slave_cur_state_ffd4_MC_D2_PT_4
    );
  slave_cur_state_ffd4_MC_D2_PT_5_53 : X_AND5
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_5_IN0,
      I1 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_5_IN1,
      I2 => slave_cur_state_ffd3,
      I3 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_5_IN3,
      I4 => ser_in_II_UIM,
      O => slave_cur_state_ffd4_MC_D2_PT_5
    );
  slave_cur_state_ffd4_MC_D2_PT_6_54 : X_AND5
    port map (
      I0 => slave_cur_state_ffd4,
      I1 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_6_IN1,
      I2 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_6_IN2,
      I3 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_6_IN3,
      I4 => ser_in_II_UIM,
      O => slave_cur_state_ffd4_MC_D2_PT_6
    );
  slave_cur_state_ffd4_MC_D2_PT_7_55 : X_AND16
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN0,
      I1 => slave_cur_state_ffd3,
      I2 => slave_cur_state_ffd1,
      I3 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN3,
      I4 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN4,
      I5 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN5,
      I6 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN6,
      I7 => receiver_sr_7_II_UIM,
      I8 => receiver_sr_5_II_UIM,
      I9 => receiver_sr_3_II_UIM,
      I10 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN10,
      I11 => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN11,
      I12 => receiver_sr_1_II_UIM,
      I13 => VCC,
      I14 => VCC,
      I15 => VCC,
      O => slave_cur_state_ffd4_MC_D2_PT_7
    );
  slave_cur_state_ffd4_MC_D2_56 : X_OR8
    port map (
      I0 => slave_cur_state_ffd4_MC_D2_PT_0,
      I1 => slave_cur_state_ffd4_MC_D2_PT_1,
      I2 => slave_cur_state_ffd4_MC_D2_PT_2,
      I3 => slave_cur_state_ffd4_MC_D2_PT_3,
      I4 => slave_cur_state_ffd4_MC_D2_PT_4,
      I5 => slave_cur_state_ffd4_MC_D2_PT_5,
      I6 => slave_cur_state_ffd4_MC_D2_PT_6,
      I7 => slave_cur_state_ffd4_MC_D2_PT_7,
      O => slave_cur_state_ffd4_MC_D2
    );
  slave_cur_state_ffd4_MC_XOR : X_XOR2
    port map (
      I0 => slave_cur_state_ffd4_MC_D1,
      I1 => slave_cur_state_ffd4_MC_D2,
      O => slave_cur_state_ffd4_MC_D
    );
  N_PZ_235_57 : X_BUF
    port map (
      I => N_PZ_235_MC_Q,
      O => N_PZ_235
    );
  N_PZ_235_MC_REG : X_BUF
    port map (
      I => N_PZ_235_MC_D,
      O => N_PZ_235_MC_Q
    );
  N_PZ_235_MC_D1_PT_0_58 : X_AND3
    port map (
      I0 => NlwInverterSignal_N_PZ_235_MC_D1_PT_0_IN0,
      I1 => slave_cur_state_ffd3,
      I2 => slave_cur_state_ffd1,
      O => N_PZ_235_MC_D1_PT_0
    );
  N_PZ_235_MC_D1_59 : X_OR2
    port map (
      I0 => N_PZ_235_MC_D1_PT_0,
      I1 => N_PZ_235_MC_D1_PT_0,
      O => N_PZ_235_MC_D1
    );
  N_PZ_235_MC_D2_PT_0_60 : X_AND5
    port map (
      I0 => receiver_done_II_UIM,
      I1 => NlwInverterSignal_N_PZ_235_MC_D2_PT_0_IN1,
      I2 => NlwInverterSignal_N_PZ_235_MC_D2_PT_0_IN2,
      I3 => slave_cur_state_ffd3,
      I4 => slave_cur_state_ffd1,
      O => N_PZ_235_MC_D2_PT_0
    );
  N_PZ_235_MC_D2_PT_1_61 : X_AND5
    port map (
      I0 => NlwInverterSignal_N_PZ_235_MC_D2_PT_1_IN0,
      I1 => NlwInverterSignal_N_PZ_235_MC_D2_PT_1_IN1,
      I2 => slave_cur_state_ffd3,
      I3 => slave_cur_state_ffd1,
      I4 => Q_n0060,
      O => N_PZ_235_MC_D2_PT_1
    );
  N_PZ_235_MC_D2_PT_2_62 : X_AND16
    port map (
      I0 => slave_cur_state_ffd2,
      I1 => NlwInverterSignal_N_PZ_235_MC_D2_PT_2_IN1,
      I2 => slave_cur_state_ffd3,
      I3 => slave_cur_state_ffd1,
      I4 => receiver_sr_6_II_UIM,
      I5 => receiver_sr_4_II_UIM,
      I6 => receiver_sr_7_II_UIM,
      I7 => receiver_sr_5_II_UIM,
      I8 => receiver_sr_3_II_UIM,
      I9 => VCC,
      I10 => VCC,
      I11 => VCC,
      I12 => VCC,
      I13 => VCC,
      I14 => VCC,
      I15 => VCC,
      O => N_PZ_235_MC_D2_PT_2
    );
  N_PZ_235_MC_D2_63 : X_OR3
    port map (
      I0 => N_PZ_235_MC_D2_PT_0,
      I1 => N_PZ_235_MC_D2_PT_1,
      I2 => N_PZ_235_MC_D2_PT_2,
      O => N_PZ_235_MC_D2
    );
  N_PZ_235_MC_XOR : X_XOR2
    port map (
      I0 => N_PZ_235_MC_D1,
      I1 => N_PZ_235_MC_D2,
      O => N_PZ_235_MC_D
    );
  slave_cur_state_ffd3_64 : X_BUF
    port map (
      I => slave_cur_state_ffd3_MC_Q,
      O => slave_cur_state_ffd3
    );
  slave_cur_state_ffd3_MC_R_OR_PRLD_65 : X_OR2
    port map (
      I0 => rst_II_FSR,
      I1 => PRLD,
      O => slave_cur_state_ffd3_MC_R_OR_PRLD
    );
  slave_cur_state_ffd3_MC_REG : X_FF
    port map (
      I => slave_cur_state_ffd3_MC_D,
      CE => VCC,
      CLK => clk_II_FCLK,
      SET => GND,
      RST => slave_cur_state_ffd3_MC_R_OR_PRLD,
      O => slave_cur_state_ffd3_MC_Q
    );
  slave_cur_state_ffd3_MC_D1_66 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => slave_cur_state_ffd3_MC_D1
    );
  slave_cur_state_ffd3_MC_D2_PT_0_67 : X_AND2
    port map (
      I0 => N_PZ_231,
      I1 => N_PZ_231,
      O => slave_cur_state_ffd3_MC_D2_PT_0
    );
  slave_cur_state_ffd3_MC_D2_PT_1_68 : X_AND2
    port map (
      I0 => N_PZ_235,
      I1 => N_PZ_235,
      O => slave_cur_state_ffd3_MC_D2_PT_1
    );
  slave_cur_state_ffd3_MC_D2_PT_2_69 : X_AND4
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_2_IN0,
      I1 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_2_IN1,
      I2 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_2_IN2,
      I3 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_2_IN3,
      O => slave_cur_state_ffd3_MC_D2_PT_2
    );
  slave_cur_state_ffd3_MC_D2_PT_3_70 : X_AND4
    port map (
      I0 => slave_cur_state_ffd4,
      I1 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_3_IN1,
      I2 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_3_IN2,
      I3 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_3_IN3,
      O => slave_cur_state_ffd3_MC_D2_PT_3
    );
  slave_cur_state_ffd3_MC_D2_PT_4_71 : X_AND5
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_4_IN0,
      I1 => slave_cur_state_ffd3,
      I2 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_4_IN2,
      I3 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_4_IN3,
      I4 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_4_IN4,
      O => slave_cur_state_ffd3_MC_D2_PT_4
    );
  slave_cur_state_ffd3_MC_D2_PT_5_72 : X_AND6
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_5_IN0,
      I1 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_5_IN1,
      I2 => slave_cur_state_ffd4,
      I3 => slave_cur_state_ffd3,
      I4 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_5_IN4,
      I5 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_5_IN5,
      O => slave_cur_state_ffd3_MC_D2_PT_5
    );
  slave_cur_state_ffd3_MC_D2_PT_6_73 : X_AND16
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN0,
      I1 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN1,
      I2 => slave_cur_state_ffd4,
      I3 => slave_cur_state_ffd3,
      I4 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN4,
      I5 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN5,
      I6 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN6,
      I7 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN7,
      I8 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN8,
      I9 => VCC,
      I10 => VCC,
      I11 => VCC,
      I12 => VCC,
      I13 => VCC,
      I14 => VCC,
      I15 => VCC,
      O => slave_cur_state_ffd3_MC_D2_PT_6
    );
  slave_cur_state_ffd3_MC_D2_PT_7_74 : X_AND32
    port map (
      I0 => slave_cur_state_ffd2,
      I1 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN1,
      I2 => slave_cur_state_ffd3,
      I3 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN3,
      I4 => bit_counter(0),
      I5 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN5,
      I6 => bit_counter(2),
      I7 => bit_counter(3),
      I8 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN8,
      I9 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN9,
      I10 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN10,
      I11 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN11,
      I12 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN12,
      I13 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN13,
      I14 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN14,
      I15 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN15,
      I16 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN16,
      I17 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN17,
      I18 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN18,
      I19 => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN19,
      I20 => VCC,
      I21 => VCC,
      I22 => VCC,
      I23 => VCC,
      I24 => VCC,
      I25 => VCC,
      I26 => VCC,
      I27 => VCC,
      I28 => VCC,
      I29 => VCC,
      I30 => VCC,
      I31 => VCC,
      O => slave_cur_state_ffd3_MC_D2_PT_7
    );
  slave_cur_state_ffd3_MC_D2_75 : X_OR8
    port map (
      I0 => slave_cur_state_ffd3_MC_D2_PT_0,
      I1 => slave_cur_state_ffd3_MC_D2_PT_1,
      I2 => slave_cur_state_ffd3_MC_D2_PT_2,
      I3 => slave_cur_state_ffd3_MC_D2_PT_3,
      I4 => slave_cur_state_ffd3_MC_D2_PT_4,
      I5 => slave_cur_state_ffd3_MC_D2_PT_5,
      I6 => slave_cur_state_ffd3_MC_D2_PT_6,
      I7 => slave_cur_state_ffd3_MC_D2_PT_7,
      O => slave_cur_state_ffd3_MC_D2
    );
  slave_cur_state_ffd3_MC_XOR : X_XOR2
    port map (
      I0 => slave_cur_state_ffd3_MC_D1,
      I1 => slave_cur_state_ffd3_MC_D2,
      O => slave_cur_state_ffd3_MC_D
    );
  slave_cur_state_ffd1_76 : X_BUF
    port map (
      I => slave_cur_state_ffd1_MC_Q,
      O => slave_cur_state_ffd1
    );
  slave_cur_state_ffd1_MC_R_OR_PRLD_77 : X_OR2
    port map (
      I0 => rst_II_FSR,
      I1 => PRLD,
      O => slave_cur_state_ffd1_MC_R_OR_PRLD
    );
  slave_cur_state_ffd1_MC_REG : X_FF
    port map (
      I => slave_cur_state_ffd1_MC_D,
      CE => VCC,
      CLK => clk_II_FCLK,
      SET => GND,
      RST => slave_cur_state_ffd1_MC_R_OR_PRLD,
      O => slave_cur_state_ffd1_MC_Q
    );
  slave_cur_state_ffd1_MC_D1_78 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => slave_cur_state_ffd1_MC_D1
    );
  slave_cur_state_ffd1_MC_D2_PT_0_79 : X_AND2
    port map (
      I0 => N_PZ_231,
      I1 => N_PZ_231,
      O => slave_cur_state_ffd1_MC_D2_PT_0
    );
  slave_cur_state_ffd1_MC_D2_PT_1_80 : X_AND2
    port map (
      I0 => N_PZ_235,
      I1 => N_PZ_235,
      O => slave_cur_state_ffd1_MC_D2_PT_1
    );
  slave_cur_state_ffd1_MC_D2_PT_2_81 : X_AND3
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_2_IN0,
      I1 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_2_IN1,
      I2 => N_PZ_198,
      O => slave_cur_state_ffd1_MC_D2_PT_2
    );
  slave_cur_state_ffd1_MC_D2_PT_3_82 : X_AND5
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_3_IN0,
      I1 => slave_cur_state_ffd4,
      I2 => slave_cur_state_ffd3,
      I3 => slave_cur_state_ffd1,
      I4 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_3_IN4,
      O => slave_cur_state_ffd1_MC_D2_PT_3
    );
  slave_cur_state_ffd1_MC_D2_PT_4_83 : X_AND5
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_4_IN0,
      I1 => slave_cur_state_ffd4,
      I2 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_4_IN2,
      I3 => slave_cur_state_ffd1,
      I4 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_4_IN4,
      O => slave_cur_state_ffd1_MC_D2_PT_4
    );
  slave_cur_state_ffd1_MC_D2_PT_5_84 : X_AND5
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_5_IN0,
      I1 => slave_cur_state_ffd4,
      I2 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_5_IN2,
      I3 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_5_IN3,
      I4 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_5_IN4,
      O => slave_cur_state_ffd1_MC_D2_PT_5
    );
  slave_cur_state_ffd1_MC_D2_PT_6_85 : X_AND5
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_6_IN0,
      I1 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_6_IN1,
      I2 => slave_cur_state_ffd1,
      I3 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_6_IN3,
      I4 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_6_IN4,
      O => slave_cur_state_ffd1_MC_D2_PT_6
    );
  slave_cur_state_ffd1_MC_D2_PT_7_86 : X_AND6
    port map (
      I0 => slave_cur_state_ffd2,
      I1 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_7_IN1,
      I2 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_7_IN2,
      I3 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_7_IN3,
      I4 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_7_IN4,
      I5 => transmitter_done_II_UIM,
      O => slave_cur_state_ffd1_MC_D2_PT_7
    );
  slave_cur_state_ffd1_MC_D2_PT_8_87 : X_AND16
    port map (
      I0 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN0,
      I1 => slave_cur_state_ffd3,
      I2 => slave_cur_state_ffd1,
      I3 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN3,
      I4 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN4,
      I5 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN5,
      I6 => receiver_sr_7_II_UIM,
      I7 => receiver_sr_5_II_UIM,
      I8 => receiver_sr_3_II_UIM,
      I9 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN9,
      I10 => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN10,
      I11 => receiver_sr_1_II_UIM,
      I12 => VCC,
      I13 => VCC,
      I14 => VCC,
      I15 => VCC,
      O => slave_cur_state_ffd1_MC_D2_PT_8
    );
  slave_cur_state_ffd1_MC_D2_88 : X_OR16
    port map (
      I0 => slave_cur_state_ffd1_MC_D2_PT_0,
      I1 => slave_cur_state_ffd1_MC_D2_PT_1,
      I2 => slave_cur_state_ffd1_MC_D2_PT_2,
      I3 => slave_cur_state_ffd1_MC_D2_PT_3,
      I4 => slave_cur_state_ffd1_MC_D2_PT_4,
      I5 => slave_cur_state_ffd1_MC_D2_PT_5,
      I6 => slave_cur_state_ffd1_MC_D2_PT_6,
      I7 => slave_cur_state_ffd1_MC_D2_PT_7,
      I8 => slave_cur_state_ffd1_MC_D2_PT_8,
      I9 => GND,
      I10 => GND,
      I11 => GND,
      I12 => GND,
      I13 => GND,
      I14 => GND,
      I15 => GND,
      O => slave_cur_state_ffd1_MC_D2
    );
  slave_cur_state_ffd1_MC_XOR : X_XOR2
    port map (
      I0 => slave_cur_state_ffd1_MC_D1,
      I1 => slave_cur_state_ffd1_MC_D2,
      O => slave_cur_state_ffd1_MC_D
    );
  Q_n0060_89 : X_BUF
    port map (
      I => Q_n0060_MC_Q,
      O => Q_n0060
    );
  Q_n0060_MC_REG : X_BUF
    port map (
      I => Q_n0060_MC_D,
      O => Q_n0060_MC_Q
    );
  Q_n0060_MC_D1_PT_0_90 : X_AND16
    port map (
      I0 => NlwInverterSignal_n0060_MC_D1_PT_0_IN0,
      I1 => NlwInverterSignal_n0060_MC_D1_PT_0_IN1,
      I2 => NlwInverterSignal_n0060_MC_D1_PT_0_IN2,
      I3 => bit_counter(3),
      I4 => NlwInverterSignal_n0060_MC_D1_PT_0_IN4,
      I5 => bit_counter(5),
      I6 => NlwInverterSignal_n0060_MC_D1_PT_0_IN6,
      I7 => bit_counter(7),
      I8 => bit_counter(8),
      I9 => NlwInverterSignal_n0060_MC_D1_PT_0_IN9,
      I10 => NlwInverterSignal_n0060_MC_D1_PT_0_IN10,
      I11 => NlwInverterSignal_n0060_MC_D1_PT_0_IN11,
      I12 => NlwInverterSignal_n0060_MC_D1_PT_0_IN12,
      I13 => bit_counter(13),
      I14 => bit_counter(14),
      I15 => NlwInverterSignal_n0060_MC_D1_PT_0_IN15,
      O => Q_n0060_MC_D1_PT_0
    );
  Q_n0060_MC_D1_91 : X_OR2
    port map (
      I0 => Q_n0060_MC_D1_PT_0,
      I1 => Q_n0060_MC_D1_PT_0,
      O => Q_n0060_MC_D1
    );
  Q_n0060_MC_D2_92 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => Q_n0060_MC_D2
    );
  Q_n0060_MC_XOR : X_XOR2
    port map (
      I0 => Q_n0060_MC_D1,
      I1 => Q_n0060_MC_D2,
      O => Q_n0060_MC_D
    );
  bit_counter_0_Q : X_BUF
    port map (
      I => bit_counter_0_MC_Q,
      O => bit_counter(0)
    );
  bit_counter_0_MC_R_OR_PRLD_93 : X_OR2
    port map (
      I0 => FOOBAR2_ctinst_5,
      I1 => PRLD,
      O => bit_counter_0_MC_R_OR_PRLD
    );
  bit_counter_0_MC_REG : X_FF
    port map (
      I => bit_counter_0_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_0_MC_R_OR_PRLD,
      O => bit_counter_0_MC_Q
    );
  FOOBAR2_ctinst_5_94 : X_AND5
    port map (
      I0 => NlwInverterSignal_FOOBAR2_ctinst_5_IN0,
      I1 => NlwInverterSignal_FOOBAR2_ctinst_5_IN1,
      I2 => NlwInverterSignal_FOOBAR2_ctinst_5_IN2,
      I3 => NlwInverterSignal_FOOBAR2_ctinst_5_IN3,
      I4 => NlwInverterSignal_FOOBAR2_ctinst_5_IN4,
      O => FOOBAR2_ctinst_5
    );
  ser_in_II_UIM_95 : X_BUF
    port map (
      I => ser_in,
      O => ser_in_II_UIM
    );
  bit_counter_0_MC_D1_96 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_0_MC_D1
    );
  bit_counter_0_MC_D2_97 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_0_MC_D2
    );
  bit_counter_0_MC_D_98 : X_XOR2
    port map (
      I0 => bit_counter_0_MC_D_TFF,
      I1 => bit_counter_0_MC_Q,
      O => bit_counter_0_MC_D
    );
  bit_counter_0_MC_XOR : X_XOR2
    port map (
      I0 => NlwInverterSignal_bit_counter_0_MC_XOR_IN0,
      I1 => bit_counter_0_MC_D2,
      O => bit_counter_0_MC_D_TFF
    );
  bitclk_II_FCLK_99 : X_BUF
    port map (
      I => bitclk,
      O => bitclk_II_FCLK
    );
  bit_counter_1_Q : X_BUF
    port map (
      I => bit_counter_1_MC_Q,
      O => bit_counter(1)
    );
  bit_counter_1_MC_R_OR_PRLD_100 : X_OR2
    port map (
      I0 => FOOBAR2_ctinst_5,
      I1 => PRLD,
      O => bit_counter_1_MC_R_OR_PRLD
    );
  bit_counter_1_MC_REG : X_FF
    port map (
      I => bit_counter_1_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_1_MC_R_OR_PRLD,
      O => bit_counter_1_MC_Q
    );
  bit_counter_1_MC_D1_PT_0_101 : X_AND2
    port map (
      I0 => bit_counter(0),
      I1 => bit_counter(0),
      O => bit_counter_1_MC_D1_PT_0
    );
  bit_counter_1_MC_D1_102 : X_OR2
    port map (
      I0 => bit_counter_1_MC_D1_PT_0,
      I1 => bit_counter_1_MC_D1_PT_0,
      O => bit_counter_1_MC_D1
    );
  bit_counter_1_MC_D2_103 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_1_MC_D2
    );
  bit_counter_1_MC_D_104 : X_XOR2
    port map (
      I0 => bit_counter_1_MC_D_TFF,
      I1 => bit_counter_1_MC_Q,
      O => bit_counter_1_MC_D
    );
  bit_counter_1_MC_XOR : X_XOR2
    port map (
      I0 => bit_counter_1_MC_D1,
      I1 => bit_counter_1_MC_D2,
      O => bit_counter_1_MC_D_TFF
    );
  bit_counter_2_Q : X_BUF
    port map (
      I => bit_counter_2_MC_Q,
      O => bit_counter(2)
    );
  bit_counter_2_MC_R_OR_PRLD_105 : X_OR2
    port map (
      I0 => FOOBAR2_ctinst_5,
      I1 => PRLD,
      O => bit_counter_2_MC_R_OR_PRLD
    );
  bit_counter_2_MC_REG : X_FF
    port map (
      I => bit_counter_2_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_2_MC_R_OR_PRLD,
      O => bit_counter_2_MC_Q
    );
  bit_counter_2_MC_D1_PT_0_106 : X_AND2
    port map (
      I0 => bit_counter(0),
      I1 => bit_counter(1),
      O => bit_counter_2_MC_D1_PT_0
    );
  bit_counter_2_MC_D1_107 : X_OR2
    port map (
      I0 => bit_counter_2_MC_D1_PT_0,
      I1 => bit_counter_2_MC_D1_PT_0,
      O => bit_counter_2_MC_D1
    );
  bit_counter_2_MC_D2_108 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_2_MC_D2
    );
  bit_counter_2_MC_D_109 : X_XOR2
    port map (
      I0 => bit_counter_2_MC_D_TFF,
      I1 => bit_counter_2_MC_Q,
      O => bit_counter_2_MC_D
    );
  bit_counter_2_MC_XOR : X_XOR2
    port map (
      I0 => bit_counter_2_MC_D1,
      I1 => bit_counter_2_MC_D2,
      O => bit_counter_2_MC_D_TFF
    );
  bit_counter_3_Q : X_BUF
    port map (
      I => bit_counter_3_MC_Q,
      O => bit_counter(3)
    );
  bit_counter_3_MC_R_OR_PRLD_110 : X_OR2
    port map (
      I0 => FOOBAR2_ctinst_5,
      I1 => PRLD,
      O => bit_counter_3_MC_R_OR_PRLD
    );
  bit_counter_3_MC_REG : X_FF
    port map (
      I => bit_counter_3_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_3_MC_R_OR_PRLD,
      O => bit_counter_3_MC_Q
    );
  bit_counter_3_MC_D1_PT_0_111 : X_AND3
    port map (
      I0 => bit_counter(0),
      I1 => bit_counter(1),
      I2 => bit_counter(2),
      O => bit_counter_3_MC_D1_PT_0
    );
  bit_counter_3_MC_D1_112 : X_OR2
    port map (
      I0 => bit_counter_3_MC_D1_PT_0,
      I1 => bit_counter_3_MC_D1_PT_0,
      O => bit_counter_3_MC_D1
    );
  bit_counter_3_MC_D2_113 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_3_MC_D2
    );
  bit_counter_3_MC_D_114 : X_XOR2
    port map (
      I0 => bit_counter_3_MC_D_TFF,
      I1 => bit_counter_3_MC_Q,
      O => bit_counter_3_MC_D
    );
  bit_counter_3_MC_XOR : X_XOR2
    port map (
      I0 => bit_counter_3_MC_D1,
      I1 => bit_counter_3_MC_D2,
      O => bit_counter_3_MC_D_TFF
    );
  bit_counter_4_Q : X_BUF
    port map (
      I => bit_counter_4_MC_Q,
      O => bit_counter(4)
    );
  bit_counter_4_MC_R_OR_PRLD_115 : X_OR2
    port map (
      I0 => FOOBAR2_ctinst_5,
      I1 => PRLD,
      O => bit_counter_4_MC_R_OR_PRLD
    );
  bit_counter_4_MC_REG : X_FF
    port map (
      I => bit_counter_4_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_4_MC_R_OR_PRLD,
      O => bit_counter_4_MC_Q
    );
  bit_counter_4_MC_D1_PT_0_116 : X_AND4
    port map (
      I0 => bit_counter(0),
      I1 => bit_counter(1),
      I2 => bit_counter(2),
      I3 => bit_counter(3),
      O => bit_counter_4_MC_D1_PT_0
    );
  bit_counter_4_MC_D1_117 : X_OR2
    port map (
      I0 => bit_counter_4_MC_D1_PT_0,
      I1 => bit_counter_4_MC_D1_PT_0,
      O => bit_counter_4_MC_D1
    );
  bit_counter_4_MC_D2_118 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_4_MC_D2
    );
  bit_counter_4_MC_D_119 : X_XOR2
    port map (
      I0 => bit_counter_4_MC_D_TFF,
      I1 => bit_counter_4_MC_Q,
      O => bit_counter_4_MC_D
    );
  bit_counter_4_MC_XOR : X_XOR2
    port map (
      I0 => bit_counter_4_MC_D1,
      I1 => bit_counter_4_MC_D2,
      O => bit_counter_4_MC_D_TFF
    );
  bit_counter_5_Q : X_BUF
    port map (
      I => bit_counter_5_MC_Q,
      O => bit_counter(5)
    );
  bit_counter_5_MC_R_OR_PRLD_120 : X_OR2
    port map (
      I0 => FOOBAR2_ctinst_5,
      I1 => PRLD,
      O => bit_counter_5_MC_R_OR_PRLD
    );
  bit_counter_5_MC_REG : X_FF
    port map (
      I => bit_counter_5_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_5_MC_R_OR_PRLD,
      O => bit_counter_5_MC_Q
    );
  bit_counter_5_MC_D1_PT_0_121 : X_AND5
    port map (
      I0 => bit_counter(0),
      I1 => bit_counter(1),
      I2 => bit_counter(2),
      I3 => bit_counter(3),
      I4 => bit_counter(4),
      O => bit_counter_5_MC_D1_PT_0
    );
  bit_counter_5_MC_D1_122 : X_OR2
    port map (
      I0 => bit_counter_5_MC_D1_PT_0,
      I1 => bit_counter_5_MC_D1_PT_0,
      O => bit_counter_5_MC_D1
    );
  bit_counter_5_MC_D2_123 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_5_MC_D2
    );
  bit_counter_5_MC_D_124 : X_XOR2
    port map (
      I0 => bit_counter_5_MC_D_TFF,
      I1 => bit_counter_5_MC_Q,
      O => bit_counter_5_MC_D
    );
  bit_counter_5_MC_XOR : X_XOR2
    port map (
      I0 => bit_counter_5_MC_D1,
      I1 => bit_counter_5_MC_D2,
      O => bit_counter_5_MC_D_TFF
    );
  bit_counter_6_Q : X_BUF
    port map (
      I => bit_counter_6_MC_Q,
      O => bit_counter(6)
    );
  bit_counter_6_MC_R_OR_PRLD_125 : X_OR2
    port map (
      I0 => FOOBAR2_ctinst_5,
      I1 => PRLD,
      O => bit_counter_6_MC_R_OR_PRLD
    );
  bit_counter_6_MC_REG : X_FF
    port map (
      I => bit_counter_6_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_6_MC_R_OR_PRLD,
      O => bit_counter_6_MC_Q
    );
  bit_counter_6_MC_D1_PT_0_126 : X_AND6
    port map (
      I0 => bit_counter(0),
      I1 => bit_counter(1),
      I2 => bit_counter(2),
      I3 => bit_counter(3),
      I4 => bit_counter(4),
      I5 => bit_counter(5),
      O => bit_counter_6_MC_D1_PT_0
    );
  bit_counter_6_MC_D1_127 : X_OR2
    port map (
      I0 => bit_counter_6_MC_D1_PT_0,
      I1 => bit_counter_6_MC_D1_PT_0,
      O => bit_counter_6_MC_D1
    );
  bit_counter_6_MC_D2_128 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_6_MC_D2
    );
  bit_counter_6_MC_D_129 : X_XOR2
    port map (
      I0 => bit_counter_6_MC_D_TFF,
      I1 => bit_counter_6_MC_Q,
      O => bit_counter_6_MC_D
    );
  bit_counter_6_MC_XOR : X_XOR2
    port map (
      I0 => bit_counter_6_MC_D1,
      I1 => bit_counter_6_MC_D2,
      O => bit_counter_6_MC_D_TFF
    );
  bit_counter_7_Q : X_BUF
    port map (
      I => bit_counter_7_MC_Q,
      O => bit_counter(7)
    );
  bit_counter_7_MC_R_OR_PRLD_130 : X_OR2
    port map (
      I0 => FOOBAR2_ctinst_5,
      I1 => PRLD,
      O => bit_counter_7_MC_R_OR_PRLD
    );
  bit_counter_7_MC_REG : X_FF
    port map (
      I => bit_counter_7_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_7_MC_R_OR_PRLD,
      O => bit_counter_7_MC_Q
    );
  bit_counter_7_MC_D1_PT_0_131 : X_AND7
    port map (
      I0 => bit_counter(0),
      I1 => bit_counter(1),
      I2 => bit_counter(2),
      I3 => bit_counter(3),
      I4 => bit_counter(4),
      I5 => bit_counter(5),
      I6 => bit_counter(6),
      O => bit_counter_7_MC_D1_PT_0
    );
  bit_counter_7_MC_D1_132 : X_OR2
    port map (
      I0 => bit_counter_7_MC_D1_PT_0,
      I1 => bit_counter_7_MC_D1_PT_0,
      O => bit_counter_7_MC_D1
    );
  bit_counter_7_MC_D2_133 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_7_MC_D2
    );
  bit_counter_7_MC_D_134 : X_XOR2
    port map (
      I0 => bit_counter_7_MC_D_TFF,
      I1 => bit_counter_7_MC_Q,
      O => bit_counter_7_MC_D
    );
  bit_counter_7_MC_XOR : X_XOR2
    port map (
      I0 => bit_counter_7_MC_D1,
      I1 => bit_counter_7_MC_D2,
      O => bit_counter_7_MC_D_TFF
    );
  bit_counter_8_Q : X_BUF
    port map (
      I => bit_counter_8_MC_Q,
      O => bit_counter(8)
    );
  bit_counter_8_MC_R_OR_PRLD_135 : X_OR2
    port map (
      I0 => FOOBAR1_ctinst_5,
      I1 => PRLD,
      O => bit_counter_8_MC_R_OR_PRLD
    );
  bit_counter_8_MC_REG : X_FF
    port map (
      I => bit_counter_8_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_8_MC_R_OR_PRLD,
      O => bit_counter_8_MC_Q
    );
  FOOBAR1_ctinst_5_136 : X_AND5
    port map (
      I0 => NlwInverterSignal_FOOBAR1_ctinst_5_IN0,
      I1 => NlwInverterSignal_FOOBAR1_ctinst_5_IN1,
      I2 => NlwInverterSignal_FOOBAR1_ctinst_5_IN2,
      I3 => NlwInverterSignal_FOOBAR1_ctinst_5_IN3,
      I4 => NlwInverterSignal_FOOBAR1_ctinst_5_IN4,
      O => FOOBAR1_ctinst_5
    );
  bit_counter_8_MC_D1_PT_0_137 : X_AND8
    port map (
      I0 => bit_counter(0),
      I1 => bit_counter(1),
      I2 => bit_counter(2),
      I3 => bit_counter(3),
      I4 => bit_counter(4),
      I5 => bit_counter(5),
      I6 => bit_counter(6),
      I7 => bit_counter(7),
      O => bit_counter_8_MC_D1_PT_0
    );
  bit_counter_8_MC_D1_138 : X_OR2
    port map (
      I0 => bit_counter_8_MC_D1_PT_0,
      I1 => bit_counter_8_MC_D1_PT_0,
      O => bit_counter_8_MC_D1
    );
  bit_counter_8_MC_D2_139 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_8_MC_D2
    );
  bit_counter_8_MC_D_140 : X_XOR2
    port map (
      I0 => bit_counter_8_MC_D_TFF,
      I1 => bit_counter_8_MC_Q,
      O => bit_counter_8_MC_D
    );
  bit_counter_8_MC_XOR : X_XOR2
    port map (
      I0 => bit_counter_8_MC_D1,
      I1 => bit_counter_8_MC_D2,
      O => bit_counter_8_MC_D_TFF
    );
  bit_counter_9_Q : X_BUF
    port map (
      I => bit_counter_9_MC_Q,
      O => bit_counter(9)
    );
  bit_counter_9_MC_R_OR_PRLD_141 : X_OR2
    port map (
      I0 => FOOBAR1_ctinst_5,
      I1 => PRLD,
      O => bit_counter_9_MC_R_OR_PRLD
    );
  bit_counter_9_MC_REG : X_FF
    port map (
      I => bit_counter_9_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_9_MC_R_OR_PRLD,
      O => bit_counter_9_MC_Q
    );
  bit_counter_9_MC_D1_PT_0_142 : X_AND16
    port map (
      I0 => bit_counter(0),
      I1 => bit_counter(1),
      I2 => bit_counter(2),
      I3 => bit_counter(3),
      I4 => bit_counter(4),
      I5 => bit_counter(5),
      I6 => bit_counter(6),
      I7 => bit_counter(7),
      I8 => bit_counter(8),
      I9 => VCC,
      I10 => VCC,
      I11 => VCC,
      I12 => VCC,
      I13 => VCC,
      I14 => VCC,
      I15 => VCC,
      O => bit_counter_9_MC_D1_PT_0
    );
  bit_counter_9_MC_D1_143 : X_OR2
    port map (
      I0 => bit_counter_9_MC_D1_PT_0,
      I1 => bit_counter_9_MC_D1_PT_0,
      O => bit_counter_9_MC_D1
    );
  bit_counter_9_MC_D2_144 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_9_MC_D2
    );
  bit_counter_9_MC_D_145 : X_XOR2
    port map (
      I0 => bit_counter_9_MC_D_TFF,
      I1 => bit_counter_9_MC_Q,
      O => bit_counter_9_MC_D
    );
  bit_counter_9_MC_XOR : X_XOR2
    port map (
      I0 => bit_counter_9_MC_D1,
      I1 => bit_counter_9_MC_D2,
      O => bit_counter_9_MC_D_TFF
    );
  bit_counter_10_Q : X_BUF
    port map (
      I => bit_counter_10_MC_Q,
      O => bit_counter(10)
    );
  bit_counter_10_MC_R_OR_PRLD_146 : X_OR2
    port map (
      I0 => FOOBAR1_ctinst_5,
      I1 => PRLD,
      O => bit_counter_10_MC_R_OR_PRLD
    );
  bit_counter_10_MC_REG : X_FF
    port map (
      I => bit_counter_10_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_10_MC_R_OR_PRLD,
      O => bit_counter_10_MC_Q
    );
  bit_counter_10_MC_D1_PT_0_147 : X_AND16
    port map (
      I0 => bit_counter(0),
      I1 => bit_counter(1),
      I2 => bit_counter(2),
      I3 => bit_counter(3),
      I4 => bit_counter(4),
      I5 => bit_counter(5),
      I6 => bit_counter(6),
      I7 => bit_counter(7),
      I8 => bit_counter(8),
      I9 => bit_counter(9),
      I10 => VCC,
      I11 => VCC,
      I12 => VCC,
      I13 => VCC,
      I14 => VCC,
      I15 => VCC,
      O => bit_counter_10_MC_D1_PT_0
    );
  bit_counter_10_MC_D1_148 : X_OR2
    port map (
      I0 => bit_counter_10_MC_D1_PT_0,
      I1 => bit_counter_10_MC_D1_PT_0,
      O => bit_counter_10_MC_D1
    );
  bit_counter_10_MC_D2_149 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_10_MC_D2
    );
  bit_counter_10_MC_D_150 : X_XOR2
    port map (
      I0 => bit_counter_10_MC_D_TFF,
      I1 => bit_counter_10_MC_Q,
      O => bit_counter_10_MC_D
    );
  bit_counter_10_MC_XOR : X_XOR2
    port map (
      I0 => bit_counter_10_MC_D1,
      I1 => bit_counter_10_MC_D2,
      O => bit_counter_10_MC_D_TFF
    );
  bit_counter_11_Q : X_BUF
    port map (
      I => bit_counter_11_MC_Q,
      O => bit_counter(11)
    );
  bit_counter_11_MC_R_OR_PRLD_151 : X_OR2
    port map (
      I0 => FOOBAR1_ctinst_5,
      I1 => PRLD,
      O => bit_counter_11_MC_R_OR_PRLD
    );
  bit_counter_11_MC_REG : X_FF
    port map (
      I => bit_counter_11_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_11_MC_R_OR_PRLD,
      O => bit_counter_11_MC_Q
    );
  bit_counter_11_MC_D1_PT_0_152 : X_AND16
    port map (
      I0 => bit_counter(0),
      I1 => bit_counter(1),
      I2 => bit_counter(2),
      I3 => bit_counter(3),
      I4 => bit_counter(4),
      I5 => bit_counter(5),
      I6 => bit_counter(6),
      I7 => bit_counter(7),
      I8 => bit_counter(8),
      I9 => bit_counter(9),
      I10 => bit_counter(10),
      I11 => VCC,
      I12 => VCC,
      I13 => VCC,
      I14 => VCC,
      I15 => VCC,
      O => bit_counter_11_MC_D1_PT_0
    );
  bit_counter_11_MC_D1_153 : X_OR2
    port map (
      I0 => bit_counter_11_MC_D1_PT_0,
      I1 => bit_counter_11_MC_D1_PT_0,
      O => bit_counter_11_MC_D1
    );
  bit_counter_11_MC_D2_154 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_11_MC_D2
    );
  bit_counter_11_MC_D_155 : X_XOR2
    port map (
      I0 => bit_counter_11_MC_D_TFF,
      I1 => bit_counter_11_MC_Q,
      O => bit_counter_11_MC_D
    );
  bit_counter_11_MC_XOR : X_XOR2
    port map (
      I0 => bit_counter_11_MC_D1,
      I1 => bit_counter_11_MC_D2,
      O => bit_counter_11_MC_D_TFF
    );
  bit_counter_12_Q : X_BUF
    port map (
      I => bit_counter_12_MC_Q,
      O => bit_counter(12)
    );
  bit_counter_12_MC_R_OR_PRLD_156 : X_OR2
    port map (
      I0 => FOOBAR1_ctinst_5,
      I1 => PRLD,
      O => bit_counter_12_MC_R_OR_PRLD
    );
  bit_counter_12_MC_REG : X_FF
    port map (
      I => bit_counter_12_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_12_MC_R_OR_PRLD,
      O => bit_counter_12_MC_Q
    );
  bit_counter_12_MC_D1_PT_0_157 : X_AND16
    port map (
      I0 => bit_counter(0),
      I1 => bit_counter(1),
      I2 => bit_counter(2),
      I3 => bit_counter(3),
      I4 => bit_counter(4),
      I5 => bit_counter(5),
      I6 => bit_counter(6),
      I7 => bit_counter(7),
      I8 => bit_counter(8),
      I9 => bit_counter(9),
      I10 => bit_counter(10),
      I11 => bit_counter(11),
      I12 => VCC,
      I13 => VCC,
      I14 => VCC,
      I15 => VCC,
      O => bit_counter_12_MC_D1_PT_0
    );
  bit_counter_12_MC_D1_158 : X_OR2
    port map (
      I0 => bit_counter_12_MC_D1_PT_0,
      I1 => bit_counter_12_MC_D1_PT_0,
      O => bit_counter_12_MC_D1
    );
  bit_counter_12_MC_D2_159 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_12_MC_D2
    );
  bit_counter_12_MC_D_160 : X_XOR2
    port map (
      I0 => bit_counter_12_MC_D_TFF,
      I1 => bit_counter_12_MC_Q,
      O => bit_counter_12_MC_D
    );
  bit_counter_12_MC_XOR : X_XOR2
    port map (
      I0 => bit_counter_12_MC_D1,
      I1 => bit_counter_12_MC_D2,
      O => bit_counter_12_MC_D_TFF
    );
  bit_counter_13_Q : X_BUF
    port map (
      I => bit_counter_13_MC_Q,
      O => bit_counter(13)
    );
  bit_counter_13_MC_R_OR_PRLD_161 : X_OR2
    port map (
      I0 => FOOBAR1_ctinst_5,
      I1 => PRLD,
      O => bit_counter_13_MC_R_OR_PRLD
    );
  bit_counter_13_MC_REG : X_FF
    port map (
      I => bit_counter_13_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_13_MC_R_OR_PRLD,
      O => bit_counter_13_MC_Q
    );
  bit_counter_13_MC_D1_PT_0_162 : X_AND16
    port map (
      I0 => bit_counter(0),
      I1 => bit_counter(1),
      I2 => bit_counter(2),
      I3 => bit_counter(3),
      I4 => bit_counter(4),
      I5 => bit_counter(5),
      I6 => bit_counter(6),
      I7 => bit_counter(7),
      I8 => bit_counter(8),
      I9 => bit_counter(9),
      I10 => bit_counter(10),
      I11 => bit_counter(11),
      I12 => bit_counter(12),
      I13 => VCC,
      I14 => VCC,
      I15 => VCC,
      O => bit_counter_13_MC_D1_PT_0
    );
  bit_counter_13_MC_D1_163 : X_OR2
    port map (
      I0 => bit_counter_13_MC_D1_PT_0,
      I1 => bit_counter_13_MC_D1_PT_0,
      O => bit_counter_13_MC_D1
    );
  bit_counter_13_MC_D2_164 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_13_MC_D2
    );
  bit_counter_13_MC_D_165 : X_XOR2
    port map (
      I0 => bit_counter_13_MC_D_TFF,
      I1 => bit_counter_13_MC_Q,
      O => bit_counter_13_MC_D
    );
  bit_counter_13_MC_XOR : X_XOR2
    port map (
      I0 => bit_counter_13_MC_D1,
      I1 => bit_counter_13_MC_D2,
      O => bit_counter_13_MC_D_TFF
    );
  bit_counter_14_Q : X_BUF
    port map (
      I => bit_counter_14_MC_Q,
      O => bit_counter(14)
    );
  bit_counter_14_MC_R_OR_PRLD_166 : X_OR2
    port map (
      I0 => FOOBAR1_ctinst_5,
      I1 => PRLD,
      O => bit_counter_14_MC_R_OR_PRLD
    );
  bit_counter_14_MC_REG : X_FF
    port map (
      I => bit_counter_14_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_14_MC_R_OR_PRLD,
      O => bit_counter_14_MC_Q
    );
  bit_counter_14_MC_D1_PT_0_167 : X_AND16
    port map (
      I0 => bit_counter(0),
      I1 => bit_counter(1),
      I2 => bit_counter(2),
      I3 => bit_counter(3),
      I4 => bit_counter(4),
      I5 => bit_counter(5),
      I6 => bit_counter(6),
      I7 => bit_counter(7),
      I8 => bit_counter(8),
      I9 => bit_counter(9),
      I10 => bit_counter(10),
      I11 => bit_counter(11),
      I12 => bit_counter(12),
      I13 => bit_counter(13),
      I14 => VCC,
      I15 => VCC,
      O => bit_counter_14_MC_D1_PT_0
    );
  bit_counter_14_MC_D1_168 : X_OR2
    port map (
      I0 => bit_counter_14_MC_D1_PT_0,
      I1 => bit_counter_14_MC_D1_PT_0,
      O => bit_counter_14_MC_D1
    );
  bit_counter_14_MC_D2_169 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_14_MC_D2
    );
  bit_counter_14_MC_D_170 : X_XOR2
    port map (
      I0 => bit_counter_14_MC_D_TFF,
      I1 => bit_counter_14_MC_Q,
      O => bit_counter_14_MC_D
    );
  bit_counter_14_MC_XOR : X_XOR2
    port map (
      I0 => bit_counter_14_MC_D1,
      I1 => bit_counter_14_MC_D2,
      O => bit_counter_14_MC_D_TFF
    );
  bit_counter_15_Q : X_BUF
    port map (
      I => bit_counter_15_MC_Q,
      O => bit_counter(15)
    );
  bit_counter_15_MC_R_OR_PRLD_171 : X_OR2
    port map (
      I0 => FOOBAR1_ctinst_5,
      I1 => PRLD,
      O => bit_counter_15_MC_R_OR_PRLD
    );
  bit_counter_15_MC_REG : X_FF
    port map (
      I => bit_counter_15_MC_D,
      CE => VCC,
      CLK => bitclk_II_FCLK,
      SET => GND,
      RST => bit_counter_15_MC_R_OR_PRLD,
      O => bit_counter_15_MC_Q
    );
  bit_counter_15_MC_D1_PT_0_172 : X_AND16
    port map (
      I0 => bit_counter(0),
      I1 => bit_counter(1),
      I2 => bit_counter(2),
      I3 => bit_counter(3),
      I4 => bit_counter(4),
      I5 => bit_counter(5),
      I6 => bit_counter(6),
      I7 => bit_counter(7),
      I8 => bit_counter(8),
      I9 => bit_counter(9),
      I10 => bit_counter(10),
      I11 => bit_counter(11),
      I12 => bit_counter(12),
      I13 => bit_counter(13),
      I14 => bit_counter(14),
      I15 => VCC,
      O => bit_counter_15_MC_D1_PT_0
    );
  bit_counter_15_MC_D1_173 : X_OR2
    port map (
      I0 => bit_counter_15_MC_D1_PT_0,
      I1 => bit_counter_15_MC_D1_PT_0,
      O => bit_counter_15_MC_D1
    );
  bit_counter_15_MC_D2_174 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => bit_counter_15_MC_D2
    );
  bit_counter_15_MC_D_175 : X_XOR2
    port map (
      I0 => bit_counter_15_MC_D_TFF,
      I1 => bit_counter_15_MC_Q,
      O => bit_counter_15_MC_D
    );
  bit_counter_15_MC_XOR : X_XOR2
    port map (
      I0 => bit_counter_15_MC_D1,
      I1 => bit_counter_15_MC_D2,
      O => bit_counter_15_MC_D_TFF
    );
  transmitter_done_II_UIM_176 : X_BUF
    port map (
      I => transmitter_done,
      O => transmitter_done_II_UIM
    );
  N_PZ_198_177 : X_BUF
    port map (
      I => N_PZ_198_MC_Q,
      O => N_PZ_198
    );
  N_PZ_198_MC_REG : X_BUF
    port map (
      I => N_PZ_198_MC_D,
      O => N_PZ_198_MC_Q
    );
  N_PZ_198_MC_D1_PT_0_178 : X_AND4
    port map (
      I0 => slave_cur_state_ffd2,
      I1 => NlwInverterSignal_N_PZ_198_MC_D1_PT_0_IN1,
      I2 => NlwInverterSignal_N_PZ_198_MC_D1_PT_0_IN2,
      I3 => slave_cur_state_ffd1,
      O => N_PZ_198_MC_D1_PT_0
    );
  N_PZ_198_MC_D1_179 : X_OR2
    port map (
      I0 => N_PZ_198_MC_D1_PT_0,
      I1 => N_PZ_198_MC_D1_PT_0,
      O => N_PZ_198_MC_D1
    );
  N_PZ_198_MC_D2_180 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => N_PZ_198_MC_D2
    );
  N_PZ_198_MC_XOR : X_XOR2
    port map (
      I0 => N_PZ_198_MC_D1,
      I1 => N_PZ_198_MC_D2,
      O => N_PZ_198_MC_D
    );
  Q_n0098_181 : X_BUF
    port map (
      I => Q_n0098_MC_Q,
      O => Q_n0098
    );
  Q_n0098_MC_REG : X_BUF
    port map (
      I => Q_n0098_MC_D,
      O => Q_n0098_MC_Q
    );
  Q_n0098_MC_D1_182 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => Q_n0098_MC_D1
    );
  Q_n0098_MC_D2_PT_0_183 : X_AND2
    port map (
      I0 => cfg_response_mask_0_II_UIM,
      I1 => receiver_sr_2_II_UIM,
      O => Q_n0098_MC_D2_PT_0
    );
  Q_n0098_MC_D2_PT_1_184 : X_AND2
    port map (
      I0 => cfg_response_mask_1_II_UIM,
      I1 => receiver_sr_3_II_UIM,
      O => Q_n0098_MC_D2_PT_1
    );
  Q_n0098_MC_D2_PT_2_185 : X_AND2
    port map (
      I0 => cfg_response_mask_2_II_UIM,
      I1 => receiver_sr_4_II_UIM,
      O => Q_n0098_MC_D2_PT_2
    );
  Q_n0098_MC_D2_PT_3_186 : X_AND2
    port map (
      I0 => cfg_response_mask_3_II_UIM,
      I1 => receiver_sr_5_II_UIM,
      O => Q_n0098_MC_D2_PT_3
    );
  Q_n0098_MC_D2_PT_4_187 : X_AND2
    port map (
      I0 => cfg_response_mask_4_II_UIM,
      I1 => receiver_sr_6_II_UIM,
      O => Q_n0098_MC_D2_PT_4
    );
  Q_n0098_MC_D2_PT_5_188 : X_AND2
    port map (
      I0 => cfg_response_mask_5_II_UIM,
      I1 => receiver_sr_7_II_UIM,
      O => Q_n0098_MC_D2_PT_5
    );
  Q_n0098_MC_D2_189 : X_OR6
    port map (
      I0 => Q_n0098_MC_D2_PT_0,
      I1 => Q_n0098_MC_D2_PT_1,
      I2 => Q_n0098_MC_D2_PT_2,
      I3 => Q_n0098_MC_D2_PT_3,
      I4 => Q_n0098_MC_D2_PT_4,
      I5 => Q_n0098_MC_D2_PT_5,
      O => Q_n0098_MC_D2
    );
  Q_n0098_MC_XOR : X_XOR2
    port map (
      I0 => Q_n0098_MC_D1,
      I1 => Q_n0098_MC_D2,
      O => Q_n0098_MC_D
    );
  cfg_response_mask_0_II_UIM_190 : X_BUF
    port map (
      I => cfg_response_mask(0),
      O => cfg_response_mask_0_II_UIM
    );
  cfg_response_mask_1_II_UIM_191 : X_BUF
    port map (
      I => cfg_response_mask(1),
      O => cfg_response_mask_1_II_UIM
    );
  receiver_sr_3_II_UIM_192 : X_BUF
    port map (
      I => receiver_sr(3),
      O => receiver_sr_3_II_UIM
    );
  cfg_response_mask_2_II_UIM_193 : X_BUF
    port map (
      I => cfg_response_mask(2),
      O => cfg_response_mask_2_II_UIM
    );
  receiver_sr_4_II_UIM_194 : X_BUF
    port map (
      I => receiver_sr(4),
      O => receiver_sr_4_II_UIM
    );
  cfg_response_mask_3_II_UIM_195 : X_BUF
    port map (
      I => cfg_response_mask(3),
      O => cfg_response_mask_3_II_UIM
    );
  receiver_sr_5_II_UIM_196 : X_BUF
    port map (
      I => receiver_sr(5),
      O => receiver_sr_5_II_UIM
    );
  cfg_response_mask_4_II_UIM_197 : X_BUF
    port map (
      I => cfg_response_mask(4),
      O => cfg_response_mask_4_II_UIM
    );
  receiver_sr_6_II_UIM_198 : X_BUF
    port map (
      I => receiver_sr(6),
      O => receiver_sr_6_II_UIM
    );
  cfg_response_mask_5_II_UIM_199 : X_BUF
    port map (
      I => cfg_response_mask(5),
      O => cfg_response_mask_5_II_UIM
    );
  receiver_sr_7_II_UIM_200 : X_BUF
    port map (
      I => receiver_sr(7),
      O => receiver_sr_7_II_UIM
    );
  transmitter_rst_MC_Q_201 : X_BUF
    port map (
      I => transmitter_rst_MC_Q_tsim_ireg_Q,
      O => transmitter_rst_MC_Q
    );
  transmitter_rst_MC_REG : X_BUF
    port map (
      I => transmitter_rst_MC_D,
      O => transmitter_rst_MC_Q_tsim_ireg_Q
    );
  transmitter_rst_MC_D1_PT_0_202 : X_AND5
    port map (
      I0 => NlwInverterSignal_transmitter_rst_MC_D1_PT_0_IN0,
      I1 => NlwInverterSignal_transmitter_rst_MC_D1_PT_0_IN1,
      I2 => NlwInverterSignal_transmitter_rst_MC_D1_PT_0_IN2,
      I3 => slave_cur_state_ffd1,
      I4 => NlwInverterSignal_transmitter_rst_MC_D1_PT_0_IN4,
      O => transmitter_rst_MC_D1_PT_0
    );
  transmitter_rst_MC_D1_203 : X_OR2
    port map (
      I0 => transmitter_rst_MC_D1_PT_0,
      I1 => transmitter_rst_MC_D1_PT_0,
      O => transmitter_rst_MC_D1
    );
  transmitter_rst_MC_D2_204 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => transmitter_rst_MC_D2
    );
  transmitter_rst_MC_XOR : X_XOR2
    port map (
      I0 => transmitter_rst_MC_D1,
      I1 => transmitter_rst_MC_D2,
      O => transmitter_rst_MC_D
    );
  transmitter_rst_MC_UIM_205 : X_BUF
    port map (
      I => transmitter_rst_MC_Q_tsim_ireg_Q,
      O => transmitter_rst_MC_UIM
    );
  receiver_sr_0_II_UIM_206 : X_BUF
    port map (
      I => receiver_sr(0),
      O => receiver_sr_0_II_UIM
    );
  receiver_sr_1_II_UIM_207 : X_BUF
    port map (
      I => receiver_sr(1),
      O => receiver_sr_1_II_UIM
    );
  clk_II_FCLK_208 : X_BUF
    port map (
      I => clk,
      O => clk_II_FCLK
    );
  rst_II_FSR_209 : X_BUF
    port map (
      I => rst,
      O => rst_II_FSR
    );
  byte_counter_1_Q : X_BUF
    port map (
      I => byte_counter_1_MC_Q,
      O => byte_counter(1)
    );
  byte_counter_1_MC_R_OR_PRLD_210 : X_OR2
    port map (
      I0 => rst_II_FSR,
      I1 => PRLD,
      O => byte_counter_1_MC_R_OR_PRLD
    );
  byte_counter_1_MC_REG : X_FF
    port map (
      I => byte_counter_1_MC_D,
      CE => VCC,
      CLK => clk_II_FCLK,
      SET => GND,
      RST => byte_counter_1_MC_R_OR_PRLD,
      O => byte_counter_1_MC_Q
    );
  byte_counter_1_MC_D1_211 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => byte_counter_1_MC_D1
    );
  byte_counter_1_MC_D2_PT_0_212 : X_AND7
    port map (
      I0 => receiver_done_II_UIM,
      I1 => NlwInverterSignal_byte_counter_1_MC_D2_PT_0_IN1,
      I2 => NlwInverterSignal_byte_counter_1_MC_D2_PT_0_IN2,
      I3 => slave_cur_state_ffd4,
      I4 => slave_cur_state_ffd3,
      I5 => NlwInverterSignal_byte_counter_1_MC_D2_PT_0_IN5,
      I6 => NlwInverterSignal_byte_counter_1_MC_D2_PT_0_IN6,
      O => byte_counter_1_MC_D2_PT_0
    );
  byte_counter_1_MC_D2_PT_1_213 : X_AND7
    port map (
      I0 => NlwInverterSignal_byte_counter_1_MC_D2_PT_1_IN0,
      I1 => slave_cur_state_ffd2,
      I2 => NlwInverterSignal_byte_counter_1_MC_D2_PT_1_IN2,
      I3 => NlwInverterSignal_byte_counter_1_MC_D2_PT_1_IN3,
      I4 => NlwInverterSignal_byte_counter_1_MC_D2_PT_1_IN4,
      I5 => NlwInverterSignal_byte_counter_1_MC_D2_PT_1_IN5,
      I6 => transmitter_done_II_UIM,
      O => byte_counter_1_MC_D2_PT_1
    );
  byte_counter_1_MC_D2_214 : X_OR2
    port map (
      I0 => byte_counter_1_MC_D2_PT_0,
      I1 => byte_counter_1_MC_D2_PT_1,
      O => byte_counter_1_MC_D2
    );
  byte_counter_1_MC_D_215 : X_XOR2
    port map (
      I0 => byte_counter_1_MC_D_TFF,
      I1 => byte_counter_1_MC_Q,
      O => byte_counter_1_MC_D
    );
  byte_counter_1_MC_XOR : X_XOR2
    port map (
      I0 => byte_counter_1_MC_D1,
      I1 => byte_counter_1_MC_D2,
      O => byte_counter_1_MC_D_TFF
    );
  byte_counter_2_Q : X_BUF
    port map (
      I => byte_counter_2_MC_Q,
      O => byte_counter(2)
    );
  byte_counter_2_MC_R_OR_PRLD_216 : X_OR2
    port map (
      I0 => rst_II_FSR,
      I1 => PRLD,
      O => byte_counter_2_MC_R_OR_PRLD
    );
  byte_counter_2_MC_REG : X_FF
    port map (
      I => byte_counter_2_MC_D,
      CE => VCC,
      CLK => clk_II_FCLK,
      SET => GND,
      RST => byte_counter_2_MC_R_OR_PRLD,
      O => byte_counter_2_MC_Q
    );
  byte_counter_2_MC_D1_217 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => byte_counter_2_MC_D1
    );
  byte_counter_2_MC_D2_PT_0_218 : X_AND8
    port map (
      I0 => receiver_done_II_UIM,
      I1 => NlwInverterSignal_byte_counter_2_MC_D2_PT_0_IN1,
      I2 => NlwInverterSignal_byte_counter_2_MC_D2_PT_0_IN2,
      I3 => slave_cur_state_ffd4,
      I4 => slave_cur_state_ffd3,
      I5 => NlwInverterSignal_byte_counter_2_MC_D2_PT_0_IN5,
      I6 => NlwInverterSignal_byte_counter_2_MC_D2_PT_0_IN6,
      I7 => NlwInverterSignal_byte_counter_2_MC_D2_PT_0_IN7,
      O => byte_counter_2_MC_D2_PT_0
    );
  byte_counter_2_MC_D2_PT_1_219 : X_AND8
    port map (
      I0 => NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN0,
      I1 => slave_cur_state_ffd2,
      I2 => NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN2,
      I3 => NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN3,
      I4 => NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN4,
      I5 => NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN5,
      I6 => NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN6,
      I7 => transmitter_done_II_UIM,
      O => byte_counter_2_MC_D2_PT_1
    );
  byte_counter_2_MC_D2_220 : X_OR2
    port map (
      I0 => byte_counter_2_MC_D2_PT_0,
      I1 => byte_counter_2_MC_D2_PT_1,
      O => byte_counter_2_MC_D2
    );
  byte_counter_2_MC_D_221 : X_XOR2
    port map (
      I0 => byte_counter_2_MC_D_TFF,
      I1 => byte_counter_2_MC_Q,
      O => byte_counter_2_MC_D
    );
  byte_counter_2_MC_XOR : X_XOR2
    port map (
      I0 => byte_counter_2_MC_D1,
      I1 => byte_counter_2_MC_D2,
      O => byte_counter_2_MC_D_TFF
    );
  byte_counter_3_Q : X_BUF
    port map (
      I => byte_counter_3_MC_Q,
      O => byte_counter(3)
    );
  byte_counter_3_MC_R_OR_PRLD_222 : X_OR2
    port map (
      I0 => rst_II_FSR,
      I1 => PRLD,
      O => byte_counter_3_MC_R_OR_PRLD
    );
  byte_counter_3_MC_REG : X_FF
    port map (
      I => byte_counter_3_MC_D,
      CE => VCC,
      CLK => clk_II_FCLK,
      SET => GND,
      RST => byte_counter_3_MC_R_OR_PRLD,
      O => byte_counter_3_MC_Q
    );
  byte_counter_3_MC_D1_223 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => byte_counter_3_MC_D1
    );
  byte_counter_3_MC_D2_PT_0_224 : X_AND16
    port map (
      I0 => receiver_done_II_UIM,
      I1 => NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN1,
      I2 => NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN2,
      I3 => slave_cur_state_ffd4,
      I4 => slave_cur_state_ffd3,
      I5 => NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN5,
      I6 => NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN6,
      I7 => NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN7,
      I8 => NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN8,
      I9 => VCC,
      I10 => VCC,
      I11 => VCC,
      I12 => VCC,
      I13 => VCC,
      I14 => VCC,
      I15 => VCC,
      O => byte_counter_3_MC_D2_PT_0
    );
  byte_counter_3_MC_D2_PT_1_225 : X_AND16
    port map (
      I0 => NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN0,
      I1 => slave_cur_state_ffd2,
      I2 => NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN2,
      I3 => NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN3,
      I4 => NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN4,
      I5 => NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN5,
      I6 => NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN6,
      I7 => NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN7,
      I8 => transmitter_done_II_UIM,
      I9 => VCC,
      I10 => VCC,
      I11 => VCC,
      I12 => VCC,
      I13 => VCC,
      I14 => VCC,
      I15 => VCC,
      O => byte_counter_3_MC_D2_PT_1
    );
  byte_counter_3_MC_D2_226 : X_OR2
    port map (
      I0 => byte_counter_3_MC_D2_PT_0,
      I1 => byte_counter_3_MC_D2_PT_1,
      O => byte_counter_3_MC_D2
    );
  byte_counter_3_MC_D_227 : X_XOR2
    port map (
      I0 => byte_counter_3_MC_D_TFF,
      I1 => byte_counter_3_MC_Q,
      O => byte_counter_3_MC_D
    );
  byte_counter_3_MC_XOR : X_XOR2
    port map (
      I0 => byte_counter_3_MC_D1,
      I1 => byte_counter_3_MC_D2,
      O => byte_counter_3_MC_D_TFF
    );
  pr0_II_UIM_228 : X_BUF
    port map (
      I => pr0,
      O => pr0_II_UIM
    );
  pr1_II_UIM_229 : X_BUF
    port map (
      I => pr1,
      O => pr1_II_UIM
    );
  cfg_receive_mask_1_II_UIM_230 : X_BUF
    port map (
      I => cfg_receive_mask(1),
      O => cfg_receive_mask_1_II_UIM
    );
  cfg_receive_mask_2_II_UIM_231 : X_BUF
    port map (
      I => cfg_receive_mask(2),
      O => cfg_receive_mask_2_II_UIM
    );
  cfg_receive_mask_3_II_UIM_232 : X_BUF
    port map (
      I => cfg_receive_mask(3),
      O => cfg_receive_mask_3_II_UIM
    );
  cfg_receive_mask_4_II_UIM_233 : X_BUF
    port map (
      I => cfg_receive_mask(4),
      O => cfg_receive_mask_4_II_UIM
    );
  cfg_receive_mask_5_II_UIM_234 : X_BUF
    port map (
      I => cfg_receive_mask(5),
      O => cfg_receive_mask_5_II_UIM
    );
  slave_cur_state_xx_ffd228_235 : X_BUF
    port map (
      I => slave_cur_state_xx_ffd228_MC_Q,
      O => slave_cur_state_xx_ffd228
    );
  slave_cur_state_xx_ffd228_MC_REG : X_BUF
    port map (
      I => slave_cur_state_xx_ffd228_MC_D,
      O => slave_cur_state_xx_ffd228_MC_Q
    );
  slave_cur_state_xx_ffd228_MC_D1_236 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => slave_cur_state_xx_ffd228_MC_D1
    );
  slave_cur_state_xx_ffd228_MC_D2_PT_0_237 : X_AND2
    port map (
      I0 => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_0_IN0,
      I1 => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_0_IN1,
      O => slave_cur_state_xx_ffd228_MC_D2_PT_0
    );
  slave_cur_state_xx_ffd228_MC_D2_PT_1_238 : X_AND2
    port map (
      I0 => slave_cur_state_ffd4,
      I1 => slave_cur_state_ffd4,
      O => slave_cur_state_xx_ffd228_MC_D2_PT_1
    );
  slave_cur_state_xx_ffd228_MC_D2_PT_2_239 : X_AND2
    port map (
      I0 => slave_cur_state_ffd1,
      I1 => slave_cur_state_ffd1,
      O => slave_cur_state_xx_ffd228_MC_D2_PT_2
    );
  slave_cur_state_xx_ffd228_MC_D2_PT_3_240 : X_AND2
    port map (
      I0 => Q_n0060,
      I1 => Q_n0060,
      O => slave_cur_state_xx_ffd228_MC_D2_PT_3
    );
  slave_cur_state_xx_ffd228_MC_D2_PT_4_241 : X_AND2
    port map (
      I0 => ser_in_II_UIM,
      I1 => ser_in_II_UIM,
      O => slave_cur_state_xx_ffd228_MC_D2_PT_4
    );
  slave_cur_state_xx_ffd228_MC_D2_PT_5_242 : X_AND16
    port map (
      I0 => bit_counter(0),
      I1 => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN1,
      I2 => bit_counter(2),
      I3 => bit_counter(3),
      I4 => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN4,
      I5 => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN5,
      I6 => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN6,
      I7 => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN7,
      I8 => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN8,
      I9 => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN9,
      I10 => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN10,
      I11 => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN11,
      I12 => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN12,
      I13 => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN13,
      I14 => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN14,
      I15 => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN15,
      O => slave_cur_state_xx_ffd228_MC_D2_PT_5
    );
  slave_cur_state_xx_ffd228_MC_D2_243 : X_OR6
    port map (
      I0 => slave_cur_state_xx_ffd228_MC_D2_PT_0,
      I1 => slave_cur_state_xx_ffd228_MC_D2_PT_1,
      I2 => slave_cur_state_xx_ffd228_MC_D2_PT_2,
      I3 => slave_cur_state_xx_ffd228_MC_D2_PT_3,
      I4 => slave_cur_state_xx_ffd228_MC_D2_PT_4,
      I5 => slave_cur_state_xx_ffd228_MC_D2_PT_5,
      O => slave_cur_state_xx_ffd228_MC_D2
    );
  slave_cur_state_xx_ffd228_MC_XOR : X_XOR2
    port map (
      I0 => slave_cur_state_xx_ffd228_MC_D1,
      I1 => slave_cur_state_xx_ffd228_MC_D2,
      O => slave_cur_state_xx_ffd228_MC_D
    );
  checksum_en_244 : X_BUF
    port map (
      I => checksum_en_MC_Q,
      O => checksum_en
    );
  checksum_en_MC_Q_245 : X_BUF
    port map (
      I => checksum_en_MC_Q_tsim_ireg_Q,
      O => checksum_en_MC_Q
    );
  checksum_en_MC_REG : X_BUF
    port map (
      I => checksum_en_MC_D,
      O => checksum_en_MC_Q_tsim_ireg_Q
    );
  checksum_en_MC_D1_246 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => checksum_en_MC_D1
    );
  checksum_en_MC_D2_PT_0_247 : X_AND6
    port map (
      I0 => receiver_done_II_UIM,
      I1 => NlwInverterSignal_checksum_en_MC_D2_PT_0_IN1,
      I2 => slave_cur_state_ffd4,
      I3 => slave_cur_state_ffd3,
      I4 => NlwInverterSignal_checksum_en_MC_D2_PT_0_IN4,
      I5 => NlwInverterSignal_checksum_en_MC_D2_PT_0_IN5,
      O => checksum_en_MC_D2_PT_0
    );
  checksum_en_MC_D2_PT_1_248 : X_AND6
    port map (
      I0 => slave_cur_state_ffd2,
      I1 => NlwInverterSignal_checksum_en_MC_D2_PT_1_IN1,
      I2 => NlwInverterSignal_checksum_en_MC_D2_PT_1_IN2,
      I3 => NlwInverterSignal_checksum_en_MC_D2_PT_1_IN3,
      I4 => NlwInverterSignal_checksum_en_MC_D2_PT_1_IN4,
      I5 => transmitter_done_II_UIM,
      O => checksum_en_MC_D2_PT_1
    );
  checksum_en_MC_D2_249 : X_OR2
    port map (
      I0 => checksum_en_MC_D2_PT_0,
      I1 => checksum_en_MC_D2_PT_1,
      O => checksum_en_MC_D2
    );
  checksum_en_MC_XOR : X_XOR2
    port map (
      I0 => checksum_en_MC_D1,
      I1 => checksum_en_MC_D2,
      O => checksum_en_MC_D
    );
  parity_check_0_Q : X_BUF
    port map (
      I => parity_check_0_MC_Q,
      O => parity_check(0)
    );
  parity_check_0_MC_Q_250 : X_BUF
    port map (
      I => parity_check_0_MC_Q_tsim_ireg_Q,
      O => parity_check_0_MC_Q
    );
  parity_check_0_MC_REG : X_BUF
    port map (
      I => parity_check_0_MC_D,
      O => parity_check_0_MC_Q_tsim_ireg_Q
    );
  parity_check_0_MC_D1_PT_0_251 : X_AND2
    port map (
      I0 => receiver_sr_2_II_UIM,
      I1 => receiver_sr_2_II_UIM,
      O => parity_check_0_MC_D1_PT_0
    );
  parity_check_0_MC_D1_252 : X_OR2
    port map (
      I0 => parity_check_0_MC_D1_PT_0,
      I1 => parity_check_0_MC_D1_PT_0,
      O => parity_check_0_MC_D1
    );
  parity_check_0_MC_D2_253 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => parity_check_0_MC_D2
    );
  parity_check_0_MC_XOR : X_XOR2
    port map (
      I0 => parity_check_0_MC_D1,
      I1 => parity_check_0_MC_D2,
      O => parity_check_0_MC_D
    );
  parity_check_1_Q : X_BUF
    port map (
      I => parity_check_1_MC_Q,
      O => parity_check(1)
    );
  parity_check_1_MC_Q_254 : X_BUF
    port map (
      I => parity_check_1_MC_Q_tsim_ireg_Q,
      O => parity_check_1_MC_Q
    );
  parity_check_1_MC_REG : X_BUF
    port map (
      I => parity_check_1_MC_D,
      O => parity_check_1_MC_Q_tsim_ireg_Q
    );
  parity_check_1_MC_D1_PT_0_255 : X_AND2
    port map (
      I0 => receiver_sr_3_II_UIM,
      I1 => receiver_sr_3_II_UIM,
      O => parity_check_1_MC_D1_PT_0
    );
  parity_check_1_MC_D1_256 : X_OR2
    port map (
      I0 => parity_check_1_MC_D1_PT_0,
      I1 => parity_check_1_MC_D1_PT_0,
      O => parity_check_1_MC_D1
    );
  parity_check_1_MC_D2_257 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => parity_check_1_MC_D2
    );
  parity_check_1_MC_XOR : X_XOR2
    port map (
      I0 => parity_check_1_MC_D1,
      I1 => parity_check_1_MC_D2,
      O => parity_check_1_MC_D
    );
  parity_check_2_Q : X_BUF
    port map (
      I => parity_check_2_MC_Q,
      O => parity_check(2)
    );
  parity_check_2_MC_Q_258 : X_BUF
    port map (
      I => parity_check_2_MC_Q_tsim_ireg_Q,
      O => parity_check_2_MC_Q
    );
  parity_check_2_MC_REG : X_BUF
    port map (
      I => parity_check_2_MC_D,
      O => parity_check_2_MC_Q_tsim_ireg_Q
    );
  parity_check_2_MC_D1_PT_0_259 : X_AND2
    port map (
      I0 => receiver_sr_4_II_UIM,
      I1 => receiver_sr_4_II_UIM,
      O => parity_check_2_MC_D1_PT_0
    );
  parity_check_2_MC_D1_260 : X_OR2
    port map (
      I0 => parity_check_2_MC_D1_PT_0,
      I1 => parity_check_2_MC_D1_PT_0,
      O => parity_check_2_MC_D1
    );
  parity_check_2_MC_D2_261 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => parity_check_2_MC_D2
    );
  parity_check_2_MC_XOR : X_XOR2
    port map (
      I0 => parity_check_2_MC_D1,
      I1 => parity_check_2_MC_D2,
      O => parity_check_2_MC_D
    );
  parity_check_3_Q : X_BUF
    port map (
      I => parity_check_3_MC_Q,
      O => parity_check(3)
    );
  parity_check_3_MC_Q_262 : X_BUF
    port map (
      I => parity_check_3_MC_Q_tsim_ireg_Q,
      O => parity_check_3_MC_Q
    );
  parity_check_3_MC_REG : X_BUF
    port map (
      I => parity_check_3_MC_D,
      O => parity_check_3_MC_Q_tsim_ireg_Q
    );
  parity_check_3_MC_D1_PT_0_263 : X_AND2
    port map (
      I0 => receiver_sr_5_II_UIM,
      I1 => receiver_sr_5_II_UIM,
      O => parity_check_3_MC_D1_PT_0
    );
  parity_check_3_MC_D1_264 : X_OR2
    port map (
      I0 => parity_check_3_MC_D1_PT_0,
      I1 => parity_check_3_MC_D1_PT_0,
      O => parity_check_3_MC_D1
    );
  parity_check_3_MC_D2_265 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => parity_check_3_MC_D2
    );
  parity_check_3_MC_XOR : X_XOR2
    port map (
      I0 => parity_check_3_MC_D1,
      I1 => parity_check_3_MC_D2,
      O => parity_check_3_MC_D
    );
  parity_check_4_Q : X_BUF
    port map (
      I => parity_check_4_MC_Q,
      O => parity_check(4)
    );
  parity_check_4_MC_Q_266 : X_BUF
    port map (
      I => parity_check_4_MC_Q_tsim_ireg_Q,
      O => parity_check_4_MC_Q
    );
  parity_check_4_MC_REG : X_BUF
    port map (
      I => parity_check_4_MC_D,
      O => parity_check_4_MC_Q_tsim_ireg_Q
    );
  parity_check_4_MC_D1_PT_0_267 : X_AND2
    port map (
      I0 => receiver_sr_6_II_UIM,
      I1 => receiver_sr_6_II_UIM,
      O => parity_check_4_MC_D1_PT_0
    );
  parity_check_4_MC_D1_268 : X_OR2
    port map (
      I0 => parity_check_4_MC_D1_PT_0,
      I1 => parity_check_4_MC_D1_PT_0,
      O => parity_check_4_MC_D1
    );
  parity_check_4_MC_D2_269 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => parity_check_4_MC_D2
    );
  parity_check_4_MC_XOR : X_XOR2
    port map (
      I0 => parity_check_4_MC_D1,
      I1 => parity_check_4_MC_D2,
      O => parity_check_4_MC_D
    );
  parity_check_5_Q : X_BUF
    port map (
      I => parity_check_5_MC_Q,
      O => parity_check(5)
    );
  parity_check_5_MC_Q_270 : X_BUF
    port map (
      I => parity_check_5_MC_Q_tsim_ireg_Q,
      O => parity_check_5_MC_Q
    );
  parity_check_5_MC_REG : X_BUF
    port map (
      I => parity_check_5_MC_D,
      O => parity_check_5_MC_Q_tsim_ireg_Q
    );
  parity_check_5_MC_D1_PT_0_271 : X_AND2
    port map (
      I0 => receiver_sr_7_II_UIM,
      I1 => receiver_sr_7_II_UIM,
      O => parity_check_5_MC_D1_PT_0
    );
  parity_check_5_MC_D1_272 : X_OR2
    port map (
      I0 => parity_check_5_MC_D1_PT_0,
      I1 => parity_check_5_MC_D1_PT_0,
      O => parity_check_5_MC_D1
    );
  parity_check_5_MC_D2_273 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => parity_check_5_MC_D2
    );
  parity_check_5_MC_XOR : X_XOR2
    port map (
      I0 => parity_check_5_MC_D1,
      I1 => parity_check_5_MC_D2,
      O => parity_check_5_MC_D
    );
  receive_0_Q : X_BUF
    port map (
      I => receive_0_MC_Q,
      O => receive(0)
    );
  receive_0_MC_Q_274 : X_BUF
    port map (
      I => receive_0_MC_Q_tsim_ireg_Q,
      O => receive_0_MC_Q
    );
  receive_0_MC_REG : X_BUF
    port map (
      I => receive_0_MC_D,
      O => receive_0_MC_Q_tsim_ireg_Q
    );
  receive_0_MC_D1_PT_0_275 : X_AND2
    port map (
      I0 => receiver_sr_0_II_UIM,
      I1 => receiver_sr_0_II_UIM,
      O => receive_0_MC_D1_PT_0
    );
  receive_0_MC_D1_276 : X_OR2
    port map (
      I0 => receive_0_MC_D1_PT_0,
      I1 => receive_0_MC_D1_PT_0,
      O => receive_0_MC_D1
    );
  receive_0_MC_D2_277 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => receive_0_MC_D2
    );
  receive_0_MC_XOR : X_XOR2
    port map (
      I0 => receive_0_MC_D1,
      I1 => receive_0_MC_D2,
      O => receive_0_MC_D
    );
  receive_1_Q : X_BUF
    port map (
      I => receive_1_MC_Q,
      O => receive(1)
    );
  receive_1_MC_Q_278 : X_BUF
    port map (
      I => receive_1_MC_Q_tsim_ireg_Q,
      O => receive_1_MC_Q
    );
  receive_1_MC_REG : X_BUF
    port map (
      I => receive_1_MC_D,
      O => receive_1_MC_Q_tsim_ireg_Q
    );
  receive_1_MC_D1_PT_0_279 : X_AND2
    port map (
      I0 => receiver_sr_1_II_UIM,
      I1 => receiver_sr_1_II_UIM,
      O => receive_1_MC_D1_PT_0
    );
  receive_1_MC_D1_280 : X_OR2
    port map (
      I0 => receive_1_MC_D1_PT_0,
      I1 => receive_1_MC_D1_PT_0,
      O => receive_1_MC_D1
    );
  receive_1_MC_D2_281 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => receive_1_MC_D2
    );
  receive_1_MC_XOR : X_XOR2
    port map (
      I0 => receive_1_MC_D1,
      I1 => receive_1_MC_D2,
      O => receive_1_MC_D
    );
  receive_2_Q : X_BUF
    port map (
      I => receive_2_MC_Q,
      O => receive(2)
    );
  receive_2_MC_Q_282 : X_BUF
    port map (
      I => receive_2_MC_Q_tsim_ireg_Q,
      O => receive_2_MC_Q
    );
  receive_2_MC_REG : X_BUF
    port map (
      I => receive_2_MC_D,
      O => receive_2_MC_Q_tsim_ireg_Q
    );
  receive_2_MC_D1_PT_0_283 : X_AND2
    port map (
      I0 => receiver_sr_2_II_UIM,
      I1 => receiver_sr_2_II_UIM,
      O => receive_2_MC_D1_PT_0
    );
  receive_2_MC_D1_284 : X_OR2
    port map (
      I0 => receive_2_MC_D1_PT_0,
      I1 => receive_2_MC_D1_PT_0,
      O => receive_2_MC_D1
    );
  receive_2_MC_D2_285 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => receive_2_MC_D2
    );
  receive_2_MC_XOR : X_XOR2
    port map (
      I0 => receive_2_MC_D1,
      I1 => receive_2_MC_D2,
      O => receive_2_MC_D
    );
  receive_3_Q : X_BUF
    port map (
      I => receive_3_MC_Q,
      O => receive(3)
    );
  receive_3_MC_Q_286 : X_BUF
    port map (
      I => receive_3_MC_Q_tsim_ireg_Q,
      O => receive_3_MC_Q
    );
  receive_3_MC_REG : X_BUF
    port map (
      I => receive_3_MC_D,
      O => receive_3_MC_Q_tsim_ireg_Q
    );
  receive_3_MC_D1_PT_0_287 : X_AND2
    port map (
      I0 => receiver_sr_3_II_UIM,
      I1 => receiver_sr_3_II_UIM,
      O => receive_3_MC_D1_PT_0
    );
  receive_3_MC_D1_288 : X_OR2
    port map (
      I0 => receive_3_MC_D1_PT_0,
      I1 => receive_3_MC_D1_PT_0,
      O => receive_3_MC_D1
    );
  receive_3_MC_D2_289 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => receive_3_MC_D2
    );
  receive_3_MC_XOR : X_XOR2
    port map (
      I0 => receive_3_MC_D1,
      I1 => receive_3_MC_D2,
      O => receive_3_MC_D
    );
  receive_4_Q : X_BUF
    port map (
      I => receive_4_MC_Q,
      O => receive(4)
    );
  receive_4_MC_Q_290 : X_BUF
    port map (
      I => receive_4_MC_Q_tsim_ireg_Q,
      O => receive_4_MC_Q
    );
  receive_4_MC_REG : X_BUF
    port map (
      I => receive_4_MC_D,
      O => receive_4_MC_Q_tsim_ireg_Q
    );
  receive_4_MC_D1_PT_0_291 : X_AND2
    port map (
      I0 => receiver_sr_4_II_UIM,
      I1 => receiver_sr_4_II_UIM,
      O => receive_4_MC_D1_PT_0
    );
  receive_4_MC_D1_292 : X_OR2
    port map (
      I0 => receive_4_MC_D1_PT_0,
      I1 => receive_4_MC_D1_PT_0,
      O => receive_4_MC_D1
    );
  receive_4_MC_D2_293 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => receive_4_MC_D2
    );
  receive_4_MC_XOR : X_XOR2
    port map (
      I0 => receive_4_MC_D1,
      I1 => receive_4_MC_D2,
      O => receive_4_MC_D
    );
  receive_5_Q : X_BUF
    port map (
      I => receive_5_MC_Q,
      O => receive(5)
    );
  receive_5_MC_Q_294 : X_BUF
    port map (
      I => receive_5_MC_Q_tsim_ireg_Q,
      O => receive_5_MC_Q
    );
  receive_5_MC_REG : X_BUF
    port map (
      I => receive_5_MC_D,
      O => receive_5_MC_Q_tsim_ireg_Q
    );
  receive_5_MC_D1_PT_0_295 : X_AND2
    port map (
      I0 => receiver_sr_5_II_UIM,
      I1 => receiver_sr_5_II_UIM,
      O => receive_5_MC_D1_PT_0
    );
  receive_5_MC_D1_296 : X_OR2
    port map (
      I0 => receive_5_MC_D1_PT_0,
      I1 => receive_5_MC_D1_PT_0,
      O => receive_5_MC_D1
    );
  receive_5_MC_D2_297 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => receive_5_MC_D2
    );
  receive_5_MC_XOR : X_XOR2
    port map (
      I0 => receive_5_MC_D1,
      I1 => receive_5_MC_D2,
      O => receive_5_MC_D
    );
  receive_6_Q : X_BUF
    port map (
      I => receive_6_MC_Q,
      O => receive(6)
    );
  receive_6_MC_Q_298 : X_BUF
    port map (
      I => receive_6_MC_Q_tsim_ireg_Q,
      O => receive_6_MC_Q
    );
  receive_6_MC_REG : X_BUF
    port map (
      I => receive_6_MC_D,
      O => receive_6_MC_Q_tsim_ireg_Q
    );
  receive_6_MC_D1_PT_0_299 : X_AND2
    port map (
      I0 => receiver_sr_6_II_UIM,
      I1 => receiver_sr_6_II_UIM,
      O => receive_6_MC_D1_PT_0
    );
  receive_6_MC_D1_300 : X_OR2
    port map (
      I0 => receive_6_MC_D1_PT_0,
      I1 => receive_6_MC_D1_PT_0,
      O => receive_6_MC_D1
    );
  receive_6_MC_D2_301 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => receive_6_MC_D2
    );
  receive_6_MC_XOR : X_XOR2
    port map (
      I0 => receive_6_MC_D1,
      I1 => receive_6_MC_D2,
      O => receive_6_MC_D
    );
  receive_7_Q : X_BUF
    port map (
      I => receive_7_MC_Q,
      O => receive(7)
    );
  receive_7_MC_Q_302 : X_BUF
    port map (
      I => receive_7_MC_Q_tsim_ireg_Q,
      O => receive_7_MC_Q
    );
  receive_7_MC_REG : X_BUF
    port map (
      I => receive_7_MC_D,
      O => receive_7_MC_Q_tsim_ireg_Q
    );
  receive_7_MC_D1_PT_0_303 : X_AND2
    port map (
      I0 => receiver_sr_7_II_UIM,
      I1 => receiver_sr_7_II_UIM,
      O => receive_7_MC_D1_PT_0
    );
  receive_7_MC_D1_304 : X_OR2
    port map (
      I0 => receive_7_MC_D1_PT_0,
      I1 => receive_7_MC_D1_PT_0,
      O => receive_7_MC_D1
    );
  receive_7_MC_D2_305 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => receive_7_MC_D2
    );
  receive_7_MC_XOR : X_XOR2
    port map (
      I0 => receive_7_MC_D1,
      I1 => receive_7_MC_D2,
      O => receive_7_MC_D
    );
  receiver_rst_306 : X_BUF
    port map (
      I => receiver_rst_MC_Q,
      O => receiver_rst
    );
  receiver_rst_MC_Q_307 : X_BUF
    port map (
      I => receiver_rst_MC_Q_tsim_ireg_Q,
      O => receiver_rst_MC_Q
    );
  receiver_rst_MC_REG : X_BUF
    port map (
      I => receiver_rst_MC_D,
      O => receiver_rst_MC_Q_tsim_ireg_Q
    );
  receiver_rst_MC_D1_308 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => receiver_rst_MC_D1
    );
  receiver_rst_MC_D2_PT_0_309 : X_AND4
    port map (
      I0 => slave_cur_state_ffd4,
      I1 => NlwInverterSignal_receiver_rst_MC_D2_PT_0_IN1,
      I2 => NlwInverterSignal_receiver_rst_MC_D2_PT_0_IN2,
      I3 => NlwInverterSignal_receiver_rst_MC_D2_PT_0_IN3,
      O => receiver_rst_MC_D2_PT_0
    );
  receiver_rst_MC_D2_PT_1_310 : X_AND16
    port map (
      I0 => receiver_done_II_UIM,
      I1 => NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN1,
      I2 => NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN2,
      I3 => slave_cur_state_ffd3,
      I4 => slave_cur_state_ffd1,
      I5 => NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN5,
      I6 => NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN6,
      I7 => NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN7,
      I8 => receiver_sr_7_II_UIM,
      I9 => receiver_sr_5_II_UIM,
      I10 => receiver_sr_3_II_UIM,
      I11 => NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN11,
      I12 => NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN12,
      I13 => receiver_sr_1_II_UIM,
      I14 => VCC,
      I15 => VCC,
      O => receiver_rst_MC_D2_PT_1
    );
  receiver_rst_MC_D2_311 : X_OR2
    port map (
      I0 => receiver_rst_MC_D2_PT_0,
      I1 => receiver_rst_MC_D2_PT_1,
      O => receiver_rst_MC_D2
    );
  receiver_rst_MC_XOR : X_XOR2
    port map (
      I0 => receiver_rst_MC_D1,
      I1 => receiver_rst_MC_D2,
      O => receiver_rst_MC_D
    );
  snoop_cur_state_0_Q : X_BUF
    port map (
      I => snoop_cur_state_0_MC_Q,
      O => snoop_cur_state(0)
    );
  snoop_cur_state_0_MC_Q_312 : X_BUF
    port map (
      I => snoop_cur_state_0_MC_Q_tsim_ireg_Q,
      O => snoop_cur_state_0_MC_Q
    );
  snoop_cur_state_0_MC_REG : X_BUF
    port map (
      I => snoop_cur_state_0_MC_D,
      O => snoop_cur_state_0_MC_Q_tsim_ireg_Q
    );
  snoop_cur_state_0_MC_D1_313 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => snoop_cur_state_0_MC_D1
    );
  snoop_cur_state_0_MC_D2_PT_0_314 : X_AND2
    port map (
      I0 => slave_cur_state_ffd2,
      I1 => slave_cur_state_ffd3,
      O => snoop_cur_state_0_MC_D2_PT_0
    );
  snoop_cur_state_0_MC_D2_PT_1_315 : X_AND2
    port map (
      I0 => slave_cur_state_ffd4,
      I1 => NlwInverterSignal_snoop_cur_state_0_MC_D2_PT_1_IN1,
      O => snoop_cur_state_0_MC_D2_PT_1
    );
  snoop_cur_state_0_MC_D2_PT_2_316 : X_AND3
    port map (
      I0 => NlwInverterSignal_snoop_cur_state_0_MC_D2_PT_2_IN0,
      I1 => slave_cur_state_ffd4,
      I2 => NlwInverterSignal_snoop_cur_state_0_MC_D2_PT_2_IN2,
      O => snoop_cur_state_0_MC_D2_PT_2
    );
  snoop_cur_state_0_MC_D2_317 : X_OR3
    port map (
      I0 => snoop_cur_state_0_MC_D2_PT_0,
      I1 => snoop_cur_state_0_MC_D2_PT_1,
      I2 => snoop_cur_state_0_MC_D2_PT_2,
      O => snoop_cur_state_0_MC_D2
    );
  snoop_cur_state_0_MC_XOR : X_XOR2
    port map (
      I0 => snoop_cur_state_0_MC_D1,
      I1 => snoop_cur_state_0_MC_D2,
      O => snoop_cur_state_0_MC_D
    );
  snoop_cur_state_1_Q : X_BUF
    port map (
      I => snoop_cur_state_1_MC_Q,
      O => snoop_cur_state(1)
    );
  snoop_cur_state_1_MC_Q_318 : X_BUF
    port map (
      I => snoop_cur_state_1_MC_Q_tsim_ireg_Q,
      O => snoop_cur_state_1_MC_Q
    );
  snoop_cur_state_1_MC_REG : X_BUF
    port map (
      I => snoop_cur_state_1_MC_D,
      O => snoop_cur_state_1_MC_Q_tsim_ireg_Q
    );
  snoop_cur_state_1_MC_D1_PT_0_319 : X_AND2
    port map (
      I0 => NlwInverterSignal_snoop_cur_state_1_MC_D1_PT_0_IN0,
      I1 => NlwInverterSignal_snoop_cur_state_1_MC_D1_PT_0_IN1,
      O => snoop_cur_state_1_MC_D1_PT_0
    );
  snoop_cur_state_1_MC_D1_320 : X_OR2
    port map (
      I0 => snoop_cur_state_1_MC_D1_PT_0,
      I1 => snoop_cur_state_1_MC_D1_PT_0,
      O => snoop_cur_state_1_MC_D1
    );
  snoop_cur_state_1_MC_D2_PT_0_321 : X_AND2
    port map (
      I0 => NlwInverterSignal_snoop_cur_state_1_MC_D2_PT_0_IN0,
      I1 => slave_cur_state_ffd4,
      O => snoop_cur_state_1_MC_D2_PT_0
    );
  snoop_cur_state_1_MC_D2_PT_1_322 : X_AND2
    port map (
      I0 => NlwInverterSignal_snoop_cur_state_1_MC_D2_PT_1_IN0,
      I1 => slave_cur_state_ffd3,
      O => snoop_cur_state_1_MC_D2_PT_1
    );
  snoop_cur_state_1_MC_D2_323 : X_OR2
    port map (
      I0 => snoop_cur_state_1_MC_D2_PT_0,
      I1 => snoop_cur_state_1_MC_D2_PT_1,
      O => snoop_cur_state_1_MC_D2
    );
  snoop_cur_state_1_MC_XOR : X_XOR2
    port map (
      I0 => NlwInverterSignal_snoop_cur_state_1_MC_XOR_IN0,
      I1 => snoop_cur_state_1_MC_D2,
      O => snoop_cur_state_1_MC_D
    );
  snoop_cur_state_2_Q : X_BUF
    port map (
      I => snoop_cur_state_2_MC_Q,
      O => snoop_cur_state(2)
    );
  snoop_cur_state_2_MC_Q_324 : X_BUF
    port map (
      I => snoop_cur_state_2_MC_Q_tsim_ireg_Q,
      O => snoop_cur_state_2_MC_Q
    );
  snoop_cur_state_2_MC_REG : X_BUF
    port map (
      I => snoop_cur_state_2_MC_D,
      O => snoop_cur_state_2_MC_Q_tsim_ireg_Q
    );
  snoop_cur_state_2_MC_D1_325 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => snoop_cur_state_2_MC_D1
    );
  snoop_cur_state_2_MC_D2_PT_0_326 : X_AND3
    port map (
      I0 => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_0_IN0,
      I1 => slave_cur_state_ffd4,
      I2 => slave_cur_state_ffd3,
      O => snoop_cur_state_2_MC_D2_PT_0
    );
  snoop_cur_state_2_MC_D2_PT_1_327 : X_AND3
    port map (
      I0 => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_1_IN0,
      I1 => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_1_IN1,
      I2 => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_1_IN2,
      O => snoop_cur_state_2_MC_D2_PT_1
    );
  snoop_cur_state_2_MC_D2_PT_2_328 : X_AND3
    port map (
      I0 => slave_cur_state_ffd4,
      I1 => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_2_IN1,
      I2 => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_2_IN2,
      O => snoop_cur_state_2_MC_D2_PT_2
    );
  snoop_cur_state_2_MC_D2_PT_3_329 : X_AND3
    port map (
      I0 => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_3_IN0,
      I1 => slave_cur_state_ffd3,
      I2 => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_3_IN2,
      O => snoop_cur_state_2_MC_D2_PT_3
    );
  snoop_cur_state_2_MC_D2_330 : X_OR4
    port map (
      I0 => snoop_cur_state_2_MC_D2_PT_0,
      I1 => snoop_cur_state_2_MC_D2_PT_1,
      I2 => snoop_cur_state_2_MC_D2_PT_2,
      I3 => snoop_cur_state_2_MC_D2_PT_3,
      O => snoop_cur_state_2_MC_D2
    );
  snoop_cur_state_2_MC_XOR : X_XOR2
    port map (
      I0 => NlwInverterSignal_snoop_cur_state_2_MC_XOR_IN0,
      I1 => snoop_cur_state_2_MC_D2,
      O => snoop_cur_state_2_MC_D
    );
  snoop_cur_state_3_Q : X_BUF
    port map (
      I => snoop_cur_state_3_MC_Q,
      O => snoop_cur_state(3)
    );
  snoop_cur_state_3_MC_Q_331 : X_BUF
    port map (
      I => snoop_cur_state_3_MC_Q_tsim_ireg_Q,
      O => snoop_cur_state_3_MC_Q
    );
  snoop_cur_state_3_MC_REG : X_BUF
    port map (
      I => snoop_cur_state_3_MC_D,
      O => snoop_cur_state_3_MC_Q_tsim_ireg_Q
    );
  snoop_cur_state_3_MC_D1_332 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => snoop_cur_state_3_MC_D1
    );
  snoop_cur_state_3_MC_D2_PT_0_333 : X_AND2
    port map (
      I0 => NlwInverterSignal_snoop_cur_state_3_MC_D2_PT_0_IN0,
      I1 => slave_cur_state_ffd3,
      O => snoop_cur_state_3_MC_D2_PT_0
    );
  snoop_cur_state_3_MC_D2_PT_1_334 : X_AND3
    port map (
      I0 => NlwInverterSignal_snoop_cur_state_3_MC_D2_PT_1_IN0,
      I1 => NlwInverterSignal_snoop_cur_state_3_MC_D2_PT_1_IN1,
      I2 => NlwInverterSignal_snoop_cur_state_3_MC_D2_PT_1_IN2,
      O => snoop_cur_state_3_MC_D2_PT_1
    );
  snoop_cur_state_3_MC_D2_PT_2_335 : X_AND3
    port map (
      I0 => slave_cur_state_ffd4,
      I1 => NlwInverterSignal_snoop_cur_state_3_MC_D2_PT_2_IN1,
      I2 => slave_cur_state_ffd1,
      O => snoop_cur_state_3_MC_D2_PT_2
    );
  snoop_cur_state_3_MC_D2_336 : X_OR3
    port map (
      I0 => snoop_cur_state_3_MC_D2_PT_0,
      I1 => snoop_cur_state_3_MC_D2_PT_1,
      I2 => snoop_cur_state_3_MC_D2_PT_2,
      O => snoop_cur_state_3_MC_D2
    );
  snoop_cur_state_3_MC_XOR : X_XOR2
    port map (
      I0 => NlwInverterSignal_snoop_cur_state_3_MC_XOR_IN0,
      I1 => snoop_cur_state_3_MC_D2,
      O => snoop_cur_state_3_MC_D
    );
  statuses_0_Q : X_BUF
    port map (
      I => statuses_0_MC_Q,
      O => statuses(0)
    );
  statuses_0_MC_Q_337 : X_BUF
    port map (
      I => statuses_0_MC_Q_tsim_ireg_Q,
      O => statuses_0_MC_Q
    );
  statuses_0_MC_REG : X_BUF
    port map (
      I => statuses_0_MC_D,
      O => statuses_0_MC_Q_tsim_ireg_Q
    );
  statuses_0_MC_D1_338 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => statuses_0_MC_D1
    );
  statuses_0_MC_D2_PT_0_339 : X_AND3
    port map (
      I0 => cfg_receive_mask_0_II_UIM,
      I1 => receiver_sr_2_II_UIM,
      I2 => N_PZ_229,
      O => statuses_0_MC_D2_PT_0
    );
  statuses_0_MC_D2_PT_1_340 : X_AND3
    port map (
      I0 => cfg_receive_mask_1_II_UIM,
      I1 => receiver_sr_3_II_UIM,
      I2 => N_PZ_229,
      O => statuses_0_MC_D2_PT_1
    );
  statuses_0_MC_D2_PT_2_341 : X_AND3
    port map (
      I0 => cfg_receive_mask_2_II_UIM,
      I1 => receiver_sr_4_II_UIM,
      I2 => N_PZ_229,
      O => statuses_0_MC_D2_PT_2
    );
  statuses_0_MC_D2_PT_3_342 : X_AND3
    port map (
      I0 => cfg_receive_mask_3_II_UIM,
      I1 => receiver_sr_5_II_UIM,
      I2 => N_PZ_229,
      O => statuses_0_MC_D2_PT_3
    );
  statuses_0_MC_D2_PT_4_343 : X_AND3
    port map (
      I0 => cfg_receive_mask_4_II_UIM,
      I1 => receiver_sr_6_II_UIM,
      I2 => N_PZ_229,
      O => statuses_0_MC_D2_PT_4
    );
  statuses_0_MC_D2_PT_5_344 : X_AND3
    port map (
      I0 => cfg_receive_mask_5_II_UIM,
      I1 => receiver_sr_7_II_UIM,
      I2 => N_PZ_229,
      O => statuses_0_MC_D2_PT_5
    );
  statuses_0_MC_D2_345 : X_OR6
    port map (
      I0 => statuses_0_MC_D2_PT_0,
      I1 => statuses_0_MC_D2_PT_1,
      I2 => statuses_0_MC_D2_PT_2,
      I3 => statuses_0_MC_D2_PT_3,
      I4 => statuses_0_MC_D2_PT_4,
      I5 => statuses_0_MC_D2_PT_5,
      O => statuses_0_MC_D2
    );
  statuses_0_MC_XOR : X_XOR2
    port map (
      I0 => statuses_0_MC_D1,
      I1 => statuses_0_MC_D2,
      O => statuses_0_MC_D
    );
  statuses_1_Q : X_BUF
    port map (
      I => statuses_1_MC_Q,
      O => statuses(1)
    );
  statuses_1_MC_Q_346 : X_BUF
    port map (
      I => statuses_1_MC_Q_tsim_ireg_Q,
      O => statuses_1_MC_Q
    );
  statuses_1_MC_REG : X_BUF
    port map (
      I => statuses_1_MC_D,
      O => statuses_1_MC_Q_tsim_ireg_Q
    );
  statuses_1_MC_D1_PT_0_347 : X_AND5
    port map (
      I0 => NlwInverterSignal_statuses_1_MC_D1_PT_0_IN0,
      I1 => NlwInverterSignal_statuses_1_MC_D1_PT_0_IN1,
      I2 => NlwInverterSignal_statuses_1_MC_D1_PT_0_IN2,
      I3 => slave_cur_state_ffd1,
      I4 => NlwInverterSignal_statuses_1_MC_D1_PT_0_IN4,
      O => statuses_1_MC_D1_PT_0
    );
  statuses_1_MC_D1_348 : X_OR2
    port map (
      I0 => statuses_1_MC_D1_PT_0,
      I1 => statuses_1_MC_D1_PT_0,
      O => statuses_1_MC_D1
    );
  statuses_1_MC_D2_349 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => statuses_1_MC_D2
    );
  statuses_1_MC_XOR : X_XOR2
    port map (
      I0 => statuses_1_MC_D1,
      I1 => statuses_1_MC_D2,
      O => statuses_1_MC_D
    );
  statuses_2_Q : X_BUF
    port map (
      I => statuses_2_MC_Q,
      O => statuses(2)
    );
  statuses_2_MC_Q_350 : X_BUF
    port map (
      I => statuses_2_MC_Q_tsim_ireg_Q,
      O => statuses_2_MC_Q
    );
  statuses_2_MC_REG : X_BUF
    port map (
      I => statuses_2_MC_D,
      O => statuses_2_MC_Q_tsim_ireg_Q
    );
  statuses_2_MC_D1_PT_0_351 : X_AND4
    port map (
      I0 => NlwInverterSignal_statuses_2_MC_D1_PT_0_IN0,
      I1 => NlwInverterSignal_statuses_2_MC_D1_PT_0_IN1,
      I2 => NlwInverterSignal_statuses_2_MC_D1_PT_0_IN2,
      I3 => NlwInverterSignal_statuses_2_MC_D1_PT_0_IN3,
      O => statuses_2_MC_D1_PT_0
    );
  statuses_2_MC_D1_352 : X_OR2
    port map (
      I0 => statuses_2_MC_D1_PT_0,
      I1 => statuses_2_MC_D1_PT_0,
      O => statuses_2_MC_D1
    );
  statuses_2_MC_D2_353 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => statuses_2_MC_D2
    );
  statuses_2_MC_XOR : X_XOR2
    port map (
      I0 => statuses_2_MC_D1,
      I1 => statuses_2_MC_D2,
      O => statuses_2_MC_D
    );
  transmitter_rst_354 : X_BUF
    port map (
      I => transmitter_rst_MC_Q,
      O => transmitter_rst
    );
  transmitter_sr_0_Q : X_BUF
    port map (
      I => transmitter_sr_0_MC_Q,
      O => transmitter_sr(0)
    );
  transmitter_sr_0_MC_Q_355 : X_BUF
    port map (
      I => transmitter_sr_0_MC_Q_tsim_ireg_Q,
      O => transmitter_sr_0_MC_Q
    );
  transmitter_sr_0_MC_REG : X_BUF
    port map (
      I => transmitter_sr_0_MC_D,
      O => transmitter_sr_0_MC_Q_tsim_ireg_Q
    );
  transmitter_sr_0_MC_D1_356 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => transmitter_sr_0_MC_D1
    );
  transmitter_sr_0_MC_D2_PT_0_357 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_0_MC_D2_PT_0_IN0,
      I1 => N_PZ_198,
      O => transmitter_sr_0_MC_D2_PT_0
    );
  transmitter_sr_0_MC_D2_PT_1_358 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_0_MC_D2_PT_1_IN0,
      I1 => NlwInverterSignal_transmitter_sr_0_MC_D2_PT_1_IN1,
      O => transmitter_sr_0_MC_D2_PT_1
    );
  transmitter_sr_0_MC_D2_359 : X_OR2
    port map (
      I0 => transmitter_sr_0_MC_D2_PT_0,
      I1 => transmitter_sr_0_MC_D2_PT_1,
      O => transmitter_sr_0_MC_D2
    );
  transmitter_sr_0_MC_XOR : X_XOR2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_0_MC_XOR_IN0,
      I1 => transmitter_sr_0_MC_D2,
      O => transmitter_sr_0_MC_D
    );
  checksum_0_II_UIM_360 : X_BUF
    port map (
      I => checksum(0),
      O => checksum_0_II_UIM
    );
  transmit_0_II_UIM_361 : X_BUF
    port map (
      I => transmit(0),
      O => transmit_0_II_UIM
    );
  transmitter_sr_1_Q : X_BUF
    port map (
      I => transmitter_sr_1_MC_Q,
      O => transmitter_sr(1)
    );
  transmitter_sr_1_MC_Q_362 : X_BUF
    port map (
      I => transmitter_sr_1_MC_Q_tsim_ireg_Q,
      O => transmitter_sr_1_MC_Q
    );
  transmitter_sr_1_MC_REG : X_BUF
    port map (
      I => transmitter_sr_1_MC_D,
      O => transmitter_sr_1_MC_Q_tsim_ireg_Q
    );
  transmitter_sr_1_MC_D1_363 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => transmitter_sr_1_MC_D1
    );
  transmitter_sr_1_MC_D2_PT_0_364 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_1_MC_D2_PT_0_IN0,
      I1 => N_PZ_198,
      O => transmitter_sr_1_MC_D2_PT_0
    );
  transmitter_sr_1_MC_D2_PT_1_365 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_1_MC_D2_PT_1_IN0,
      I1 => NlwInverterSignal_transmitter_sr_1_MC_D2_PT_1_IN1,
      O => transmitter_sr_1_MC_D2_PT_1
    );
  transmitter_sr_1_MC_D2_366 : X_OR2
    port map (
      I0 => transmitter_sr_1_MC_D2_PT_0,
      I1 => transmitter_sr_1_MC_D2_PT_1,
      O => transmitter_sr_1_MC_D2
    );
  transmitter_sr_1_MC_XOR : X_XOR2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_1_MC_XOR_IN0,
      I1 => transmitter_sr_1_MC_D2,
      O => transmitter_sr_1_MC_D
    );
  checksum_1_II_UIM_367 : X_BUF
    port map (
      I => checksum(1),
      O => checksum_1_II_UIM
    );
  transmit_1_II_UIM_368 : X_BUF
    port map (
      I => transmit(1),
      O => transmit_1_II_UIM
    );
  transmitter_sr_2_Q : X_BUF
    port map (
      I => transmitter_sr_2_MC_Q,
      O => transmitter_sr(2)
    );
  transmitter_sr_2_MC_Q_369 : X_BUF
    port map (
      I => transmitter_sr_2_MC_Q_tsim_ireg_Q,
      O => transmitter_sr_2_MC_Q
    );
  transmitter_sr_2_MC_REG : X_BUF
    port map (
      I => transmitter_sr_2_MC_D,
      O => transmitter_sr_2_MC_Q_tsim_ireg_Q
    );
  transmitter_sr_2_MC_D1_370 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => transmitter_sr_2_MC_D1
    );
  transmitter_sr_2_MC_D2_PT_0_371 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_2_MC_D2_PT_0_IN0,
      I1 => N_PZ_198,
      O => transmitter_sr_2_MC_D2_PT_0
    );
  transmitter_sr_2_MC_D2_PT_1_372 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_2_MC_D2_PT_1_IN0,
      I1 => NlwInverterSignal_transmitter_sr_2_MC_D2_PT_1_IN1,
      O => transmitter_sr_2_MC_D2_PT_1
    );
  transmitter_sr_2_MC_D2_373 : X_OR2
    port map (
      I0 => transmitter_sr_2_MC_D2_PT_0,
      I1 => transmitter_sr_2_MC_D2_PT_1,
      O => transmitter_sr_2_MC_D2
    );
  transmitter_sr_2_MC_XOR : X_XOR2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_2_MC_XOR_IN0,
      I1 => transmitter_sr_2_MC_D2,
      O => transmitter_sr_2_MC_D
    );
  checksum_2_II_UIM_374 : X_BUF
    port map (
      I => checksum(2),
      O => checksum_2_II_UIM
    );
  transmit_2_II_UIM_375 : X_BUF
    port map (
      I => transmit(2),
      O => transmit_2_II_UIM
    );
  transmitter_sr_3_Q : X_BUF
    port map (
      I => transmitter_sr_3_MC_Q,
      O => transmitter_sr(3)
    );
  transmitter_sr_3_MC_Q_376 : X_BUF
    port map (
      I => transmitter_sr_3_MC_Q_tsim_ireg_Q,
      O => transmitter_sr_3_MC_Q
    );
  transmitter_sr_3_MC_REG : X_BUF
    port map (
      I => transmitter_sr_3_MC_D,
      O => transmitter_sr_3_MC_Q_tsim_ireg_Q
    );
  transmitter_sr_3_MC_D1_377 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => transmitter_sr_3_MC_D1
    );
  transmitter_sr_3_MC_D2_PT_0_378 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_3_MC_D2_PT_0_IN0,
      I1 => N_PZ_198,
      O => transmitter_sr_3_MC_D2_PT_0
    );
  transmitter_sr_3_MC_D2_PT_1_379 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_3_MC_D2_PT_1_IN0,
      I1 => NlwInverterSignal_transmitter_sr_3_MC_D2_PT_1_IN1,
      O => transmitter_sr_3_MC_D2_PT_1
    );
  transmitter_sr_3_MC_D2_380 : X_OR2
    port map (
      I0 => transmitter_sr_3_MC_D2_PT_0,
      I1 => transmitter_sr_3_MC_D2_PT_1,
      O => transmitter_sr_3_MC_D2
    );
  transmitter_sr_3_MC_XOR : X_XOR2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_3_MC_XOR_IN0,
      I1 => transmitter_sr_3_MC_D2,
      O => transmitter_sr_3_MC_D
    );
  checksum_3_II_UIM_381 : X_BUF
    port map (
      I => checksum(3),
      O => checksum_3_II_UIM
    );
  transmit_3_II_UIM_382 : X_BUF
    port map (
      I => transmit(3),
      O => transmit_3_II_UIM
    );
  transmitter_sr_4_Q : X_BUF
    port map (
      I => transmitter_sr_4_MC_Q,
      O => transmitter_sr(4)
    );
  transmitter_sr_4_MC_Q_383 : X_BUF
    port map (
      I => transmitter_sr_4_MC_Q_tsim_ireg_Q,
      O => transmitter_sr_4_MC_Q
    );
  transmitter_sr_4_MC_REG : X_BUF
    port map (
      I => transmitter_sr_4_MC_D,
      O => transmitter_sr_4_MC_Q_tsim_ireg_Q
    );
  transmitter_sr_4_MC_D1_384 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => transmitter_sr_4_MC_D1
    );
  transmitter_sr_4_MC_D2_PT_0_385 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_4_MC_D2_PT_0_IN0,
      I1 => N_PZ_198,
      O => transmitter_sr_4_MC_D2_PT_0
    );
  transmitter_sr_4_MC_D2_PT_1_386 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_4_MC_D2_PT_1_IN0,
      I1 => NlwInverterSignal_transmitter_sr_4_MC_D2_PT_1_IN1,
      O => transmitter_sr_4_MC_D2_PT_1
    );
  transmitter_sr_4_MC_D2_387 : X_OR2
    port map (
      I0 => transmitter_sr_4_MC_D2_PT_0,
      I1 => transmitter_sr_4_MC_D2_PT_1,
      O => transmitter_sr_4_MC_D2
    );
  transmitter_sr_4_MC_XOR : X_XOR2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_4_MC_XOR_IN0,
      I1 => transmitter_sr_4_MC_D2,
      O => transmitter_sr_4_MC_D
    );
  checksum_4_II_UIM_388 : X_BUF
    port map (
      I => checksum(4),
      O => checksum_4_II_UIM
    );
  transmit_4_II_UIM_389 : X_BUF
    port map (
      I => transmit(4),
      O => transmit_4_II_UIM
    );
  transmitter_sr_5_Q : X_BUF
    port map (
      I => transmitter_sr_5_MC_Q,
      O => transmitter_sr(5)
    );
  transmitter_sr_5_MC_Q_390 : X_BUF
    port map (
      I => transmitter_sr_5_MC_Q_tsim_ireg_Q,
      O => transmitter_sr_5_MC_Q
    );
  transmitter_sr_5_MC_REG : X_BUF
    port map (
      I => transmitter_sr_5_MC_D,
      O => transmitter_sr_5_MC_Q_tsim_ireg_Q
    );
  transmitter_sr_5_MC_D1_391 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => transmitter_sr_5_MC_D1
    );
  transmitter_sr_5_MC_D2_PT_0_392 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_5_MC_D2_PT_0_IN0,
      I1 => N_PZ_198,
      O => transmitter_sr_5_MC_D2_PT_0
    );
  transmitter_sr_5_MC_D2_PT_1_393 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_5_MC_D2_PT_1_IN0,
      I1 => NlwInverterSignal_transmitter_sr_5_MC_D2_PT_1_IN1,
      O => transmitter_sr_5_MC_D2_PT_1
    );
  transmitter_sr_5_MC_D2_394 : X_OR2
    port map (
      I0 => transmitter_sr_5_MC_D2_PT_0,
      I1 => transmitter_sr_5_MC_D2_PT_1,
      O => transmitter_sr_5_MC_D2
    );
  transmitter_sr_5_MC_XOR : X_XOR2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_5_MC_XOR_IN0,
      I1 => transmitter_sr_5_MC_D2,
      O => transmitter_sr_5_MC_D
    );
  checksum_5_II_UIM_395 : X_BUF
    port map (
      I => checksum(5),
      O => checksum_5_II_UIM
    );
  transmit_5_II_UIM_396 : X_BUF
    port map (
      I => transmit(5),
      O => transmit_5_II_UIM
    );
  transmitter_sr_6_Q : X_BUF
    port map (
      I => transmitter_sr_6_MC_Q,
      O => transmitter_sr(6)
    );
  transmitter_sr_6_MC_Q_397 : X_BUF
    port map (
      I => transmitter_sr_6_MC_Q_tsim_ireg_Q,
      O => transmitter_sr_6_MC_Q
    );
  transmitter_sr_6_MC_REG : X_BUF
    port map (
      I => transmitter_sr_6_MC_D,
      O => transmitter_sr_6_MC_Q_tsim_ireg_Q
    );
  transmitter_sr_6_MC_D1_398 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => transmitter_sr_6_MC_D1
    );
  transmitter_sr_6_MC_D2_PT_0_399 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_6_MC_D2_PT_0_IN0,
      I1 => N_PZ_198,
      O => transmitter_sr_6_MC_D2_PT_0
    );
  transmitter_sr_6_MC_D2_PT_1_400 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_6_MC_D2_PT_1_IN0,
      I1 => NlwInverterSignal_transmitter_sr_6_MC_D2_PT_1_IN1,
      O => transmitter_sr_6_MC_D2_PT_1
    );
  transmitter_sr_6_MC_D2_401 : X_OR2
    port map (
      I0 => transmitter_sr_6_MC_D2_PT_0,
      I1 => transmitter_sr_6_MC_D2_PT_1,
      O => transmitter_sr_6_MC_D2
    );
  transmitter_sr_6_MC_XOR : X_XOR2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_6_MC_XOR_IN0,
      I1 => transmitter_sr_6_MC_D2,
      O => transmitter_sr_6_MC_D
    );
  checksum_6_II_UIM_402 : X_BUF
    port map (
      I => checksum(6),
      O => checksum_6_II_UIM
    );
  transmit_6_II_UIM_403 : X_BUF
    port map (
      I => transmit(6),
      O => transmit_6_II_UIM
    );
  transmitter_sr_7_Q : X_BUF
    port map (
      I => transmitter_sr_7_MC_Q,
      O => transmitter_sr(7)
    );
  transmitter_sr_7_MC_Q_404 : X_BUF
    port map (
      I => transmitter_sr_7_MC_Q_tsim_ireg_Q,
      O => transmitter_sr_7_MC_Q
    );
  transmitter_sr_7_MC_REG : X_BUF
    port map (
      I => transmitter_sr_7_MC_D,
      O => transmitter_sr_7_MC_Q_tsim_ireg_Q
    );
  transmitter_sr_7_MC_D1_405 : X_OR2
    port map (
      I0 => GND,
      I1 => GND,
      O => transmitter_sr_7_MC_D1
    );
  transmitter_sr_7_MC_D2_PT_0_406 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_7_MC_D2_PT_0_IN0,
      I1 => N_PZ_198,
      O => transmitter_sr_7_MC_D2_PT_0
    );
  transmitter_sr_7_MC_D2_PT_1_407 : X_AND2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_7_MC_D2_PT_1_IN0,
      I1 => NlwInverterSignal_transmitter_sr_7_MC_D2_PT_1_IN1,
      O => transmitter_sr_7_MC_D2_PT_1
    );
  transmitter_sr_7_MC_D2_408 : X_OR2
    port map (
      I0 => transmitter_sr_7_MC_D2_PT_0,
      I1 => transmitter_sr_7_MC_D2_PT_1,
      O => transmitter_sr_7_MC_D2
    );
  transmitter_sr_7_MC_XOR : X_XOR2
    port map (
      I0 => NlwInverterSignal_transmitter_sr_7_MC_XOR_IN0,
      I1 => transmitter_sr_7_MC_D2,
      O => transmitter_sr_7_MC_D
    );
  checksum_7_II_UIM_409 : X_BUF
    port map (
      I => checksum(7),
      O => checksum_7_II_UIM
    );
  transmit_7_II_UIM_410 : X_BUF
    port map (
      I => transmit(7),
      O => transmit_7_II_UIM
    );
  NlwInverterBlock_checksum_done_MC_D2_PT_0_IN1 : X_INV
    port map (
      I => byte_counter(0),
      O => NlwInverterSignal_checksum_done_MC_D2_PT_0_IN1
    );
  NlwInverterBlock_checksum_done_MC_D2_PT_0_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_checksum_done_MC_D2_PT_0_IN2
    );
  NlwInverterBlock_checksum_done_MC_D2_PT_0_IN5 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_checksum_done_MC_D2_PT_0_IN5
    );
  NlwInverterBlock_checksum_done_MC_D2_PT_0_IN6 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_checksum_done_MC_D2_PT_0_IN6
    );
  NlwInverterBlock_checksum_done_MC_D2_PT_0_IN7 : X_INV
    port map (
      I => byte_counter(1),
      O => NlwInverterSignal_checksum_done_MC_D2_PT_0_IN7
    );
  NlwInverterBlock_checksum_done_MC_D2_PT_0_IN8 : X_INV
    port map (
      I => byte_counter(2),
      O => NlwInverterSignal_checksum_done_MC_D2_PT_0_IN8
    );
  NlwInverterBlock_checksum_done_MC_D2_PT_0_IN9 : X_INV
    port map (
      I => byte_counter(3),
      O => NlwInverterSignal_checksum_done_MC_D2_PT_0_IN9
    );
  NlwInverterBlock_checksum_done_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => byte_counter(0),
      O => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_checksum_done_MC_D2_PT_1_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN2
    );
  NlwInverterBlock_checksum_done_MC_D2_PT_1_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN3
    );
  NlwInverterBlock_checksum_done_MC_D2_PT_1_IN4 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN4
    );
  NlwInverterBlock_checksum_done_MC_D2_PT_1_IN5 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN5
    );
  NlwInverterBlock_checksum_done_MC_D2_PT_1_IN6 : X_INV
    port map (
      I => byte_counter(1),
      O => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN6
    );
  NlwInverterBlock_checksum_done_MC_D2_PT_1_IN7 : X_INV
    port map (
      I => byte_counter(2),
      O => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN7
    );
  NlwInverterBlock_checksum_done_MC_D2_PT_1_IN8 : X_INV
    port map (
      I => byte_counter(3),
      O => NlwInverterSignal_checksum_done_MC_D2_PT_1_IN8
    );
  NlwInverterBlock_byte_counter_0_MC_D2_PT_0_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_byte_counter_0_MC_D2_PT_0_IN1
    );
  NlwInverterBlock_byte_counter_0_MC_D2_PT_0_IN4 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_byte_counter_0_MC_D2_PT_0_IN4
    );
  NlwInverterBlock_byte_counter_0_MC_D2_PT_0_IN5 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_byte_counter_0_MC_D2_PT_0_IN5
    );
  NlwInverterBlock_byte_counter_0_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_byte_counter_0_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_byte_counter_0_MC_D2_PT_1_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_byte_counter_0_MC_D2_PT_1_IN2
    );
  NlwInverterBlock_byte_counter_0_MC_D2_PT_1_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_byte_counter_0_MC_D2_PT_1_IN3
    );
  NlwInverterBlock_byte_counter_0_MC_D2_PT_1_IN4 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_byte_counter_0_MC_D2_PT_1_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => slave_cur_state_xx_ffd228,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_2_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_2_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_2_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_2_IN2
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_2_IN3 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_2_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_2_IN4 : X_INV
    port map (
      I => transmitter_done_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_2_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_3_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_3_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_4_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_4_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_4_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_4_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_4_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_4_IN2
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_4_IN4 : X_INV
    port map (
      I => transmitter_rst_MC_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_4_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_5_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_5_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_5_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_5_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_5_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_5_IN2
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_5_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_5_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_5_IN4 : X_INV
    port map (
      I => ser_in_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_5_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_6_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_6_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_6_IN4 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_6_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_6_IN5 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_6_IN5
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_7_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_7_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_7_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_7_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_7_IN5 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_7_IN5
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_8_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_8_IN2
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_8_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_8_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_8_IN4 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_8_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_9_IN0 : X_INV
    port map (
      I => byte_counter(0),
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_9_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN2
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_9_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_9_IN4 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_9_IN5 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN5
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_9_IN6 : X_INV
    port map (
      I => byte_counter(1),
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN6
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_9_IN7 : X_INV
    port map (
      I => byte_counter(2),
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN7
    );
  NlwInverterBlock_slave_cur_state_ffd2_MC_D2_PT_9_IN8 : X_INV
    port map (
      I => byte_counter(3),
      O => NlwInverterSignal_slave_cur_state_ffd2_MC_D2_PT_9_IN8
    );
  NlwInverterBlock_N_PZ_229_MC_D2_PT_0_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_N_PZ_229_MC_D2_PT_0_IN2
    );
  NlwInverterBlock_N_PZ_229_MC_D2_PT_1_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_N_PZ_229_MC_D2_PT_1_IN2
    );
  NlwInverterBlock_N_PZ_229_MC_D2_PT_1_IN5 : X_INV
    port map (
      I => receiver_sr_1_II_UIM,
      O => NlwInverterSignal_N_PZ_229_MC_D2_PT_1_IN5
    );
  NlwInverterBlock_N_PZ_229_MC_D2_PT_1_IN7 : X_INV
    port map (
      I => pr1_II_UIM,
      O => NlwInverterSignal_N_PZ_229_MC_D2_PT_1_IN7
    );
  NlwInverterBlock_N_PZ_229_MC_D2_PT_2_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_N_PZ_229_MC_D2_PT_2_IN2
    );
  NlwInverterBlock_N_PZ_229_MC_D2_PT_2_IN4 : X_INV
    port map (
      I => receiver_sr_0_II_UIM,
      O => NlwInverterSignal_N_PZ_229_MC_D2_PT_2_IN4
    );
  NlwInverterBlock_N_PZ_229_MC_D2_PT_2_IN6 : X_INV
    port map (
      I => pr0_II_UIM,
      O => NlwInverterSignal_N_PZ_229_MC_D2_PT_2_IN6
    );
  NlwInverterBlock_N_PZ_229_MC_D2_PT_3_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_N_PZ_229_MC_D2_PT_3_IN2
    );
  NlwInverterBlock_N_PZ_229_MC_D2_PT_3_IN4 : X_INV
    port map (
      I => receiver_sr_0_II_UIM,
      O => NlwInverterSignal_N_PZ_229_MC_D2_PT_3_IN4
    );
  NlwInverterBlock_N_PZ_229_MC_D2_PT_3_IN5 : X_INV
    port map (
      I => receiver_sr_1_II_UIM,
      O => NlwInverterSignal_N_PZ_229_MC_D2_PT_3_IN5
    );
  NlwInverterBlock_N_PZ_229_MC_D2_PT_3_IN6 : X_INV
    port map (
      I => pr0_II_UIM,
      O => NlwInverterSignal_N_PZ_229_MC_D2_PT_3_IN6
    );
  NlwInverterBlock_N_PZ_229_MC_D2_PT_3_IN7 : X_INV
    port map (
      I => pr1_II_UIM,
      O => NlwInverterSignal_N_PZ_229_MC_D2_PT_3_IN7
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_1_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_1_IN2
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_1_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_1_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_1_IN4 : X_INV
    port map (
      I => ser_in_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_1_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_2_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_2_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_3_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_3_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_3_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_3_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_3_IN4 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_3_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_4_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_4_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_4_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_4_IN2
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_4_IN4 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_4_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_5_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_5_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_5_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_5_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_5_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_5_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_6_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_6_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_6_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_6_IN2
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_6_IN3 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_6_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_7_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_7_IN3 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_7_IN4 : X_INV
    port map (
      I => N_PZ_235,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_7_IN5 : X_INV
    port map (
      I => receiver_sr_6_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN5
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_7_IN6 : X_INV
    port map (
      I => receiver_sr_4_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN6
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_7_IN10 : X_INV
    port map (
      I => receiver_sr_2_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN10
    );
  NlwInverterBlock_slave_cur_state_ffd4_MC_D2_PT_7_IN11 : X_INV
    port map (
      I => receiver_sr_0_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd4_MC_D2_PT_7_IN11
    );
  NlwInverterBlock_N_PZ_235_MC_D1_PT_0_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_N_PZ_235_MC_D1_PT_0_IN0
    );
  NlwInverterBlock_N_PZ_235_MC_D2_PT_0_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_N_PZ_235_MC_D2_PT_0_IN1
    );
  NlwInverterBlock_N_PZ_235_MC_D2_PT_0_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_N_PZ_235_MC_D2_PT_0_IN2
    );
  NlwInverterBlock_N_PZ_235_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_N_PZ_235_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_N_PZ_235_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_N_PZ_235_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_N_PZ_235_MC_D2_PT_2_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_N_PZ_235_MC_D2_PT_2_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_2_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_2_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_2_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_2_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_2_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_2_IN2
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_2_IN3 : X_INV
    port map (
      I => ser_in_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_2_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_3_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_3_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_3_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_3_IN2
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_3_IN3 : X_INV
    port map (
      I => ser_in_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_3_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_4_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_4_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_4_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_4_IN2
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_4_IN3 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_4_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_4_IN4 : X_INV
    port map (
      I => ser_in_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_4_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_5_IN0 : X_INV
    port map (
      I => receiver_done_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_5_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_5_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_5_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_5_IN4 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_5_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_5_IN5 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_5_IN5
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_6_IN0 : X_INV
    port map (
      I => byte_counter(0),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_6_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_6_IN4 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_6_IN5 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN5
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_6_IN6 : X_INV
    port map (
      I => byte_counter(1),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN6
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_6_IN7 : X_INV
    port map (
      I => byte_counter(2),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN7
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_6_IN8 : X_INV
    port map (
      I => byte_counter(3),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_6_IN8
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_7_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_7_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_7_IN5 : X_INV
    port map (
      I => bit_counter(1),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN5
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_7_IN8 : X_INV
    port map (
      I => bit_counter(4),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN8
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_7_IN9 : X_INV
    port map (
      I => bit_counter(5),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN9
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_7_IN10 : X_INV
    port map (
      I => bit_counter(6),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN10
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_7_IN11 : X_INV
    port map (
      I => bit_counter(7),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN11
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_7_IN12 : X_INV
    port map (
      I => bit_counter(8),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN12
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_7_IN13 : X_INV
    port map (
      I => bit_counter(9),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN13
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_7_IN14 : X_INV
    port map (
      I => bit_counter(10),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN14
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_7_IN15 : X_INV
    port map (
      I => bit_counter(11),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN15
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_7_IN16 : X_INV
    port map (
      I => bit_counter(12),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN16
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_7_IN17 : X_INV
    port map (
      I => bit_counter(13),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN17
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_7_IN18 : X_INV
    port map (
      I => bit_counter(14),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN18
    );
  NlwInverterBlock_slave_cur_state_ffd3_MC_D2_PT_7_IN19 : X_INV
    port map (
      I => bit_counter(15),
      O => NlwInverterSignal_slave_cur_state_ffd3_MC_D2_PT_7_IN19
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_2_IN0 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_2_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_2_IN1 : X_INV
    port map (
      I => transmitter_done_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_2_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_3_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_3_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_3_IN4 : X_INV
    port map (
      I => Q_n0098,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_3_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_4_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_4_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_4_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_4_IN2
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_4_IN4 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_4_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_5_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_5_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_5_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_5_IN2
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_5_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_5_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_5_IN4 : X_INV
    port map (
      I => ser_in_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_5_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_6_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_6_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_6_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_6_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_6_IN3 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_6_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_6_IN4 : X_INV
    port map (
      I => transmitter_rst_MC_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_6_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_7_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_7_IN1
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_7_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_7_IN2
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_7_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_7_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_7_IN4 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_7_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_8_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN0
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_8_IN3 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN3
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_8_IN4 : X_INV
    port map (
      I => receiver_sr_6_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN4
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_8_IN5 : X_INV
    port map (
      I => receiver_sr_4_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN5
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_8_IN9 : X_INV
    port map (
      I => receiver_sr_2_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN9
    );
  NlwInverterBlock_slave_cur_state_ffd1_MC_D2_PT_8_IN10 : X_INV
    port map (
      I => receiver_sr_0_II_UIM,
      O => NlwInverterSignal_slave_cur_state_ffd1_MC_D2_PT_8_IN10
    );
  NlwInverterBlock_n0060_MC_D1_PT_0_IN0 : X_INV
    port map (
      I => bit_counter(0),
      O => NlwInverterSignal_n0060_MC_D1_PT_0_IN0
    );
  NlwInverterBlock_n0060_MC_D1_PT_0_IN1 : X_INV
    port map (
      I => bit_counter(1),
      O => NlwInverterSignal_n0060_MC_D1_PT_0_IN1
    );
  NlwInverterBlock_n0060_MC_D1_PT_0_IN2 : X_INV
    port map (
      I => bit_counter(2),
      O => NlwInverterSignal_n0060_MC_D1_PT_0_IN2
    );
  NlwInverterBlock_n0060_MC_D1_PT_0_IN4 : X_INV
    port map (
      I => bit_counter(4),
      O => NlwInverterSignal_n0060_MC_D1_PT_0_IN4
    );
  NlwInverterBlock_n0060_MC_D1_PT_0_IN6 : X_INV
    port map (
      I => bit_counter(6),
      O => NlwInverterSignal_n0060_MC_D1_PT_0_IN6
    );
  NlwInverterBlock_n0060_MC_D1_PT_0_IN9 : X_INV
    port map (
      I => bit_counter(9),
      O => NlwInverterSignal_n0060_MC_D1_PT_0_IN9
    );
  NlwInverterBlock_n0060_MC_D1_PT_0_IN10 : X_INV
    port map (
      I => bit_counter(10),
      O => NlwInverterSignal_n0060_MC_D1_PT_0_IN10
    );
  NlwInverterBlock_n0060_MC_D1_PT_0_IN11 : X_INV
    port map (
      I => bit_counter(11),
      O => NlwInverterSignal_n0060_MC_D1_PT_0_IN11
    );
  NlwInverterBlock_n0060_MC_D1_PT_0_IN12 : X_INV
    port map (
      I => bit_counter(12),
      O => NlwInverterSignal_n0060_MC_D1_PT_0_IN12
    );
  NlwInverterBlock_n0060_MC_D1_PT_0_IN15 : X_INV
    port map (
      I => bit_counter(15),
      O => NlwInverterSignal_n0060_MC_D1_PT_0_IN15
    );
  NlwInverterBlock_FOOBAR2_ctinst_5_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_FOOBAR2_ctinst_5_IN0
    );
  NlwInverterBlock_FOOBAR2_ctinst_5_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_FOOBAR2_ctinst_5_IN1
    );
  NlwInverterBlock_FOOBAR2_ctinst_5_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_FOOBAR2_ctinst_5_IN2
    );
  NlwInverterBlock_FOOBAR2_ctinst_5_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_FOOBAR2_ctinst_5_IN3
    );
  NlwInverterBlock_FOOBAR2_ctinst_5_IN4 : X_INV
    port map (
      I => ser_in_II_UIM,
      O => NlwInverterSignal_FOOBAR2_ctinst_5_IN4
    );
  NlwInverterBlock_bit_counter_0_MC_XOR_IN0 : X_INV
    port map (
      I => bit_counter_0_MC_D1,
      O => NlwInverterSignal_bit_counter_0_MC_XOR_IN0
    );
  NlwInverterBlock_FOOBAR1_ctinst_5_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_FOOBAR1_ctinst_5_IN0
    );
  NlwInverterBlock_FOOBAR1_ctinst_5_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_FOOBAR1_ctinst_5_IN1
    );
  NlwInverterBlock_FOOBAR1_ctinst_5_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_FOOBAR1_ctinst_5_IN2
    );
  NlwInverterBlock_FOOBAR1_ctinst_5_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_FOOBAR1_ctinst_5_IN3
    );
  NlwInverterBlock_FOOBAR1_ctinst_5_IN4 : X_INV
    port map (
      I => ser_in_II_UIM,
      O => NlwInverterSignal_FOOBAR1_ctinst_5_IN4
    );
  NlwInverterBlock_N_PZ_198_MC_D1_PT_0_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_N_PZ_198_MC_D1_PT_0_IN1
    );
  NlwInverterBlock_N_PZ_198_MC_D1_PT_0_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_N_PZ_198_MC_D1_PT_0_IN2
    );
  NlwInverterBlock_transmitter_rst_MC_D1_PT_0_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_transmitter_rst_MC_D1_PT_0_IN0
    );
  NlwInverterBlock_transmitter_rst_MC_D1_PT_0_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_transmitter_rst_MC_D1_PT_0_IN1
    );
  NlwInverterBlock_transmitter_rst_MC_D1_PT_0_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_transmitter_rst_MC_D1_PT_0_IN2
    );
  NlwInverterBlock_transmitter_rst_MC_D1_PT_0_IN4 : X_INV
    port map (
      I => transmitter_rst_MC_UIM,
      O => NlwInverterSignal_transmitter_rst_MC_D1_PT_0_IN4
    );
  NlwInverterBlock_byte_counter_1_MC_D2_PT_0_IN1 : X_INV
    port map (
      I => byte_counter(0),
      O => NlwInverterSignal_byte_counter_1_MC_D2_PT_0_IN1
    );
  NlwInverterBlock_byte_counter_1_MC_D2_PT_0_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_byte_counter_1_MC_D2_PT_0_IN2
    );
  NlwInverterBlock_byte_counter_1_MC_D2_PT_0_IN5 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_byte_counter_1_MC_D2_PT_0_IN5
    );
  NlwInverterBlock_byte_counter_1_MC_D2_PT_0_IN6 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_byte_counter_1_MC_D2_PT_0_IN6
    );
  NlwInverterBlock_byte_counter_1_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => byte_counter(0),
      O => NlwInverterSignal_byte_counter_1_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_byte_counter_1_MC_D2_PT_1_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_byte_counter_1_MC_D2_PT_1_IN2
    );
  NlwInverterBlock_byte_counter_1_MC_D2_PT_1_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_byte_counter_1_MC_D2_PT_1_IN3
    );
  NlwInverterBlock_byte_counter_1_MC_D2_PT_1_IN4 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_byte_counter_1_MC_D2_PT_1_IN4
    );
  NlwInverterBlock_byte_counter_1_MC_D2_PT_1_IN5 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_byte_counter_1_MC_D2_PT_1_IN5
    );
  NlwInverterBlock_byte_counter_2_MC_D2_PT_0_IN1 : X_INV
    port map (
      I => byte_counter(0),
      O => NlwInverterSignal_byte_counter_2_MC_D2_PT_0_IN1
    );
  NlwInverterBlock_byte_counter_2_MC_D2_PT_0_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_byte_counter_2_MC_D2_PT_0_IN2
    );
  NlwInverterBlock_byte_counter_2_MC_D2_PT_0_IN5 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_byte_counter_2_MC_D2_PT_0_IN5
    );
  NlwInverterBlock_byte_counter_2_MC_D2_PT_0_IN6 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_byte_counter_2_MC_D2_PT_0_IN6
    );
  NlwInverterBlock_byte_counter_2_MC_D2_PT_0_IN7 : X_INV
    port map (
      I => byte_counter(1),
      O => NlwInverterSignal_byte_counter_2_MC_D2_PT_0_IN7
    );
  NlwInverterBlock_byte_counter_2_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => byte_counter(0),
      O => NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_byte_counter_2_MC_D2_PT_1_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN2
    );
  NlwInverterBlock_byte_counter_2_MC_D2_PT_1_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN3
    );
  NlwInverterBlock_byte_counter_2_MC_D2_PT_1_IN4 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN4
    );
  NlwInverterBlock_byte_counter_2_MC_D2_PT_1_IN5 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN5
    );
  NlwInverterBlock_byte_counter_2_MC_D2_PT_1_IN6 : X_INV
    port map (
      I => byte_counter(1),
      O => NlwInverterSignal_byte_counter_2_MC_D2_PT_1_IN6
    );
  NlwInverterBlock_byte_counter_3_MC_D2_PT_0_IN1 : X_INV
    port map (
      I => byte_counter(0),
      O => NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN1
    );
  NlwInverterBlock_byte_counter_3_MC_D2_PT_0_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN2
    );
  NlwInverterBlock_byte_counter_3_MC_D2_PT_0_IN5 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN5
    );
  NlwInverterBlock_byte_counter_3_MC_D2_PT_0_IN6 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN6
    );
  NlwInverterBlock_byte_counter_3_MC_D2_PT_0_IN7 : X_INV
    port map (
      I => byte_counter(1),
      O => NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN7
    );
  NlwInverterBlock_byte_counter_3_MC_D2_PT_0_IN8 : X_INV
    port map (
      I => byte_counter(2),
      O => NlwInverterSignal_byte_counter_3_MC_D2_PT_0_IN8
    );
  NlwInverterBlock_byte_counter_3_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => byte_counter(0),
      O => NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_byte_counter_3_MC_D2_PT_1_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN2
    );
  NlwInverterBlock_byte_counter_3_MC_D2_PT_1_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN3
    );
  NlwInverterBlock_byte_counter_3_MC_D2_PT_1_IN4 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN4
    );
  NlwInverterBlock_byte_counter_3_MC_D2_PT_1_IN5 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN5
    );
  NlwInverterBlock_byte_counter_3_MC_D2_PT_1_IN6 : X_INV
    port map (
      I => byte_counter(1),
      O => NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN6
    );
  NlwInverterBlock_byte_counter_3_MC_D2_PT_1_IN7 : X_INV
    port map (
      I => byte_counter(2),
      O => NlwInverterSignal_byte_counter_3_MC_D2_PT_1_IN7
    );
  NlwInverterBlock_slave_cur_state_xx_ffd228_MC_D2_PT_0_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_0_IN0
    );
  NlwInverterBlock_slave_cur_state_xx_ffd228_MC_D2_PT_0_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_0_IN1
    );
  NlwInverterBlock_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN1 : X_INV
    port map (
      I => bit_counter(1),
      O => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN1
    );
  NlwInverterBlock_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN4 : X_INV
    port map (
      I => bit_counter(4),
      O => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN4
    );
  NlwInverterBlock_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN5 : X_INV
    port map (
      I => bit_counter(5),
      O => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN5
    );
  NlwInverterBlock_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN6 : X_INV
    port map (
      I => bit_counter(6),
      O => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN6
    );
  NlwInverterBlock_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN7 : X_INV
    port map (
      I => bit_counter(7),
      O => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN7
    );
  NlwInverterBlock_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN8 : X_INV
    port map (
      I => bit_counter(8),
      O => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN8
    );
  NlwInverterBlock_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN9 : X_INV
    port map (
      I => bit_counter(9),
      O => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN9
    );
  NlwInverterBlock_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN10 : X_INV
    port map (
      I => bit_counter(10),
      O => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN10
    );
  NlwInverterBlock_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN11 : X_INV
    port map (
      I => bit_counter(11),
      O => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN11
    );
  NlwInverterBlock_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN12 : X_INV
    port map (
      I => bit_counter(12),
      O => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN12
    );
  NlwInverterBlock_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN13 : X_INV
    port map (
      I => bit_counter(13),
      O => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN13
    );
  NlwInverterBlock_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN14 : X_INV
    port map (
      I => bit_counter(14),
      O => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN14
    );
  NlwInverterBlock_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN15 : X_INV
    port map (
      I => bit_counter(15),
      O => NlwInverterSignal_slave_cur_state_xx_ffd228_MC_D2_PT_5_IN15
    );
  NlwInverterBlock_checksum_en_MC_D2_PT_0_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_checksum_en_MC_D2_PT_0_IN1
    );
  NlwInverterBlock_checksum_en_MC_D2_PT_0_IN4 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_checksum_en_MC_D2_PT_0_IN4
    );
  NlwInverterBlock_checksum_en_MC_D2_PT_0_IN5 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_checksum_en_MC_D2_PT_0_IN5
    );
  NlwInverterBlock_checksum_en_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_checksum_en_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_checksum_en_MC_D2_PT_1_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_checksum_en_MC_D2_PT_1_IN2
    );
  NlwInverterBlock_checksum_en_MC_D2_PT_1_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_checksum_en_MC_D2_PT_1_IN3
    );
  NlwInverterBlock_checksum_en_MC_D2_PT_1_IN4 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_checksum_en_MC_D2_PT_1_IN4
    );
  NlwInverterBlock_receiver_rst_MC_D2_PT_0_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_receiver_rst_MC_D2_PT_0_IN1
    );
  NlwInverterBlock_receiver_rst_MC_D2_PT_0_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_receiver_rst_MC_D2_PT_0_IN2
    );
  NlwInverterBlock_receiver_rst_MC_D2_PT_0_IN3 : X_INV
    port map (
      I => ser_in_II_UIM,
      O => NlwInverterSignal_receiver_rst_MC_D2_PT_0_IN3
    );
  NlwInverterBlock_receiver_rst_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_receiver_rst_MC_D2_PT_1_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN2
    );
  NlwInverterBlock_receiver_rst_MC_D2_PT_1_IN5 : X_INV
    port map (
      I => Q_n0060,
      O => NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN5
    );
  NlwInverterBlock_receiver_rst_MC_D2_PT_1_IN6 : X_INV
    port map (
      I => receiver_sr_6_II_UIM,
      O => NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN6
    );
  NlwInverterBlock_receiver_rst_MC_D2_PT_1_IN7 : X_INV
    port map (
      I => receiver_sr_4_II_UIM,
      O => NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN7
    );
  NlwInverterBlock_receiver_rst_MC_D2_PT_1_IN11 : X_INV
    port map (
      I => receiver_sr_2_II_UIM,
      O => NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN11
    );
  NlwInverterBlock_receiver_rst_MC_D2_PT_1_IN12 : X_INV
    port map (
      I => receiver_sr_0_II_UIM,
      O => NlwInverterSignal_receiver_rst_MC_D2_PT_1_IN12
    );
  NlwInverterBlock_snoop_cur_state_0_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_snoop_cur_state_0_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_snoop_cur_state_0_MC_D2_PT_2_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_snoop_cur_state_0_MC_D2_PT_2_IN0
    );
  NlwInverterBlock_snoop_cur_state_0_MC_D2_PT_2_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_snoop_cur_state_0_MC_D2_PT_2_IN2
    );
  NlwInverterBlock_snoop_cur_state_1_MC_D1_PT_0_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_snoop_cur_state_1_MC_D1_PT_0_IN0
    );
  NlwInverterBlock_snoop_cur_state_1_MC_D1_PT_0_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_snoop_cur_state_1_MC_D1_PT_0_IN1
    );
  NlwInverterBlock_snoop_cur_state_1_MC_D2_PT_0_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_snoop_cur_state_1_MC_D2_PT_0_IN0
    );
  NlwInverterBlock_snoop_cur_state_1_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_snoop_cur_state_1_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_snoop_cur_state_1_MC_XOR_IN0 : X_INV
    port map (
      I => snoop_cur_state_1_MC_D1,
      O => NlwInverterSignal_snoop_cur_state_1_MC_XOR_IN0
    );
  NlwInverterBlock_snoop_cur_state_2_MC_D2_PT_0_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_0_IN0
    );
  NlwInverterBlock_snoop_cur_state_2_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_snoop_cur_state_2_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_snoop_cur_state_2_MC_D2_PT_1_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_1_IN2
    );
  NlwInverterBlock_snoop_cur_state_2_MC_D2_PT_2_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_2_IN1
    );
  NlwInverterBlock_snoop_cur_state_2_MC_D2_PT_2_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_2_IN2
    );
  NlwInverterBlock_snoop_cur_state_2_MC_D2_PT_3_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_3_IN0
    );
  NlwInverterBlock_snoop_cur_state_2_MC_D2_PT_3_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_snoop_cur_state_2_MC_D2_PT_3_IN2
    );
  NlwInverterBlock_snoop_cur_state_2_MC_XOR_IN0 : X_INV
    port map (
      I => snoop_cur_state_2_MC_D1,
      O => NlwInverterSignal_snoop_cur_state_2_MC_XOR_IN0
    );
  NlwInverterBlock_snoop_cur_state_3_MC_D2_PT_0_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_snoop_cur_state_3_MC_D2_PT_0_IN0
    );
  NlwInverterBlock_snoop_cur_state_3_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_snoop_cur_state_3_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_snoop_cur_state_3_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_snoop_cur_state_3_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_snoop_cur_state_3_MC_D2_PT_1_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_snoop_cur_state_3_MC_D2_PT_1_IN2
    );
  NlwInverterBlock_snoop_cur_state_3_MC_D2_PT_2_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_snoop_cur_state_3_MC_D2_PT_2_IN1
    );
  NlwInverterBlock_snoop_cur_state_3_MC_XOR_IN0 : X_INV
    port map (
      I => snoop_cur_state_3_MC_D1,
      O => NlwInverterSignal_snoop_cur_state_3_MC_XOR_IN0
    );
  NlwInverterBlock_statuses_1_MC_D1_PT_0_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_statuses_1_MC_D1_PT_0_IN0
    );
  NlwInverterBlock_statuses_1_MC_D1_PT_0_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_statuses_1_MC_D1_PT_0_IN1
    );
  NlwInverterBlock_statuses_1_MC_D1_PT_0_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_statuses_1_MC_D1_PT_0_IN2
    );
  NlwInverterBlock_statuses_1_MC_D1_PT_0_IN4 : X_INV
    port map (
      I => transmitter_rst_MC_UIM,
      O => NlwInverterSignal_statuses_1_MC_D1_PT_0_IN4
    );
  NlwInverterBlock_statuses_2_MC_D1_PT_0_IN0 : X_INV
    port map (
      I => slave_cur_state_ffd2,
      O => NlwInverterSignal_statuses_2_MC_D1_PT_0_IN0
    );
  NlwInverterBlock_statuses_2_MC_D1_PT_0_IN1 : X_INV
    port map (
      I => slave_cur_state_ffd4,
      O => NlwInverterSignal_statuses_2_MC_D1_PT_0_IN1
    );
  NlwInverterBlock_statuses_2_MC_D1_PT_0_IN2 : X_INV
    port map (
      I => slave_cur_state_ffd3,
      O => NlwInverterSignal_statuses_2_MC_D1_PT_0_IN2
    );
  NlwInverterBlock_statuses_2_MC_D1_PT_0_IN3 : X_INV
    port map (
      I => slave_cur_state_ffd1,
      O => NlwInverterSignal_statuses_2_MC_D1_PT_0_IN3
    );
  NlwInverterBlock_transmitter_sr_0_MC_D2_PT_0_IN0 : X_INV
    port map (
      I => checksum_0_II_UIM,
      O => NlwInverterSignal_transmitter_sr_0_MC_D2_PT_0_IN0
    );
  NlwInverterBlock_transmitter_sr_0_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => N_PZ_198,
      O => NlwInverterSignal_transmitter_sr_0_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_transmitter_sr_0_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => transmit_0_II_UIM,
      O => NlwInverterSignal_transmitter_sr_0_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_transmitter_sr_0_MC_XOR_IN0 : X_INV
    port map (
      I => transmitter_sr_0_MC_D1,
      O => NlwInverterSignal_transmitter_sr_0_MC_XOR_IN0
    );
  NlwInverterBlock_transmitter_sr_1_MC_D2_PT_0_IN0 : X_INV
    port map (
      I => checksum_1_II_UIM,
      O => NlwInverterSignal_transmitter_sr_1_MC_D2_PT_0_IN0
    );
  NlwInverterBlock_transmitter_sr_1_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => N_PZ_198,
      O => NlwInverterSignal_transmitter_sr_1_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_transmitter_sr_1_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => transmit_1_II_UIM,
      O => NlwInverterSignal_transmitter_sr_1_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_transmitter_sr_1_MC_XOR_IN0 : X_INV
    port map (
      I => transmitter_sr_1_MC_D1,
      O => NlwInverterSignal_transmitter_sr_1_MC_XOR_IN0
    );
  NlwInverterBlock_transmitter_sr_2_MC_D2_PT_0_IN0 : X_INV
    port map (
      I => checksum_2_II_UIM,
      O => NlwInverterSignal_transmitter_sr_2_MC_D2_PT_0_IN0
    );
  NlwInverterBlock_transmitter_sr_2_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => N_PZ_198,
      O => NlwInverterSignal_transmitter_sr_2_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_transmitter_sr_2_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => transmit_2_II_UIM,
      O => NlwInverterSignal_transmitter_sr_2_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_transmitter_sr_2_MC_XOR_IN0 : X_INV
    port map (
      I => transmitter_sr_2_MC_D1,
      O => NlwInverterSignal_transmitter_sr_2_MC_XOR_IN0
    );
  NlwInverterBlock_transmitter_sr_3_MC_D2_PT_0_IN0 : X_INV
    port map (
      I => checksum_3_II_UIM,
      O => NlwInverterSignal_transmitter_sr_3_MC_D2_PT_0_IN0
    );
  NlwInverterBlock_transmitter_sr_3_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => N_PZ_198,
      O => NlwInverterSignal_transmitter_sr_3_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_transmitter_sr_3_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => transmit_3_II_UIM,
      O => NlwInverterSignal_transmitter_sr_3_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_transmitter_sr_3_MC_XOR_IN0 : X_INV
    port map (
      I => transmitter_sr_3_MC_D1,
      O => NlwInverterSignal_transmitter_sr_3_MC_XOR_IN0
    );
  NlwInverterBlock_transmitter_sr_4_MC_D2_PT_0_IN0 : X_INV
    port map (
      I => checksum_4_II_UIM,
      O => NlwInverterSignal_transmitter_sr_4_MC_D2_PT_0_IN0
    );
  NlwInverterBlock_transmitter_sr_4_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => N_PZ_198,
      O => NlwInverterSignal_transmitter_sr_4_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_transmitter_sr_4_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => transmit_4_II_UIM,
      O => NlwInverterSignal_transmitter_sr_4_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_transmitter_sr_4_MC_XOR_IN0 : X_INV
    port map (
      I => transmitter_sr_4_MC_D1,
      O => NlwInverterSignal_transmitter_sr_4_MC_XOR_IN0
    );
  NlwInverterBlock_transmitter_sr_5_MC_D2_PT_0_IN0 : X_INV
    port map (
      I => checksum_5_II_UIM,
      O => NlwInverterSignal_transmitter_sr_5_MC_D2_PT_0_IN0
    );
  NlwInverterBlock_transmitter_sr_5_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => N_PZ_198,
      O => NlwInverterSignal_transmitter_sr_5_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_transmitter_sr_5_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => transmit_5_II_UIM,
      O => NlwInverterSignal_transmitter_sr_5_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_transmitter_sr_5_MC_XOR_IN0 : X_INV
    port map (
      I => transmitter_sr_5_MC_D1,
      O => NlwInverterSignal_transmitter_sr_5_MC_XOR_IN0
    );
  NlwInverterBlock_transmitter_sr_6_MC_D2_PT_0_IN0 : X_INV
    port map (
      I => checksum_6_II_UIM,
      O => NlwInverterSignal_transmitter_sr_6_MC_D2_PT_0_IN0
    );
  NlwInverterBlock_transmitter_sr_6_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => N_PZ_198,
      O => NlwInverterSignal_transmitter_sr_6_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_transmitter_sr_6_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => transmit_6_II_UIM,
      O => NlwInverterSignal_transmitter_sr_6_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_transmitter_sr_6_MC_XOR_IN0 : X_INV
    port map (
      I => transmitter_sr_6_MC_D1,
      O => NlwInverterSignal_transmitter_sr_6_MC_XOR_IN0
    );
  NlwInverterBlock_transmitter_sr_7_MC_D2_PT_0_IN0 : X_INV
    port map (
      I => checksum_7_II_UIM,
      O => NlwInverterSignal_transmitter_sr_7_MC_D2_PT_0_IN0
    );
  NlwInverterBlock_transmitter_sr_7_MC_D2_PT_1_IN0 : X_INV
    port map (
      I => N_PZ_198,
      O => NlwInverterSignal_transmitter_sr_7_MC_D2_PT_1_IN0
    );
  NlwInverterBlock_transmitter_sr_7_MC_D2_PT_1_IN1 : X_INV
    port map (
      I => transmit_7_II_UIM,
      O => NlwInverterSignal_transmitter_sr_7_MC_D2_PT_1_IN1
    );
  NlwInverterBlock_transmitter_sr_7_MC_XOR_IN0 : X_INV
    port map (
      I => transmitter_sr_7_MC_D1,
      O => NlwInverterSignal_transmitter_sr_7_MC_XOR_IN0
    );
  NlwBlockROC : ROC generic map ( WIDTH => 100 ns)
     port map (O => PRLD);
end Structure;

